/*----- PROTECTED REGION ID(Pbmpaxis.cpp) ENABLED START -----*/
//=============================================================================
//
// file :        Pbmpaxis.cpp
//
// description : C++ source for the Pbmpaxis class and its commands.
//               The class is derived from Device. It represents the
//               CORBA servant object which will be accessed from the
//               network. All commands which can be executed on the
//               Pbmpaxis are implemented in this file.
//
// project :     Photon beam monitor position
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <tango.h>
#include <Pbmpaxis.h>
#include <PbmpaxisClass.h>

/*----- PROTECTED REGION END -----*/	//	Pbmpaxis.cpp

/**
 *  Pbmpaxis class description:
 *    Photon beam monitor position axis mover. Works on galilaxis.
 */

//================================================================
//  The following table gives the correspondence
//  between command and method names.
//
//  Command name             |  Method name
//================================================================
//  State                    |  Inherited (no method)
//  Status                   |  Inherited (no method)
//  AxisGetMotionStatusU     |  axis_get_motion_status_u
//  AxisGetMotionStatusD     |  axis_get_motion_status_d
//  AxisGetMotionStatusL     |  axis_get_motion_status_l
//  AxisGetMotionStatusR     |  axis_get_motion_status_r
//  AxisInitU                |  axis_init_u
//  AxisInitD                |  axis_init_d
//  AxisInitL                |  axis_init_l
//  AxisInitR                |  axis_init_r
//  AxisStopU                |  axis_stop_u
//  AxisStopD                |  axis_stop_d
//  AxisStopL                |  axis_stop_l
//  AxisStopR                |  axis_stop_r
//  MotorONU                 |  motor_onu
//  MotorOND                 |  motor_ond
//  MotorONL                 |  motor_onl
//  MotorONR                 |  motor_onr
//  MotorOFFU                |  motor_offu
//  MotorOFFD                |  motor_offd
//  MotorOFFL                |  motor_offl
//  MotorOFFR                |  motor_offr
//  PbmpAxisDefineOffsetU    |  pbmp_axis_define_offset_u
//  PbmpAxisDefineOffsetD    |  pbmp_axis_define_offset_d
//  PbmpAxisDefineOffsetL    |  pbmp_axis_define_offset_l
//  PbmpAxisDefineOffsetR    |  pbmp_axis_define_offset_r
//  PbmpDefineZeroU          |  pbmp_define_zero_u
//  PbmpDefineZeroD          |  pbmp_define_zero_d
//  PbmpDefineZeroL          |  pbmp_define_zero_l
//  PbmpDefineZeroR          |  pbmp_define_zero_r
//  PbmpCenterVGoToPosition  |  pbmp_center_vgo_to_position
//  PbmpCenterHGoToPosition  |  pbmp_center_hgo_to_position
//  PbmpGapV                 |  pbmp_gap_v
//  PbmpGapH                 |  pbmp_gap_h
//  PbmpAxisStop             |  pbmp_axis_stop
//================================================================

//================================================================
//  Attributes managed are:
//================================================================
//  AxisCurrentPositionU      |  Tango::DevDouble	Scalar
//  AxisCurrentPositionD      |  Tango::DevDouble	Scalar
//  AxisCurrentPositionL      |  Tango::DevDouble	Scalar
//  AxisCurrentPositionR      |  Tango::DevDouble	Scalar
//  IsInitialisedU            |  Tango::DevShort	Scalar
//  IsInitialisedD            |  Tango::DevShort	Scalar
//  IsInitialisedL            |  Tango::DevShort	Scalar
//  IsInitialisedR            |  Tango::DevShort	Scalar
//  PbmpAxisCurrentPositionU  |  Tango::DevDouble	Scalar
//  PbmpAxisCurrentPositionD  |  Tango::DevDouble	Scalar
//  PbmpAxisCurrentPositionL  |  Tango::DevDouble	Scalar
//  PbmpAxisCurrentPositionR  |  Tango::DevDouble	Scalar
//  PbmpCenterV               |  Tango::DevDouble	Scalar
//  PbmpCenterH               |  Tango::DevDouble	Scalar
//  GapV                      |  Tango::DevDouble	Scalar
//  GapH                      |  Tango::DevDouble	Scalar
//  PbmpAxisOffsetU           |  Tango::DevDouble	Scalar
//  PbmpAxisOffsetD           |  Tango::DevDouble	Scalar
//  PbmpAxisOffsetL           |  Tango::DevDouble	Scalar
//  PbmpAxisOffsetR           |  Tango::DevDouble	Scalar
//  PbmpAxisIsInitialised     |  Tango::DevShort	Scalar
//  History                   |  Tango::DevString	Spectrum  ( max = 2000)
//================================================================

namespace Pbmpaxis_ns
{
/*----- PROTECTED REGION ID(Pbmpaxis::namespace_starting) ENABLED START -----*/

//	static initializations

/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::namespace_starting

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::Pbmpaxis()
 *	Description : Constructors for a Tango device
 *                implementing the classPbmpaxis
 */
//--------------------------------------------------------
Pbmpaxis::Pbmpaxis(Tango::DeviceClass *cl, string &s)
 : TANGO_BASE_CLASS(cl, s.c_str())
{
	/*----- PROTECTED REGION ID(Pbmpaxis::constructor_1) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::constructor_1
}
//--------------------------------------------------------
Pbmpaxis::Pbmpaxis(Tango::DeviceClass *cl, const char *s)
 : TANGO_BASE_CLASS(cl, s)
{
	/*----- PROTECTED REGION ID(Pbmpaxis::constructor_2) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::constructor_2
}
//--------------------------------------------------------
Pbmpaxis::Pbmpaxis(Tango::DeviceClass *cl, const char *s, const char *d)
 : TANGO_BASE_CLASS(cl, s, d)
{
	/*----- PROTECTED REGION ID(Pbmpaxis::constructor_3) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::constructor_3
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::delete_device()
 *	Description : will be called at device destruction or at init command
 */
//--------------------------------------------------------
void Pbmpaxis::delete_device()
{
	DEBUG_STREAM << "Pbmpaxis::delete_device() " << device_name << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::delete_device) ENABLED START -----*/

	for (int i=0; i<2000; i++){
	        if (attr_History_read[i] != NULL){
	                #ifdef _DBG_HISTORY
	                        cout << "Going to delete attr_History_read[" << i << "]" << endl;
	                #endif
	                delete[] attr_History_read[i];
	                attr_History_read[i] = NULL;
	        }
	}

	if (hist) {
	        delete hist;
	        hist = NULL;
	}

	
	//	Delete device allocated objects
	if(attr_AxisCurrentPositionU_read)
	{
		delete attr_AxisCurrentPositionU_read;
		attr_AxisCurrentPositionU_read = 0;
	}
	if(attr_AxisCurrentPositionD_read)
	{
		delete attr_AxisCurrentPositionD_read;
		attr_AxisCurrentPositionD_read = 0;
	}
	if(attr_AxisCurrentPositionL_read)
	{
		delete attr_AxisCurrentPositionL_read;
		attr_AxisCurrentPositionL_read = 0;
	}
	if(attr_AxisCurrentPositionR_read)
	{
		delete attr_AxisCurrentPositionR_read;
		attr_AxisCurrentPositionR_read = 0;
	}

	if(attr_IsInitialisedU_read)
	{
		delete attr_IsInitialisedU_read;
		attr_IsInitialisedU_read = 0;
	}
	if(attr_IsInitialisedD_read)
	{
		delete attr_IsInitialisedD_read;
		attr_IsInitialisedD_read = 0;
	}
	if(attr_IsInitialisedL_read)
	{
		delete attr_IsInitialisedL_read;
		attr_IsInitialisedL_read = 0;
	}
	if(attr_IsInitialisedR_read)
	{
		delete attr_IsInitialisedR_read;
		attr_IsInitialisedR_read = 0;
	}

	if(attr_PbmpAxisCurrentPositionU_read)
	{
		delete attr_PbmpAxisCurrentPositionU_read;
		attr_PbmpAxisCurrentPositionU_read = 0;
	}
	if(attr_PbmpAxisCurrentPositionD_read)
	{
		delete attr_PbmpAxisCurrentPositionD_read;
		attr_PbmpAxisCurrentPositionD_read = 0;
	}
	if(attr_PbmpAxisCurrentPositionL_read)
	{
		delete attr_PbmpAxisCurrentPositionL_read;
		attr_PbmpAxisCurrentPositionL_read = 0;
	}
	if(attr_PbmpAxisCurrentPositionR_read)
	{
		delete attr_PbmpAxisCurrentPositionR_read;
		attr_PbmpAxisCurrentPositionR_read = 0;
	}

	if(attr_PbmpCenterV_read)
	{
		delete attr_PbmpCenterV_read;
		attr_PbmpCenterV_read = 0;
	}
	if(attr_PbmpCenterH_read)
	{
		delete attr_PbmpCenterH_read;
		attr_PbmpCenterH_read = 0;
	}

	if(attr_GapV_read)
	{
		delete attr_GapV_read;
		attr_GapV_read = 0;
	}
	if(attr_GapH_read)
	{
		delete attr_GapH_read;
		attr_GapH_read = 0;
	}

	if(attr_PbmpAxisOffsetU_read)
	{
		delete attr_PbmpAxisOffsetU_read;
		attr_PbmpAxisOffsetU_read = 0;
	}
	if(attr_PbmpAxisOffsetD_read)
	{
		delete attr_PbmpAxisOffsetD_read;
		attr_PbmpAxisOffsetD_read = 0;
	}
	if(attr_PbmpAxisOffsetL_read)
	{
		delete attr_PbmpAxisOffsetL_read;
		attr_PbmpAxisOffsetL_read = 0;
	}
	if(attr_PbmpAxisOffsetR_read)
	{
		delete attr_PbmpAxisOffsetR_read;
		attr_PbmpAxisOffsetR_read = 0;
	}

	if(attr_PbmpAxisIsInitialised_read)
	{
		delete attr_PbmpAxisIsInitialised_read;
		attr_PbmpAxisIsInitialised_read = 0;
	}

	if(axisU_proxy)
	{
		delete axisU_proxy;
		axisU_proxy = 0;
	}
	if(axisD_proxy)
	{
		delete axisD_proxy;
		axisD_proxy = 0;
	}
	if(axisL_proxy)
	{
		delete axisL_proxy;
		axisL_proxy = 0;
	}
	if(axisR_proxy)
	{
		delete axisR_proxy;
		axisR_proxy = 0;
	}

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::delete_device
	delete[] attr_History_read;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::init_device()
 *	Description : will be called at device initialization.
 */
//--------------------------------------------------------
void Pbmpaxis::init_device()
{
	DEBUG_STREAM << "Pbmpaxis::init_device() create device " << device_name << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::init_device_before) ENABLED START -----*/
	
	//	Initialization before get_device_property() call
	GAP_H_MIN_VAL = 0.1;
	GAP_V_MIN_VAL = 0.1;



	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::init_device_before
	

	//	Get the device properties from database
	get_device_property();
	
	attr_History_read = new Tango::DevString[2000];
	//	No longer if mandatory property not set. 
	if (mandatoryNotDefined)
		return;

	/*----- PROTECTED REGION ID(Pbmpaxis::init_device) ENABLED START -----*/
	
	//	Initialize device

	hist = new History_ns::history(this);
	hist->set_max_sample(2000);

	for (int i=0; i<2000; i++){
	        attr_History_read[i] = new char[2];
	        sprintf(attr_History_read[i], "-");
	        #ifdef _DBG_HISTORY
	                cout << "attr_History_read[" << i << "]=" << attr_History_read[i] << "|" << endl;
	        #endif /* _DBG_HISTORY*/
	}


	attr_AxisCurrentPositionU_read = 0;
	attr_AxisCurrentPositionU_read = new Tango::DevDouble();
	*attr_AxisCurrentPositionU_read = 0.0;
	attr_AxisCurrentPositionD_read = 0;
	attr_AxisCurrentPositionD_read = new Tango::DevDouble();
	*attr_AxisCurrentPositionD_read = 0.0;
	attr_AxisCurrentPositionL_read = 0;
	attr_AxisCurrentPositionL_read = new Tango::DevDouble();
	*attr_AxisCurrentPositionL_read = 0.0;
	attr_AxisCurrentPositionR_read = 0;
	attr_AxisCurrentPositionR_read = new Tango::DevDouble();
	*attr_AxisCurrentPositionR_read = 0.0;

	attr_IsInitialisedU_read = 0;
	attr_IsInitialisedU_read = new Tango::DevShort();
	*attr_IsInitialisedU_read = 0;
	attr_IsInitialisedD_read = 0;
	attr_IsInitialisedD_read = new Tango::DevShort();
	*attr_IsInitialisedD_read = 0;
	attr_IsInitialisedL_read = 0;
	attr_IsInitialisedL_read = new Tango::DevShort();
	*attr_IsInitialisedL_read = 0;
	attr_IsInitialisedR_read = 0;
	attr_IsInitialisedR_read = new Tango::DevShort();
	*attr_IsInitialisedR_read = 0;

	attr_PbmpAxisCurrentPositionU_read = 0;
	attr_PbmpAxisCurrentPositionU_read = new Tango::DevDouble();
	*attr_PbmpAxisCurrentPositionU_read = 0.0;
	attr_PbmpAxisCurrentPositionD_read = 0;
	attr_PbmpAxisCurrentPositionD_read = new Tango::DevDouble();
	*attr_PbmpAxisCurrentPositionD_read = 0.0;
	attr_PbmpAxisCurrentPositionL_read = 0;
	attr_PbmpAxisCurrentPositionL_read = new Tango::DevDouble();
	*attr_PbmpAxisCurrentPositionL_read = 0.0;
	attr_PbmpAxisCurrentPositionR_read = 0;
	attr_PbmpAxisCurrentPositionR_read = new Tango::DevDouble();
	*attr_PbmpAxisCurrentPositionR_read = 0.0;

	attr_PbmpCenterV_read = 0;
	attr_PbmpCenterV_read = new Tango::DevDouble();
	*attr_PbmpCenterV_read = 0.0;
	attr_PbmpCenterH_read = 0;
	attr_PbmpCenterH_read = new Tango::DevDouble();
	*attr_PbmpCenterH_read = 0.0;

	attr_GapV_read = 0;
	attr_GapV_read = new Tango::DevDouble();
	*attr_GapV_read = 0.0;
	attr_GapH_read = 0;
	attr_GapH_read = new Tango::DevDouble();
	*attr_GapH_read = 0.0;

	attr_PbmpAxisOffsetU_read = 0;
	attr_PbmpAxisOffsetU_read = new Tango::DevDouble();
	*attr_PbmpAxisOffsetU_read = 0.0;
	attr_PbmpAxisOffsetD_read = 0;
	attr_PbmpAxisOffsetD_read = new Tango::DevDouble();
	*attr_PbmpAxisOffsetD_read = 0.0;
	attr_PbmpAxisOffsetL_read = 0;
	attr_PbmpAxisOffsetL_read = new Tango::DevDouble();
	*attr_PbmpAxisOffsetL_read = 0.0;
	attr_PbmpAxisOffsetR_read = 0;
	attr_PbmpAxisOffsetR_read = new Tango::DevDouble();
	*attr_PbmpAxisOffsetR_read = 0.0;

	attr_PbmpAxisIsInitialised_read = 0;
	attr_PbmpAxisIsInitialised_read = new Tango::DevShort();
	*attr_PbmpAxisIsInitialised_read = 0;

	try
	{
		axisU_proxy = 0;
		axisU_proxy = new Tango::DeviceProxy(axisU);
		axisU_proxy->set_timeout_millis(timeout);
		INFO_STREAM << "Pbmpaxis::Pbmpaxis(): axis U proxy connected..." << endl;
    }
    catch(Tango::DevFailed &e)
    {
    	print_error_msg("cannot connect axis U proxy", "cannot connect axis U proxy" ,"Pbmpaxis::Pbmpaxis()", Tango::FAULT);
    }

    try
    {
    	axisD_proxy = 0;
		axisD_proxy = new Tango::DeviceProxy(axisD);
		axisD_proxy->set_timeout_millis(timeout);
		INFO_STREAM << "Pbmpaxis::Pbmpaxis(): axis D proxy connected..." << endl;
    }
    catch(Tango::DevFailed &e)
    {
    	print_error_msg("cannot connect axis D proxy", "cannot connect axis D proxy" ,"Pbmpaxis::Pbmpaxis()", Tango::FAULT);
    }

    try
    {
    	axisL_proxy = 0;
		axisL_proxy = new Tango::DeviceProxy(axisL);
		axisL_proxy->set_timeout_millis(timeout);
		INFO_STREAM << "Pbmpaxis::Pbmpaxis(): axis L proxy connected..." << endl;
    }
    catch(Tango::DevFailed &e)
    {
    	print_error_msg("cannot connect axis L proxy", "cannot connect axis L proxy" ,"Pbmpaxis::Pbmpaxis()", Tango::FAULT);
    }

    try
    {
    	axisR_proxy = 0;
		axisR_proxy = new Tango::DeviceProxy(axisR);
		axisR_proxy->set_timeout_millis(timeout);
		INFO_STREAM << "Pbmpaxis::Pbmpaxis(): axis R proxy connected..." << endl;
    }
    catch(Tango::DevFailed &e)
    {
    	print_error_msg("cannot connect axis R proxy", "cannot connect axis R proxy" ,"Pbmpaxis::Pbmpaxis()", Tango::FAULT);
    }

    DEBUG_STREAM << "AxisU m:" << axisU_m << " q: " << axisU_q << endl;
	DEBUG_STREAM << "AxisD m:" << axisD_m << " q: " << axisD_q << endl;
	DEBUG_STREAM << "AxisL m:" << axisL_m << " q: " << axisL_q << endl;
	DEBUG_STREAM << "AxisR m:" << axisR_m << " q: " << axisR_q << endl;

	std::stringstream ss;
	ss << __func__ << "(done)";
	hist->push_end(ss.str());

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::init_device
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::get_device_property()
 *	Description : Read database to initialize property data members.
 */
//--------------------------------------------------------
void Pbmpaxis::get_device_property()
{
	/*----- PROTECTED REGION ID(Pbmpaxis::get_device_property_before) ENABLED START -----*/
	
	//	Initialize property data members
	

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::get_device_property_before

	mandatoryNotDefined = false;

	//	Read device properties from database.
	Tango::DbData	dev_prop;
	dev_prop.push_back(Tango::DbDatum("AxisU"));
	dev_prop.push_back(Tango::DbDatum("AxisD"));
	dev_prop.push_back(Tango::DbDatum("AxisL"));
	dev_prop.push_back(Tango::DbDatum("AxisR"));
	dev_prop.push_back(Tango::DbDatum("TrasfAxisU"));
	dev_prop.push_back(Tango::DbDatum("TrasfAxisD"));
	dev_prop.push_back(Tango::DbDatum("TrasfAxisL"));
	dev_prop.push_back(Tango::DbDatum("TrasfAxisR"));
	dev_prop.push_back(Tango::DbDatum("Timeout"));

	//	is there at least one property to be read ?
	if (dev_prop.size()>0)
	{
		//	Call database and extract values
		if (Tango::Util::instance()->_UseDb==true)
			get_db_device()->get_property(dev_prop);
	
		//	get instance on PbmpaxisClass to get class property
		Tango::DbDatum	def_prop, cl_prop;
		PbmpaxisClass	*ds_class =
			(static_cast<PbmpaxisClass *>(get_device_class()));
		int	i = -1;

		//	Try to initialize AxisU from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  axisU;
		else {
			//	Try to initialize AxisU from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  axisU;
		}
		//	And try to extract AxisU value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  axisU;
		//	Property StartDsPath is mandatory, check if has been defined in database.
		check_mandatory_property(cl_prop, dev_prop[i]);

		//	Try to initialize AxisD from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  axisD;
		else {
			//	Try to initialize AxisD from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  axisD;
		}
		//	And try to extract AxisD value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  axisD;
		//	Property StartDsPath is mandatory, check if has been defined in database.
		check_mandatory_property(cl_prop, dev_prop[i]);

		//	Try to initialize AxisL from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  axisL;
		else {
			//	Try to initialize AxisL from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  axisL;
		}
		//	And try to extract AxisL value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  axisL;
		//	Property StartDsPath is mandatory, check if has been defined in database.
		check_mandatory_property(cl_prop, dev_prop[i]);

		//	Try to initialize AxisR from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  axisR;
		else {
			//	Try to initialize AxisR from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  axisR;
		}
		//	And try to extract AxisR value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  axisR;
		//	Property StartDsPath is mandatory, check if has been defined in database.
		check_mandatory_property(cl_prop, dev_prop[i]);

		//	Try to initialize TrasfAxisU from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  trasfAxisU;
		else {
			//	Try to initialize TrasfAxisU from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  trasfAxisU;
		}
		//	And try to extract TrasfAxisU value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  trasfAxisU;

		//	Try to initialize TrasfAxisD from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  trasfAxisD;
		else {
			//	Try to initialize TrasfAxisD from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  trasfAxisD;
		}
		//	And try to extract TrasfAxisD value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  trasfAxisD;

		//	Try to initialize TrasfAxisL from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  trasfAxisL;
		else {
			//	Try to initialize TrasfAxisL from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  trasfAxisL;
		}
		//	And try to extract TrasfAxisL value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  trasfAxisL;

		//	Try to initialize TrasfAxisR from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  trasfAxisR;
		else {
			//	Try to initialize TrasfAxisR from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  trasfAxisR;
		}
		//	And try to extract TrasfAxisR value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  trasfAxisR;

		//	Try to initialize Timeout from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  timeout;
		else {
			//	Try to initialize Timeout from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  timeout;
		}
		//	And try to extract Timeout value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  timeout;

	}

	/*----- PROTECTED REGION ID(Pbmpaxis::get_device_property_after) ENABLED START -----*/
	
	//	Check device property data members init
	if (!trasfAxisU.size()) {
		axisU_m = trasfAxisU[0];
		if(axisU_m==0) {
			WARN_STREAM << "TrasfAxisU cannot be 0, default = 1" << endl;
			axisU_m=1;
		}
		axisU_q = trasfAxisU[1];
	} else {
		axisU_m=1;
		axisU_q=0;
	}

	if (!trasfAxisD.size()) {
		axisD_m = trasfAxisD[0];
		if(axisD_m==0) {
			WARN_STREAM << "TrasfAxisD cannot be 0, default = 1" << endl;
			axisD_m=1;
		}
		axisD_q = trasfAxisD[1];
	} else {
		axisD_m=1;
		axisD_q=0;
	}

	if (!trasfAxisL.size()) {
		axisL_m = trasfAxisL[0];
		if(axisL_m==0) {
			WARN_STREAM << "TrasfAxisL cannot be 0, default = 1" << endl;
			axisL_m=1;
		}
		axisL_q = trasfAxisL[1];
	} else {
		axisL_m=1;
		axisL_q=0;
	}

	if (!trasfAxisR.size()) {
		axisR_m = trasfAxisR[0];
		if(axisR_m==0) {
			WARN_STREAM << "TrasfAxisR cannot be 0, default = 1" << endl;
			axisR_m=1;
		}
		axisR_q = trasfAxisR[1];
	} else {
		axisR_m=1;
		axisR_q=0;
	}
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::get_device_property_after
}
//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::check_mandatory_property()
 *	Description : For mandatory properties check if defined in database.
 */
//--------------------------------------------------------
void Pbmpaxis::check_mandatory_property(Tango::DbDatum &class_prop, Tango::DbDatum &dev_prop)
{
	//	Check if all properties are empty
	if (class_prop.is_empty() && dev_prop.is_empty())
	{
		TangoSys_OMemStream	tms;
		tms << endl <<"Property \'" << dev_prop.name;
		if (Tango::Util::instance()->_UseDb==true)
			tms << "\' is mandatory but not defined in database";
		else
			tms << "\' is mandatory but cannot be defined without database";
		append_status(tms.str());
		mandatoryNotDefined = true;
		/*----- PROTECTED REGION ID(Pbmpaxis::check_mandatory_property) ENABLED START -----*/
		cerr << tms.str() << " for " << device_name << endl;
		
		/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::check_mandatory_property
	}
}


//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::always_executed_hook()
 *	Description : method always executed before any command is executed
 */
//--------------------------------------------------------
void Pbmpaxis::always_executed_hook()
{
	DEBUG_STREAM << "Pbmpaxis::always_executed_hook()  " << device_name << endl;
	if (mandatoryNotDefined)
	{
		Tango::Except::throw_exception(
					(const char *)"PROPERTY_NOT_SET",
					get_status().c_str(),
					(const char *)"Pbmpaxis::always_executed_hook()");
	}
	/*----- PROTECTED REGION ID(Pbmpaxis::always_executed_hook) ENABLED START -----*/
	
	//	code always executed before all requests
	#ifdef _MDM
	Tango::DevState pbmp_state = Tango::STANDBY;
	stringstream pbmp_status;

	try
	{
		axisU_state = axisU_proxy->state();
		axisU_status = axisU_proxy->status();
	}
	catch(Tango::DevFailed &e)
	{
		axisU_state = Tango::FAULT;
	}

	try
	{
		axisD_state = axisD_proxy->state();
		axisD_status = axisD_proxy->status();
	}
	catch(Tango::DevFailed &e)
	{
		axisD_state = Tango::FAULT;
	}

	try
	{
		axisL_state = axisL_proxy->state();
		axisL_status = axisL_proxy->status();
	}
	catch(Tango::DevFailed &e)
	{
		axisL_state = Tango::FAULT;
	}

	try
	{
		axisR_state = axisR_proxy->state();
		axisR_status = axisR_proxy->status();
	}
	catch(Tango::DevFailed &e)
	{
		axisR_state = Tango::FAULT;
	}

	if(axisU_state == Tango::MOVING ||
		axisD_state == Tango::MOVING ||
		axisL_state == Tango::MOVING ||
		axisR_state == Tango::MOVING )
	{
		pbmp_state = Tango::MOVING;
	}

	if(axisU_state == Tango::ALARM ||
		axisD_state == Tango::ALARM ||
		axisL_state == Tango::ALARM ||
		axisR_state == Tango::ALARM )
	{
		pbmp_state = Tango::ALARM;
	}

	if(axisU_state == Tango::FAULT ||
		axisD_state == Tango::FAULT ||
		axisL_state == Tango::FAULT ||
		axisR_state == Tango::FAULT )
	{
		pbmp_state = Tango::FAULT;
	}

	pbmp_status.str("");
	pbmp_status << "Axis U: " << axisU_status << endl;
	set_status(pbmp_status.str());

	pbmp_status.str("");
	pbmp_status << "Axis D: " << axisD_status << endl;
	append_status(pbmp_status.str(), true);

	pbmp_status.str("");
	pbmp_status << "Axis L: " << axisL_status << endl;
	append_status(pbmp_status.str(), true);

	pbmp_status.str("");
	pbmp_status << "Axis R: " << axisR_status << endl;
	append_status(pbmp_status.str(), true);

	set_state(pbmp_state);
#endif

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::always_executed_hook
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::read_attr_hardware()
 *	Description : Hardware acquisition for attributes
 */
//--------------------------------------------------------
void Pbmpaxis::read_attr_hardware(TANGO_UNUSED(vector<long> &attr_list))
{
	DEBUG_STREAM << "Pbmpaxis::read_attr_hardware(vector<long> &attr_list) entering... " << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::read_attr_hardware) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::read_attr_hardware
}
//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::write_attr_hardware()
 *	Description : Hardware writing for attributes
 */
//--------------------------------------------------------
void Pbmpaxis::write_attr_hardware(TANGO_UNUSED(vector<long> &attr_list))
{
	DEBUG_STREAM << "Pbmpaxis::write_attr_hardware(vector<long> &attr_list) entering... " << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::write_attr_hardware) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::write_attr_hardware
}

//--------------------------------------------------------
/**
 *	Read attribute AxisCurrentPositionU related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pbmpaxis::read_AxisCurrentPositionU(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Pbmpaxis::read_AxisCurrentPositionU(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::read_AxisCurrentPositionU) ENABLED START -----*/
	try
	{
		Tango::DeviceAttribute dev_attr = axisU_proxy->read_attribute("Position");
		dev_attr >> *attr_AxisCurrentPositionU_read;
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::read_AxisCurrentPositionU()");
	}

	DEBUG_STREAM << "Position U: " << *attr_AxisCurrentPositionU_read << endl;

	*attr_AxisCurrentPositionU_read = *attr_AxisCurrentPositionU_read * axisU_m + axisU_q;
	attr.set_value(attr_AxisCurrentPositionU_read);

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::read_AxisCurrentPositionU
}
//--------------------------------------------------------
/**
 *	Write attribute AxisCurrentPositionU related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pbmpaxis::write_AxisCurrentPositionU(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Pbmpaxis::write_AxisCurrentPositionU(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Pbmpaxis::write_AxisCurrentPositionU) ENABLED START -----*/
	// the variable w_val will not be used !

	std::stringstream ss;
	ss << __func__ << "(" << w_val << ")";
	hist->push_end(ss.str());

	w_val = (w_val - axisU_q) / axisU_m;

	DEBUG_STREAM << "Position U: " << w_val << endl;

	Tango::DeviceAttribute dev_attr;
	dev_attr << w_val;
	dev_attr.set_name("Position");

	try
	{
		axisU_proxy->write_attribute(dev_attr);
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::write_AxisCurrentPositionU()");
	}

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::write_AxisCurrentPositionU
}
//--------------------------------------------------------
/**
 *	Read attribute AxisCurrentPositionD related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pbmpaxis::read_AxisCurrentPositionD(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Pbmpaxis::read_AxisCurrentPositionD(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::read_AxisCurrentPositionD) ENABLED START -----*/
	try
	{
		Tango::DeviceAttribute dev_attr = axisD_proxy->read_attribute("Position");
		dev_attr >> *attr_AxisCurrentPositionD_read;
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::read_AxisCurrentPositionD()");
	}

	DEBUG_STREAM << "Position D: " << *attr_AxisCurrentPositionD_read << endl;

	*attr_AxisCurrentPositionD_read = *attr_AxisCurrentPositionD_read * axisD_m + axisD_q;
	attr.set_value(attr_AxisCurrentPositionD_read);

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::read_AxisCurrentPositionD
}
//--------------------------------------------------------
/**
 *	Write attribute AxisCurrentPositionD related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pbmpaxis::write_AxisCurrentPositionD(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Pbmpaxis::write_AxisCurrentPositionD(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Pbmpaxis::write_AxisCurrentPositionD) ENABLED START -----*/
	// the variable w_val will not be used !

	std::stringstream ss;
	ss << __func__ << "(" << w_val << ")";
	hist->push_end(ss.str());

	w_val = (w_val - axisD_q) / axisD_m;

	DEBUG_STREAM << "Position D: " << w_val << endl;

	Tango::DeviceAttribute dev_attr;
	dev_attr << w_val;
	dev_attr.set_name("Position");

	try
	{
		axisD_proxy->write_attribute(dev_attr);
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::write_AxisCurrentPositionD()");
	}

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::write_AxisCurrentPositionD
}
//--------------------------------------------------------
/**
 *	Read attribute AxisCurrentPositionL related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pbmpaxis::read_AxisCurrentPositionL(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Pbmpaxis::read_AxisCurrentPositionL(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::read_AxisCurrentPositionL) ENABLED START -----*/
	try
	{
		Tango::DeviceAttribute dev_attr = axisL_proxy->read_attribute("Position");
		dev_attr >> *attr_AxisCurrentPositionL_read;
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::read_AxisCurrentPositionL()");
	}

	DEBUG_STREAM << "Position L: " << *attr_AxisCurrentPositionL_read << endl;

	*attr_AxisCurrentPositionL_read = *attr_AxisCurrentPositionL_read * axisL_m + axisL_q;
	attr.set_value(attr_AxisCurrentPositionL_read);

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::read_AxisCurrentPositionL
}
//--------------------------------------------------------
/**
 *	Write attribute AxisCurrentPositionL related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pbmpaxis::write_AxisCurrentPositionL(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Pbmpaxis::write_AxisCurrentPositionL(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Pbmpaxis::write_AxisCurrentPositionL) ENABLED START -----*/
	// the variable w_val will not be used !

	std::stringstream ss;
	ss << __func__ << "(" << w_val << ")";
	hist->push_end(ss.str());

	w_val = (w_val - axisL_q) / axisL_m;

	DEBUG_STREAM << "Position L: " << w_val << endl;

	Tango::DeviceAttribute dev_attr;
	dev_attr << w_val;
	dev_attr.set_name("Position");

	try
	{
		axisL_proxy->write_attribute(dev_attr);
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::write_AxisCurrentPositionL()");
	}

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::write_AxisCurrentPositionL
}
//--------------------------------------------------------
/**
 *	Read attribute AxisCurrentPositionR related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pbmpaxis::read_AxisCurrentPositionR(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Pbmpaxis::read_AxisCurrentPositionR(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::read_AxisCurrentPositionR) ENABLED START -----*/
	try
	{
		Tango::DeviceAttribute dev_attr = axisR_proxy->read_attribute("Position");
		dev_attr >> *attr_AxisCurrentPositionR_read;
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::read_AxisCurrentPositionR()");
	}

	DEBUG_STREAM << "Position R: " << *attr_AxisCurrentPositionR_read << endl;

	*attr_AxisCurrentPositionR_read = *attr_AxisCurrentPositionR_read * axisR_m + axisR_q;
	attr.set_value(attr_AxisCurrentPositionR_read);

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::read_AxisCurrentPositionR
}
//--------------------------------------------------------
/**
 *	Write attribute AxisCurrentPositionR related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pbmpaxis::write_AxisCurrentPositionR(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Pbmpaxis::write_AxisCurrentPositionR(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Pbmpaxis::write_AxisCurrentPositionR) ENABLED START -----*/
	// the variable w_val will not be used !

	std::stringstream ss;
	ss << __func__ << "(" << w_val << ")";
	hist->push_end(ss.str());

	w_val = (w_val - axisR_q) / axisR_m;

	DEBUG_STREAM << "Position R: " << w_val << endl;

	Tango::DeviceAttribute dev_attr;
	dev_attr << w_val;
	dev_attr.set_name("Position");

	try
	{
		axisR_proxy->write_attribute(dev_attr);
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::write_AxisCurrentPositionR()");
	}

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::write_AxisCurrentPositionR
}
//--------------------------------------------------------
/**
 *	Read attribute IsInitialisedU related method
 *	Description: 
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pbmpaxis::read_IsInitialisedU(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Pbmpaxis::read_IsInitialisedU(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::read_IsInitialisedU) ENABLED START -----*/
	try
	{
		Tango::DeviceAttribute dev_attr = axisU_proxy->read_attribute("IsInitialised");
		dev_attr >> *attr_IsInitialisedU_read;
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::read_IsInitialisedU()");
	}

	attr.set_value(attr_IsInitialisedU_read);

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::read_IsInitialisedU
}
//--------------------------------------------------------
/**
 *	Read attribute IsInitialisedD related method
 *	Description: 
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pbmpaxis::read_IsInitialisedD(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Pbmpaxis::read_IsInitialisedD(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::read_IsInitialisedD) ENABLED START -----*/
	try
	{
		Tango::DeviceAttribute dev_attr = axisD_proxy->read_attribute("IsInitialised");
		dev_attr >> *attr_IsInitialisedD_read;
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::read_IsInitialisedD()");
	}

	attr.set_value(attr_IsInitialisedD_read);

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::read_IsInitialisedD
}
//--------------------------------------------------------
/**
 *	Read attribute IsInitialisedL related method
 *	Description: 
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pbmpaxis::read_IsInitialisedL(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Pbmpaxis::read_IsInitialisedL(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::read_IsInitialisedL) ENABLED START -----*/
	try
	{
		Tango::DeviceAttribute dev_attr = axisL_proxy->read_attribute("IsInitialised");
		dev_attr >> *attr_IsInitialisedL_read;
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::read_IsInitialisedL()");
	}

	attr.set_value(attr_IsInitialisedL_read);

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::read_IsInitialisedL
}
//--------------------------------------------------------
/**
 *	Read attribute IsInitialisedR related method
 *	Description: 
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pbmpaxis::read_IsInitialisedR(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Pbmpaxis::read_IsInitialisedR(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::read_IsInitialisedR) ENABLED START -----*/
	try
	{
		Tango::DeviceAttribute dev_attr = axisR_proxy->read_attribute("IsInitialised");
		dev_attr >> *attr_IsInitialisedR_read;
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::read_IsInitialisedR()");
	}

	attr.set_value(attr_IsInitialisedR_read);

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::read_IsInitialisedR
}
//--------------------------------------------------------
/**
 *	Read attribute PbmpAxisCurrentPositionU related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pbmpaxis::read_PbmpAxisCurrentPositionU(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Pbmpaxis::read_PbmpAxisCurrentPositionU(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::read_PbmpAxisCurrentPositionU) ENABLED START -----*/
	try
	{
		Tango::DeviceAttribute dev_attr = axisU_proxy->read_attribute("Position");
		dev_attr >> *attr_AxisCurrentPositionU_read;
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::read_PbmpAxisCurrentPositionU()");
	}

	DEBUG_STREAM << "Position U: " << *attr_AxisCurrentPositionU_read << endl;

	*attr_PbmpAxisCurrentPositionU_read = *attr_AxisCurrentPositionU_read * axisU_m + axisU_q + *attr_PbmpAxisOffsetU_read;
	attr.set_value(attr_PbmpAxisCurrentPositionU_read);

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::read_PbmpAxisCurrentPositionU
}
//--------------------------------------------------------
/**
 *	Write attribute PbmpAxisCurrentPositionU related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pbmpaxis::write_PbmpAxisCurrentPositionU(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Pbmpaxis::write_PbmpAxisCurrentPositionU(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Pbmpaxis::write_PbmpAxisCurrentPositionU) ENABLED START -----*/
	// the variable w_val will not be used !

	std::stringstream ss;
	ss << __func__ << "(" << w_val << ")";
	hist->push_end(ss.str());

	Tango::DevDouble apos = (w_val - *attr_PbmpAxisOffsetU_read - axisU_q) / axisU_m;

	DEBUG_STREAM << "Position U: " << apos << endl;

	Tango::DeviceAttribute dev_attr;
	dev_attr << apos;
	dev_attr.set_name("Position");

	try
	{
		axisU_proxy->write_attribute(dev_attr);
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::write_PbmpAxisCurrentPositionU()");
	}

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::write_PbmpAxisCurrentPositionU
}
//--------------------------------------------------------
/**
 *	Read attribute PbmpAxisCurrentPositionD related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pbmpaxis::read_PbmpAxisCurrentPositionD(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Pbmpaxis::read_PbmpAxisCurrentPositionD(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::read_PbmpAxisCurrentPositionD) ENABLED START -----*/
	try
	{
		Tango::DeviceAttribute dev_attr = axisD_proxy->read_attribute("Position");
		dev_attr >> *attr_AxisCurrentPositionD_read;
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::read_PbmpAxisCurrentPositionD()");
	}

	DEBUG_STREAM << "Position D: " << *attr_AxisCurrentPositionD_read << endl;

	*attr_PbmpAxisCurrentPositionD_read = *attr_AxisCurrentPositionD_read * axisD_m + axisD_q + *attr_PbmpAxisOffsetD_read;
	attr.set_value(attr_PbmpAxisCurrentPositionD_read);

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::read_PbmpAxisCurrentPositionD
}
//--------------------------------------------------------
/**
 *	Write attribute PbmpAxisCurrentPositionD related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pbmpaxis::write_PbmpAxisCurrentPositionD(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Pbmpaxis::write_PbmpAxisCurrentPositionD(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Pbmpaxis::write_PbmpAxisCurrentPositionD) ENABLED START -----*/
	// the variable w_val will not be used !

	std::stringstream ss;
	ss << __func__ << "(" << w_val << ")";
	hist->push_end(ss.str());

	Tango::DevDouble apos = (w_val - *attr_PbmpAxisOffsetD_read - axisD_q) / axisD_m;

	DEBUG_STREAM << "Position D: " << apos << endl;

	Tango::DeviceAttribute dev_attr;
	dev_attr << apos;
	dev_attr.set_name("Position");

	try
	{
		axisD_proxy->write_attribute(dev_attr);
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::write_PbmpAxisCurrentPositionD()");
	}

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::write_PbmpAxisCurrentPositionD
}
//--------------------------------------------------------
/**
 *	Read attribute PbmpAxisCurrentPositionL related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pbmpaxis::read_PbmpAxisCurrentPositionL(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Pbmpaxis::read_PbmpAxisCurrentPositionL(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::read_PbmpAxisCurrentPositionL) ENABLED START -----*/
	try
	{
		Tango::DeviceAttribute dev_attr = axisL_proxy->read_attribute("Position");
		dev_attr >> *attr_AxisCurrentPositionL_read;
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::read_PbmpAxisCurrentPositionL()");
	}

	DEBUG_STREAM << "Position L: " << *attr_AxisCurrentPositionL_read << endl;

	*attr_PbmpAxisCurrentPositionL_read = *attr_AxisCurrentPositionL_read * axisL_m + axisL_q + *attr_PbmpAxisOffsetL_read;
	attr.set_value(attr_PbmpAxisCurrentPositionL_read);

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::read_PbmpAxisCurrentPositionL
}
//--------------------------------------------------------
/**
 *	Write attribute PbmpAxisCurrentPositionL related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pbmpaxis::write_PbmpAxisCurrentPositionL(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Pbmpaxis::write_PbmpAxisCurrentPositionL(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Pbmpaxis::write_PbmpAxisCurrentPositionL) ENABLED START -----*/
	// the variable w_val will not be used !

	std::stringstream ss;
	ss << __func__ << "(" << w_val << ")";
	hist->push_end(ss.str());

	Tango::DevDouble apos = (w_val - *attr_PbmpAxisOffsetL_read - axisL_q) / axisL_m;

	DEBUG_STREAM << "Position L: " << apos << endl;

	Tango::DeviceAttribute dev_attr;
	dev_attr << apos;
	dev_attr.set_name("Position");

	try
	{
		axisL_proxy->write_attribute(dev_attr);
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::write_PbmpAxisCurrentPositionL()");
	}

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::write_PbmpAxisCurrentPositionL
}
//--------------------------------------------------------
/**
 *	Read attribute PbmpAxisCurrentPositionR related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pbmpaxis::read_PbmpAxisCurrentPositionR(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Pbmpaxis::read_PbmpAxisCurrentPositionR(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::read_PbmpAxisCurrentPositionR) ENABLED START -----*/
	try
	{
		Tango::DeviceAttribute dev_attr = axisR_proxy->read_attribute("Position");
		dev_attr >> *attr_AxisCurrentPositionR_read;
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::read_PbmpAxisCurrentPositionR()");
	}

	DEBUG_STREAM << "Position L: " << *attr_AxisCurrentPositionR_read << endl;

	*attr_PbmpAxisCurrentPositionR_read = *attr_AxisCurrentPositionR_read * axisR_m + axisR_q + *attr_PbmpAxisOffsetR_read;
	attr.set_value(attr_PbmpAxisCurrentPositionR_read);

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::read_PbmpAxisCurrentPositionR
}
//--------------------------------------------------------
/**
 *	Write attribute PbmpAxisCurrentPositionR related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pbmpaxis::write_PbmpAxisCurrentPositionR(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Pbmpaxis::write_PbmpAxisCurrentPositionR(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Pbmpaxis::write_PbmpAxisCurrentPositionR) ENABLED START -----*/
	// the variable w_val will not be used !

	std::stringstream ss;
	ss << __func__ << "(" << w_val << ")";
	hist->push_end(ss.str());

	Tango::DevDouble apos = (w_val - *attr_PbmpAxisOffsetR_read - axisR_q) / axisR_m;

	DEBUG_STREAM << "Position R: " << apos << endl;

	Tango::DeviceAttribute dev_attr;
	dev_attr << apos;
	dev_attr.set_name("AxisCurrentPosition");

	try
	{
		axisR_proxy->write_attribute(dev_attr);
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::write_PbmpAxisCurrentPositionR()");
	}

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::write_PbmpAxisCurrentPositionR
}
//--------------------------------------------------------
/**
 *	Read attribute PbmpCenterV related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pbmpaxis::read_PbmpCenterV(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Pbmpaxis::read_PbmpCenterV(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::read_PbmpCenterV) ENABLED START -----*/
	try
	{
		Tango::DeviceAttribute dev_attr;

		dev_attr = axisU_proxy->read_attribute("Position");
		dev_attr >> *attr_AxisCurrentPositionU_read;

		dev_attr = axisD_proxy->read_attribute("Position");
		dev_attr >> *attr_AxisCurrentPositionD_read;

		DEBUG_STREAM << "Position U: " << *attr_AxisCurrentPositionU_read << endl;
		*attr_PbmpAxisCurrentPositionU_read = *attr_AxisCurrentPositionU_read * axisU_m + axisU_q + *attr_PbmpAxisOffsetU_read;
		DEBUG_STREAM << "PBPM position U: " << *attr_PbmpAxisCurrentPositionU_read << endl;

		DEBUG_STREAM << "Position D: " << *attr_AxisCurrentPositionU_read << endl;
		*attr_PbmpAxisCurrentPositionD_read = *attr_AxisCurrentPositionD_read * axisD_m + axisD_q + *attr_PbmpAxisOffsetD_read;
		DEBUG_STREAM << "PBPM position D: " << *attr_PbmpAxisCurrentPositionD_read << endl;

		*attr_PbmpCenterV_read = (*attr_PbmpAxisCurrentPositionD_read + *attr_PbmpAxisCurrentPositionU_read) / 2;

		attr.set_value(attr_PbmpCenterV_read);
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::read_PbmpCenterV()");
	}

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::read_PbmpCenterV
}
//--------------------------------------------------------
/**
 *	Write attribute PbmpCenterV related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pbmpaxis::write_PbmpCenterV(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Pbmpaxis::write_PbmpCenterV(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Pbmpaxis::write_PbmpCenterV) ENABLED START -----*/
	// the variable w_val will not be used !

	std::stringstream ss;
	ss << __func__ << "(" << w_val << ")";
	hist->push_end(ss.str());

	try
	{
		Tango::DeviceAttribute dev_attr;

		dev_attr = axisU_proxy->read_attribute("Position");
		dev_attr >> *attr_AxisCurrentPositionU_read;

		dev_attr = axisD_proxy->read_attribute("Position");
		dev_attr >> *attr_AxisCurrentPositionD_read;

		DEBUG_STREAM << "Position U: " << *attr_AxisCurrentPositionU_read << endl;
		*attr_PbmpAxisCurrentPositionU_read = *attr_AxisCurrentPositionU_read * axisU_m + axisU_q + *attr_PbmpAxisOffsetU_read;

		DEBUG_STREAM << "Position D: " << *attr_AxisCurrentPositionD_read << endl;
		*attr_PbmpAxisCurrentPositionD_read = *attr_AxisCurrentPositionD_read * axisD_m + axisD_q + *attr_PbmpAxisOffsetD_read;

		*attr_PbmpCenterV_read = (*attr_PbmpAxisCurrentPositionD_read + *attr_PbmpAxisCurrentPositionU_read) / 2;

		DEBUG_STREAM << "Moving Pbmp Center V from: " << *attr_PbmpCenterV_read << " to: " << w_val << endl;

		double PbmpCenterV_delta = w_val - *attr_PbmpCenterV_read;

		*attr_AxisCurrentPositionU_read = (*attr_AxisCurrentPositionU_read + PbmpCenterV_delta - *attr_PbmpAxisOffsetU_read - axisU_q) / axisU_m;
		DEBUG_STREAM << "Position U: " << *attr_AxisCurrentPositionU_read << endl;

		*attr_AxisCurrentPositionD_read = (*attr_AxisCurrentPositionD_read + PbmpCenterV_delta - *attr_PbmpAxisOffsetD_read - axisD_q) / axisD_m;
		DEBUG_STREAM << "Position D: " << *attr_AxisCurrentPositionD_read << endl;

		dev_attr << *attr_AxisCurrentPositionU_read;
		dev_attr.set_name("Position");
		axisU_proxy->write_attribute(dev_attr);

		dev_attr << *attr_AxisCurrentPositionD_read;
		dev_attr.set_name("Position");
		axisD_proxy->write_attribute(dev_attr);
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::write_PbmpCenterV()");
	}

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::write_PbmpCenterV
}
//--------------------------------------------------------
/**
 *	Read attribute PbmpCenterH related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pbmpaxis::read_PbmpCenterH(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Pbmpaxis::read_PbmpCenterH(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::read_PbmpCenterH) ENABLED START -----*/
	try
	{
		Tango::DeviceAttribute dev_attr;

		dev_attr = axisL_proxy->read_attribute("Position");
		dev_attr >> *attr_AxisCurrentPositionL_read;

		dev_attr = axisR_proxy->read_attribute("Position");
		dev_attr >> *attr_AxisCurrentPositionR_read;

		DEBUG_STREAM << "Position L: " << *attr_AxisCurrentPositionL_read << endl;
		*attr_PbmpAxisCurrentPositionL_read = *attr_AxisCurrentPositionL_read * axisL_m + axisL_q + *attr_PbmpAxisOffsetL_read;
		DEBUG_STREAM << "PBPM position L: " << *attr_PbmpAxisCurrentPositionL_read << endl;

		DEBUG_STREAM << "Position R: " << *attr_AxisCurrentPositionR_read << endl;
		*attr_PbmpAxisCurrentPositionR_read = *attr_AxisCurrentPositionR_read * axisR_m + axisR_q + *attr_PbmpAxisOffsetR_read;
		DEBUG_STREAM << "PBPM position R: " << *attr_PbmpAxisCurrentPositionR_read << endl;

		*attr_PbmpCenterV_read = (*attr_PbmpAxisCurrentPositionL_read + *attr_PbmpAxisCurrentPositionR_read) / 2;

		attr.set_value(attr_PbmpCenterV_read);
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::read_PbmpCenterH()");
	}

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::read_PbmpCenterH
}
//--------------------------------------------------------
/**
 *	Write attribute PbmpCenterH related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pbmpaxis::write_PbmpCenterH(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Pbmpaxis::write_PbmpCenterH(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Pbmpaxis::write_PbmpCenterH) ENABLED START -----*/
	// the variable w_val will not be used !

	std::stringstream ss;
	ss << __func__ << "(" << w_val << ")";
	hist->push_end(ss.str());

	try
	{
		Tango::DeviceAttribute dev_attr;

		dev_attr = axisL_proxy->read_attribute("Position");
		dev_attr >> *attr_AxisCurrentPositionL_read;

		dev_attr = axisR_proxy->read_attribute("Position");
		dev_attr >> *attr_AxisCurrentPositionR_read;

		DEBUG_STREAM << "Position L: " << *attr_AxisCurrentPositionL_read << endl;
		*attr_PbmpAxisCurrentPositionL_read = *attr_AxisCurrentPositionL_read * axisL_m + axisL_q + *attr_PbmpAxisOffsetL_read;

		DEBUG_STREAM << "Position R: " << *attr_AxisCurrentPositionR_read << endl;
		*attr_PbmpAxisCurrentPositionR_read = *attr_AxisCurrentPositionR_read * axisR_m + axisR_q + *attr_PbmpAxisOffsetR_read;

		*attr_PbmpCenterH_read = (*attr_PbmpAxisCurrentPositionR_read + *attr_PbmpAxisCurrentPositionL_read) / 2;

		DEBUG_STREAM << "Moving Pbmp Center H from: " << *attr_PbmpCenterH_read << " to: " << w_val << endl;

		double PbmpCenterH_delta = w_val - *attr_PbmpCenterH_read;

		*attr_AxisCurrentPositionL_read = (*attr_AxisCurrentPositionL_read + PbmpCenterH_delta - *attr_PbmpAxisOffsetL_read - axisL_q) / axisL_m;
		DEBUG_STREAM << "Position L: " << *attr_AxisCurrentPositionL_read << endl;

		*attr_AxisCurrentPositionR_read = (*attr_AxisCurrentPositionR_read + PbmpCenterH_delta - *attr_PbmpAxisOffsetR_read - axisR_q) / axisR_m;
		DEBUG_STREAM << "Position R: " << *attr_AxisCurrentPositionR_read << endl;

		dev_attr << *attr_AxisCurrentPositionL_read;
		dev_attr.set_name("Position");
		axisL_proxy->write_attribute(dev_attr);

		dev_attr << *attr_AxisCurrentPositionR_read;
		dev_attr.set_name("Position");
		axisR_proxy->write_attribute(dev_attr);
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::write_PbmpCenterH()");
	}

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::write_PbmpCenterH
}
//--------------------------------------------------------
/**
 *	Read attribute GapV related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pbmpaxis::read_GapV(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Pbmpaxis::read_GapV(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::read_GapV) ENABLED START -----*/
	try
	{
		Tango::DeviceAttribute dev_attr;

		dev_attr = axisU_proxy->read_attribute("Position");
		dev_attr >> *attr_AxisCurrentPositionU_read;

		dev_attr = axisD_proxy->read_attribute("Position");
		dev_attr >> *attr_AxisCurrentPositionD_read;
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::read_GapV()");
	}

	*attr_GapV_read = (*attr_AxisCurrentPositionU_read * axisU_m + axisU_q) - (*attr_AxisCurrentPositionD_read * axisD_m + axisD_q);
	attr.set_value(attr_GapV_read);

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::read_GapV
}
//--------------------------------------------------------
/**
 *	Write attribute GapV related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pbmpaxis::write_GapV(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Pbmpaxis::write_GapV(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Pbmpaxis::write_GapV) ENABLED START -----*/
	// the variable w_val will not be used !

	std::stringstream ss;
	ss << __func__ << "(" << w_val << ")";
	hist->push_end(ss.str());

	if(w_val < GAP_V_MIN_VAL)
	{
		print_error_msg("Negative gap not allowed", "Negative gap not allowed", "Pbmpaxis::write_GapV");
	}

	try
	{
		Tango::DeviceAttribute dev_attr;

		dev_attr = axisU_proxy->read_attribute("Position");
		dev_attr >> *attr_AxisCurrentPositionU_read;

		dev_attr = axisD_proxy->read_attribute("Position");
		dev_attr >> *attr_AxisCurrentPositionD_read;

		DEBUG_STREAM << "Position U: " << *attr_AxisCurrentPositionU_read << endl;
		DEBUG_STREAM << "Position D: " << *attr_AxisCurrentPositionD_read << endl;
		*attr_GapV_read = (*attr_AxisCurrentPositionU_read * axisU_m + axisU_q) - (*attr_AxisCurrentPositionD_read * axisD_m + axisD_q);

		double gapV_delta = (w_val - *attr_GapV_read) / 2;

		*attr_AxisCurrentPositionU_read = (*attr_AxisCurrentPositionU_read + gapV_delta - axisU_q) / axisU_m;
		DEBUG_STREAM << "Position U: " << *attr_AxisCurrentPositionU_read << endl;

		*attr_AxisCurrentPositionD_read = (*attr_AxisCurrentPositionD_read - gapV_delta - axisD_q) / axisD_m;
		DEBUG_STREAM << "Position D: " << *attr_AxisCurrentPositionD_read << endl;

		dev_attr << *attr_AxisCurrentPositionU_read;
		dev_attr.set_name("Position");
		axisU_proxy->write_attribute(dev_attr);

		dev_attr << *attr_AxisCurrentPositionD_read;
		dev_attr.set_name("Position");
		axisD_proxy->write_attribute(dev_attr);
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::write_GapV()");
	}

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::write_GapV
}
//--------------------------------------------------------
/**
 *	Read attribute GapH related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pbmpaxis::read_GapH(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Pbmpaxis::read_GapH(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::read_GapH) ENABLED START -----*/
	try
	{
		Tango::DeviceAttribute dev_attr;

		dev_attr = axisL_proxy->read_attribute("Position");
		dev_attr >> *attr_AxisCurrentPositionL_read;

		dev_attr = axisR_proxy->read_attribute("Position");
		dev_attr >> *attr_AxisCurrentPositionR_read;
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::read_GapH()");
	}

	*attr_GapH_read = (*attr_AxisCurrentPositionL_read * axisL_m + axisL_q) - (*attr_AxisCurrentPositionR_read * axisR_m + axisR_q);
	attr.set_value(attr_GapH_read);

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::read_GapH
}
//--------------------------------------------------------
/**
 *	Write attribute GapH related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pbmpaxis::write_GapH(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Pbmpaxis::write_GapH(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Pbmpaxis::write_GapH) ENABLED START -----*/
	// the variable w_val will not be used !

	std::stringstream ss;
	ss << __func__ << "(" << w_val << ")";
	hist->push_end(ss.str());

	if(w_val < GAP_H_MIN_VAL)
		{
			print_error_msg("Negative gap not allowed", "Negative gap not allowed", "Pbmpaxis::write_GapH");
		}

	try
	{
		Tango::DeviceAttribute dev_attr;

		dev_attr = axisL_proxy->read_attribute("Position");
		dev_attr >> *attr_AxisCurrentPositionL_read;

		dev_attr = axisR_proxy->read_attribute("Position");
		dev_attr >> *attr_AxisCurrentPositionR_read;

		DEBUG_STREAM << "Position L: " << *attr_AxisCurrentPositionL_read << endl;
		DEBUG_STREAM << "Position R: " << *attr_AxisCurrentPositionR_read << endl;
		*attr_GapH_read = (*attr_AxisCurrentPositionL_read * axisL_m + axisL_q) - (*attr_AxisCurrentPositionR_read * axisR_m + axisR_q);

		double gapH_delta = (w_val - *attr_GapH_read) / 2;

		*attr_AxisCurrentPositionL_read = (*attr_AxisCurrentPositionL_read + gapH_delta - axisL_q) / axisL_m;
		DEBUG_STREAM << "Position L: " << *attr_AxisCurrentPositionL_read << endl;

		*attr_AxisCurrentPositionR_read = (*attr_AxisCurrentPositionR_read - gapH_delta - axisR_q) / axisR_m;
		DEBUG_STREAM << "Position R: " << *attr_AxisCurrentPositionR_read << endl;

		dev_attr << *attr_AxisCurrentPositionL_read;
		dev_attr.set_name("Position");
		axisL_proxy->write_attribute(dev_attr);

		dev_attr << *attr_AxisCurrentPositionR_read;
		dev_attr.set_name("Position");
		axisR_proxy->write_attribute(dev_attr);
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::write_GapH()");
	}

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::write_GapH
}
//--------------------------------------------------------
/**
 *	Read attribute PbmpAxisOffsetU related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pbmpaxis::read_PbmpAxisOffsetU(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Pbmpaxis::read_PbmpAxisOffsetU(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::read_PbmpAxisOffsetU) ENABLED START -----*/
	attr.set_value(attr_PbmpAxisOffsetU_read);

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::read_PbmpAxisOffsetU
}
//--------------------------------------------------------
/**
 *	Read attribute PbmpAxisOffsetD related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pbmpaxis::read_PbmpAxisOffsetD(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Pbmpaxis::read_PbmpAxisOffsetD(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::read_PbmpAxisOffsetD) ENABLED START -----*/
	attr.set_value(attr_PbmpAxisOffsetD_read);

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::read_PbmpAxisOffsetD
}
//--------------------------------------------------------
/**
 *	Read attribute PbmpAxisOffsetL related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pbmpaxis::read_PbmpAxisOffsetL(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Pbmpaxis::read_PbmpAxisOffsetL(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::read_PbmpAxisOffsetL) ENABLED START -----*/
	attr.set_value(attr_PbmpAxisOffsetL_read);

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::read_PbmpAxisOffsetL
}
//--------------------------------------------------------
/**
 *	Read attribute PbmpAxisOffsetR related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pbmpaxis::read_PbmpAxisOffsetR(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Pbmpaxis::read_PbmpAxisOffsetR(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::read_PbmpAxisOffsetR) ENABLED START -----*/
	attr.set_value(attr_PbmpAxisOffsetR_read);

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::read_PbmpAxisOffsetR
}
//--------------------------------------------------------
/**
 *	Read attribute PbmpAxisIsInitialised related method
 *	Description: 
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pbmpaxis::read_PbmpAxisIsInitialised(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Pbmpaxis::read_PbmpAxisIsInitialised(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::read_PbmpAxisIsInitialised) ENABLED START -----*/
	#ifndef _MDM


	Tango::DeviceAttribute dev_attr;

	Tango::DevState pbmp_state = Tango::STANDBY;
	stringstream pbmp_status;

	try
	{
		dev_attr = axisU_proxy->read_attribute("State"); dev_attr >> axisU_state;
		dev_attr = axisU_proxy->read_attribute("Status"); dev_attr >> axisU_status;
	}
	catch(Tango::DevFailed &e)
	{
		axisU_state = Tango::FAULT;
		axisU_status.assign("FAULT");
	}

	try
	{
		dev_attr = axisD_proxy->read_attribute("State"); dev_attr >> axisD_state;
		dev_attr = axisD_proxy->read_attribute("Status"); dev_attr >> axisD_status;
	}
	catch(Tango::DevFailed &e)
	{
		axisD_state = Tango::FAULT;
		axisD_status.assign("FAULT");
	}

	try
	{
		dev_attr = axisL_proxy->read_attribute("State"); dev_attr >> axisL_state;
		dev_attr = axisL_proxy->read_attribute("Status"); dev_attr >> axisL_status;
	}
	catch(Tango::DevFailed &e)
	{
		axisL_state = Tango::FAULT;
		axisU_status.assign("FAULT");
	}

	try
	{
		dev_attr = axisR_proxy->read_attribute("State"); dev_attr >> axisR_state;
		dev_attr = axisR_proxy->read_attribute("Status"); dev_attr >> axisR_status;
	}
	catch(Tango::DevFailed &e)
	{
		axisR_state = Tango::FAULT;
		axisL_status.assign("FAULT");
	}
	if(axisU_state == Tango::FAULT ||
		axisD_state == Tango::FAULT ||
		axisL_state == Tango::FAULT ||
		axisR_state == Tango::FAULT )
	{
		pbmp_state = Tango::FAULT;
	} else 
	if(axisU_state == Tango::ALARM ||
		axisD_state == Tango::ALARM ||
		axisL_state == Tango::ALARM ||
		axisR_state == Tango::ALARM )
	{
		pbmp_state = Tango::ALARM;
	} else

	if(axisU_state == Tango::MOVING ||
		axisD_state == Tango::MOVING ||
		axisL_state == Tango::MOVING ||
		axisR_state == Tango::MOVING )
	{
		pbmp_state = Tango::MOVING;
	}


	//cout << "Pbmpaxis::read_PbmpAxisIsInitialised(): axisU_state "<< Tango::DevStateName[axisU_state] << endl;
	//cout << "Pbmpaxis::read_PbmpAxisIsInitialised(): axisU_status "<< axisU_status << endl;

	pbmp_status.str("");
	pbmp_status << "Axis U: " << axisU_status ;
	set_status(pbmp_status.str());

	pbmp_status.str("");
	pbmp_status << "Axis D: " << axisD_status ;
	append_status(pbmp_status.str(), true);

	pbmp_status.str("");
	pbmp_status << "Axis L: " << axisL_status ;
	append_status(pbmp_status.str(), true);

	pbmp_status.str("");
	pbmp_status << "Axis R: " << axisR_status ;
	append_status(pbmp_status.str(), true);

	//cout << "Pbmpaxis::read_PbmpAxisIsInitialised(): pbmp_status "<< pbmp_status.str() << endl;

	set_state(pbmp_state);
#endif

	//Tango::DeviceAttribute dev_attr;
	try
	{
		dev_attr = axisU_proxy->read_attribute("IsInitialised");
		dev_attr >> *attr_IsInitialisedU_read;

		dev_attr = axisD_proxy->read_attribute("IsInitialised");
		dev_attr >> *attr_IsInitialisedD_read;

		dev_attr = axisL_proxy->read_attribute("IsInitialised");
		dev_attr >> *attr_IsInitialisedL_read;

		dev_attr = axisR_proxy->read_attribute("IsInitialised");
		dev_attr >> *attr_IsInitialisedR_read;
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::read_PbmpAxisIsInitialised()");
	}

	*attr_PbmpAxisIsInitialised_read = *attr_IsInitialisedU_read &&
									*attr_IsInitialisedD_read &&
									*attr_IsInitialisedL_read &&
									*attr_IsInitialisedR_read;
	attr.set_value(attr_PbmpAxisIsInitialised_read);

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::read_PbmpAxisIsInitialised
}
//--------------------------------------------------------
/**
 *	Read attribute History related method
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Spectrum max = 2000
 */
//--------------------------------------------------------
void Pbmpaxis::read_History(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Pbmpaxis::read_History(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::read_History) ENABLED START -----*/

	int howmany = hist->copyto(attr_History_read);
	if (howmany > 0) attr.set_value(attr_History_read, howmany);

	//	Set the attribute value
	//attr.set_value(attr_History_read, 2000);
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::read_History
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::add_dynamic_attributes()
 *	Description : Create the dynamic attributes if any
 *                for specified device.
 */
//--------------------------------------------------------
void Pbmpaxis::add_dynamic_attributes()
{
	/*----- PROTECTED REGION ID(Pbmpaxis::add_dynamic_attributes) ENABLED START -----*/
	
	//	Add your own code to create and add dynamic attributes if any
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::add_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Command AxisGetMotionStatusU related method
 *	Description: Status of the motion : Returned Value is:
 *               -1 motion state unknown because communication is broken
 *               0 motion ended with success
 *               1 positionning motion running
 *
 *	@returns numerical code representing the status of the motion
 */
//--------------------------------------------------------
Tango::DevLong Pbmpaxis::axis_get_motion_status_u()
{
	Tango::DevLong argout;
	DEBUG_STREAM << "Pbmpaxis::AxisGetMotionStatusU()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::axis_get_motion_status_u) ENABLED START -----*/
	
	//	Add your own code
	Tango::DeviceData dev_data;

	try
	{
		dev_data = axisU_proxy->command_inout("AxisGetMotionStatus");
		dev_data >> argout;
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::axis_get_motion_status_u()");
	}

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::axis_get_motion_status_u
	return argout;
}
//--------------------------------------------------------
/**
 *	Command AxisGetMotionStatusD related method
 *	Description: Status of the motion : Returned Value is:
 *               -1 motion state unknown because communication is broken
 *               0 motion ended with success
 *               1 positionning motion running
 *
 *	@returns numerical code representing the status of the motion
 */
//--------------------------------------------------------
Tango::DevLong Pbmpaxis::axis_get_motion_status_d()
{
	Tango::DevLong argout;
	DEBUG_STREAM << "Pbmpaxis::AxisGetMotionStatusD()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::axis_get_motion_status_d) ENABLED START -----*/
	
	//	Add your own code
	Tango::DeviceData dev_data;

	try
	{
		dev_data = axisD_proxy->command_inout("AxisGetMotionStatus");
		dev_data >> argout;
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::axis_get_motion_status_d()");
	}

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::axis_get_motion_status_d
	return argout;
}
//--------------------------------------------------------
/**
 *	Command AxisGetMotionStatusL related method
 *	Description: Status of the motion : Returned Value is:
 *               -1 motion state unknown because communication is broken
 *               0 motion ended with success
 *               1 positionning motion running
 *
 *	@returns numerical code representing the status of the motion
 */
//--------------------------------------------------------
Tango::DevLong Pbmpaxis::axis_get_motion_status_l()
{
	Tango::DevLong argout;
	DEBUG_STREAM << "Pbmpaxis::AxisGetMotionStatusL()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::axis_get_motion_status_l) ENABLED START -----*/
	
	//	Add your own code
	Tango::DeviceData dev_data;

	try
	{
		dev_data = axisL_proxy->command_inout("AxisGetMotionStatus");
		dev_data >> argout;
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::axis_get_motion_status_l()");
	}

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::axis_get_motion_status_l
	return argout;
}
//--------------------------------------------------------
/**
 *	Command AxisGetMotionStatusR related method
 *	Description: Status of the motion : Returned Value is:
 *               -1 motion state unknown because communication is broken
 *               0 motion ended with success
 *               1 positionning motion running
 *
 *	@returns numerical code representing the status of the motion
 */
//--------------------------------------------------------
Tango::DevLong Pbmpaxis::axis_get_motion_status_r()
{
	Tango::DevLong argout;
	DEBUG_STREAM << "Pbmpaxis::AxisGetMotionStatusR()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::axis_get_motion_status_r) ENABLED START -----*/
	
	//	Add your own code
	Tango::DeviceData dev_data;

	try
	{
		dev_data = axisR_proxy->command_inout("AxisGetMotionStatus");
		dev_data >> argout;
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::axis_get_motion_status_l()");
	}

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::axis_get_motion_status_r
	return argout;
}
//--------------------------------------------------------
/**
 *	Command AxisInitU related method
 *	Description: 
 *
 */
//--------------------------------------------------------
void Pbmpaxis::axis_init_u()
{
	DEBUG_STREAM << "Pbmpaxis::AxisInitU()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::axis_init_u) ENABLED START -----*/

	std::stringstream ss;
	ss << __func__ << "()";
	hist->push_end(ss.str());
	
	//	Add your own code
	try
	{
		axisU_proxy->command_inout("AxisInit");
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::axis_init_u()");
	}

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::axis_init_u
}
//--------------------------------------------------------
/**
 *	Command AxisInitD related method
 *	Description: 
 *
 */
//--------------------------------------------------------
void Pbmpaxis::axis_init_d()
{
	DEBUG_STREAM << "Pbmpaxis::AxisInitD()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::axis_init_d) ENABLED START -----*/

	std::stringstream ss;
	ss << __func__ << "()";
	hist->push_end(ss.str());
	
	//	Add your own code
	try
	{
		axisD_proxy->command_inout("AxisInit");
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::axis_init_d()");
	}

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::axis_init_d
}
//--------------------------------------------------------
/**
 *	Command AxisInitL related method
 *	Description: 
 *
 */
//--------------------------------------------------------
void Pbmpaxis::axis_init_l()
{
	DEBUG_STREAM << "Pbmpaxis::AxisInitL()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::axis_init_l) ENABLED START -----*/
	
	std::stringstream ss;
	ss << __func__ << "()";
	hist->push_end(ss.str());
	
	//	Add your own code
	try
	{
		axisL_proxy->command_inout("AxisInit");
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::axis_init_l()");
	}

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::axis_init_l
}
//--------------------------------------------------------
/**
 *	Command AxisInitR related method
 *	Description: 
 *
 */
//--------------------------------------------------------
void Pbmpaxis::axis_init_r()
{
	DEBUG_STREAM << "Pbmpaxis::AxisInitR()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::axis_init_r) ENABLED START -----*/
	
	std::stringstream ss;
	ss << __func__ << "()";
	hist->push_end(ss.str());
	
	//	Add your own code
	try
	{
		axisR_proxy->command_inout("AxisInit");
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::axis_init_r()");
	}

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::axis_init_r
}
//--------------------------------------------------------
/**
 *	Command AxisStopU related method
 *	Description: 
 *
 */
//--------------------------------------------------------
void Pbmpaxis::axis_stop_u()
{
	DEBUG_STREAM << "Pbmpaxis::AxisStopU()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::axis_stop_u) ENABLED START -----*/
	
	std::stringstream ss;
	ss << __func__ << "()";
	hist->push_end(ss.str());
	
	//	Add your own code
	try
	{
		axisU_proxy->command_inout("AxisStop");
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::axis_stop_u()");
	}

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::axis_stop_u
}
//--------------------------------------------------------
/**
 *	Command AxisStopD related method
 *	Description: 
 *
 */
//--------------------------------------------------------
void Pbmpaxis::axis_stop_d()
{
	DEBUG_STREAM << "Pbmpaxis::AxisStopD()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::axis_stop_d) ENABLED START -----*/
	
	std::stringstream ss;
	ss << __func__ << "()";
	hist->push_end(ss.str());
	
	//	Add your own code
	try
	{
		axisD_proxy->command_inout("AxisStop");
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::axis_stop_d()");
	}

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::axis_stop_d
}
//--------------------------------------------------------
/**
 *	Command AxisStopL related method
 *	Description: 
 *
 */
//--------------------------------------------------------
void Pbmpaxis::axis_stop_l()
{
	DEBUG_STREAM << "Pbmpaxis::AxisStopL()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::axis_stop_l) ENABLED START -----*/
	
	std::stringstream ss;
	ss << __func__ << "()";
	hist->push_end(ss.str());
	
	//	Add your own code
	try
	{
		axisL_proxy->command_inout("AxisStop");
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::axis_stop_l()");
	}

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::axis_stop_l
}
//--------------------------------------------------------
/**
 *	Command AxisStopR related method
 *	Description: 
 *
 */
//--------------------------------------------------------
void Pbmpaxis::axis_stop_r()
{
	DEBUG_STREAM << "Pbmpaxis::AxisStopR()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::axis_stop_r) ENABLED START -----*/
	
	std::stringstream ss;
	ss << __func__ << "()";
	hist->push_end(ss.str());
	
	//	Add your own code
	try
	{
		axisR_proxy->command_inout("AxisStop");
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::axis_stop_r()");
	}

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::axis_stop_r
}
//--------------------------------------------------------
/**
 *	Command MotorONU related method
 *	Description: enables the power amplifier of the motor
 *
 */
//--------------------------------------------------------
void Pbmpaxis::motor_onu()
{
	DEBUG_STREAM << "Pbmpaxis::MotorONU()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::motor_onu) ENABLED START -----*/
	
	std::stringstream ss;
	ss << __func__ << "()";
	hist->push_end(ss.str());
	
	//	Add your own code
	try
	{
		axisU_proxy->command_inout("MotorON");
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::motor_onu()");
	}

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::motor_onu
}
//--------------------------------------------------------
/**
 *	Command MotorOND related method
 *	Description: enables the power amplifier of the motor
 *
 */
//--------------------------------------------------------
void Pbmpaxis::motor_ond()
{
	DEBUG_STREAM << "Pbmpaxis::MotorOND()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::motor_ond) ENABLED START -----*/
	
	std::stringstream ss;
	ss << __func__ << "()";
	hist->push_end(ss.str());
	
	//	Add your own code
	try
	{
		axisD_proxy->command_inout("MotorON");
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::motor_ond()");
	}

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::motor_ond
}
//--------------------------------------------------------
/**
 *	Command MotorONL related method
 *	Description: enables the power amplifier of the motor
 *
 */
//--------------------------------------------------------
void Pbmpaxis::motor_onl()
{
	DEBUG_STREAM << "Pbmpaxis::MotorONL()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::motor_onl) ENABLED START -----*/
	
	std::stringstream ss;
	ss << __func__ << "()";
	hist->push_end(ss.str());
	
	//	Add your own code
	try
	{
		axisL_proxy->command_inout("MotorON");
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::motor_onl()");
	}

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::motor_onl
}
//--------------------------------------------------------
/**
 *	Command MotorONR related method
 *	Description: enables the power amplifier of the motor
 *
 */
//--------------------------------------------------------
void Pbmpaxis::motor_onr()
{
	DEBUG_STREAM << "Pbmpaxis::MotorONR()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::motor_onr) ENABLED START -----*/
	
	std::stringstream ss;
	ss << __func__ << "()";
	hist->push_end(ss.str());
	
	//	Add your own code
	try
	{
		axisR_proxy->command_inout("MotorON");
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::motor_onr()");
	}

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::motor_onr
}
//--------------------------------------------------------
/**
 *	Command MotorOFFU related method
 *	Description: disable the power amplifier of the motor
 *
 */
//--------------------------------------------------------
void Pbmpaxis::motor_offu()
{
	DEBUG_STREAM << "Pbmpaxis::MotorOFFU()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::motor_offu) ENABLED START -----*/
	
	std::stringstream ss;
	ss << __func__ << "()";
	hist->push_end(ss.str());
	
	//	Add your own code
	try
	{
		axisU_proxy->command_inout("MotorOFF");
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::motor_offu()");
	}

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::motor_offu
}
//--------------------------------------------------------
/**
 *	Command MotorOFFD related method
 *	Description: disable the power amplifier of the motor
 *
 */
//--------------------------------------------------------
void Pbmpaxis::motor_offd()
{
	DEBUG_STREAM << "Pbmpaxis::MotorOFFD()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::motor_offd) ENABLED START -----*/
	
	std::stringstream ss;
	ss << __func__ << "()";
	hist->push_end(ss.str());
	
	//	Add your own code
	try
	{
		axisD_proxy->command_inout("MotorOFF");
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::motor_offd()");
	}

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::motor_offd
}
//--------------------------------------------------------
/**
 *	Command MotorOFFL related method
 *	Description: disable the power amplifier of the motor
 *
 */
//--------------------------------------------------------
void Pbmpaxis::motor_offl()
{
	DEBUG_STREAM << "Pbmpaxis::MotorOFFL()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::motor_offl) ENABLED START -----*/
	
	std::stringstream ss;
	ss << __func__ << "()";
	hist->push_end(ss.str());
	
	//	Add your own code
	try
	{
		axisL_proxy->command_inout("MotorOFF");
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::motor_offl()");
	}

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::motor_offl
}
//--------------------------------------------------------
/**
 *	Command MotorOFFR related method
 *	Description: disable the power amplifier of the motor
 *
 */
//--------------------------------------------------------
void Pbmpaxis::motor_offr()
{
	DEBUG_STREAM << "Pbmpaxis::MotorOFFR()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::motor_offr) ENABLED START -----*/
	
	std::stringstream ss;
	ss << __func__ << "()";
	hist->push_end(ss.str());
	
	//	Add your own code
	try
	{
		axisR_proxy->command_inout("MotorOFF");
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::motor_offr()");
	}

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::motor_offr
}
//--------------------------------------------------------
/**
 *	Command PbmpAxisDefineOffsetU related method
 *	Description: 
 *
 *	@param argin 
 */
//--------------------------------------------------------
void Pbmpaxis::pbmp_axis_define_offset_u(Tango::DevDouble argin)
{
	DEBUG_STREAM << "Pbmpaxis::PbmpAxisDefineOffsetU()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::pbmp_axis_define_offset_u) ENABLED START -----*/
	
	std::stringstream ss;
	ss << __func__ << "(" << argin << ")";
	hist->push_end(ss.str());
	
	//	Add your own code
	*attr_PbmpAxisOffsetU_read = argin;

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::pbmp_axis_define_offset_u
}
//--------------------------------------------------------
/**
 *	Command PbmpAxisDefineOffsetD related method
 *	Description: 
 *
 *	@param argin 
 */
//--------------------------------------------------------
void Pbmpaxis::pbmp_axis_define_offset_d(Tango::DevDouble argin)
{
	DEBUG_STREAM << "Pbmpaxis::PbmpAxisDefineOffsetD()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::pbmp_axis_define_offset_d) ENABLED START -----*/
	
	std::stringstream ss;
	ss << __func__ << "(" << argin << ")";
	hist->push_end(ss.str());
	
	//	Add your own code
	*attr_PbmpAxisOffsetD_read = argin;

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::pbmp_axis_define_offset_d
}
//--------------------------------------------------------
/**
 *	Command PbmpAxisDefineOffsetL related method
 *	Description: 
 *
 *	@param argin 
 */
//--------------------------------------------------------
void Pbmpaxis::pbmp_axis_define_offset_l(Tango::DevDouble argin)
{
	DEBUG_STREAM << "Pbmpaxis::PbmpAxisDefineOffsetL()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::pbmp_axis_define_offset_l) ENABLED START -----*/
	
	std::stringstream ss;
	ss << __func__ << "(" << argin << ")";
	hist->push_end(ss.str());
	
	//	Add your own code
	*attr_PbmpAxisOffsetL_read = argin;

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::pbmp_axis_define_offset_l
}
//--------------------------------------------------------
/**
 *	Command PbmpAxisDefineOffsetR related method
 *	Description: 
 *
 *	@param argin 
 */
//--------------------------------------------------------
void Pbmpaxis::pbmp_axis_define_offset_r(Tango::DevDouble argin)
{
	DEBUG_STREAM << "Pbmpaxis::PbmpAxisDefineOffsetR()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::pbmp_axis_define_offset_r) ENABLED START -----*/
	
	std::stringstream ss;
	ss << __func__ << "(" << argin << ")";
	hist->push_end(ss.str());
	
	//	Add your own code
	*attr_PbmpAxisOffsetR_read = argin;

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::pbmp_axis_define_offset_r
}
//--------------------------------------------------------
/**
 *	Command PbmpDefineZeroU related method
 *	Description: 
 *
 */
//--------------------------------------------------------
void Pbmpaxis::pbmp_define_zero_u()
{
	DEBUG_STREAM << "Pbmpaxis::PbmpDefineZeroU()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::pbmp_define_zero_u) ENABLED START -----*/
	
	std::stringstream ss;
	ss << __func__ << "()";
	hist->push_end(ss.str());
	
	//	Add your own code
	Tango::DeviceAttribute dev_attr;
	try
	{
		dev_attr = axisU_proxy->read_attribute("Position");
		dev_attr >> *attr_AxisCurrentPositionU_read;
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::pbmp_define_zero_u()");
	}

	*attr_PbmpAxisOffsetU_read = *attr_PbmpAxisOffsetU_read - (*attr_AxisCurrentPositionU_read * axisU_m + axisU_q);

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::pbmp_define_zero_u
}
//--------------------------------------------------------
/**
 *	Command PbmpDefineZeroD related method
 *	Description: 
 *
 */
//--------------------------------------------------------
void Pbmpaxis::pbmp_define_zero_d()
{
	DEBUG_STREAM << "Pbmpaxis::PbmpDefineZeroD()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::pbmp_define_zero_d) ENABLED START -----*/
	
	std::stringstream ss;
	ss << __func__ << "()";
	hist->push_end(ss.str());
	
	//	Add your own code
	Tango::DeviceAttribute dev_attr;
	try
	{
		dev_attr = axisD_proxy->read_attribute("Position");
		dev_attr >> *attr_AxisCurrentPositionD_read;
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::pbmp_define_zero_d()");
	}

	*attr_PbmpAxisOffsetD_read = *attr_PbmpAxisOffsetD_read - (*attr_AxisCurrentPositionD_read * axisD_m + axisD_q);

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::pbmp_define_zero_d
}
//--------------------------------------------------------
/**
 *	Command PbmpDefineZeroL related method
 *	Description: 
 *
 */
//--------------------------------------------------------
void Pbmpaxis::pbmp_define_zero_l()
{
	DEBUG_STREAM << "Pbmpaxis::PbmpDefineZeroL()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::pbmp_define_zero_l) ENABLED START -----*/
	
	std::stringstream ss;
	ss << __func__ << "()";
	hist->push_end(ss.str());
	
	//	Add your own code
	Tango::DeviceAttribute dev_attr;
	try
	{
		dev_attr = axisL_proxy->read_attribute("Position");
		dev_attr >> *attr_AxisCurrentPositionL_read;
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::pbmp_define_zero_l()");
	}

	*attr_PbmpAxisOffsetL_read = *attr_PbmpAxisOffsetL_read - (*attr_AxisCurrentPositionL_read * axisL_m + axisL_q);

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::pbmp_define_zero_l
}
//--------------------------------------------------------
/**
 *	Command PbmpDefineZeroR related method
 *	Description: 
 *
 */
//--------------------------------------------------------
void Pbmpaxis::pbmp_define_zero_r()
{
	DEBUG_STREAM << "Pbmpaxis::PbmpDefineZeroR()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::pbmp_define_zero_r) ENABLED START -----*/
	
	std::stringstream ss;
	ss << __func__ << "()";
	hist->push_end(ss.str());
	
	//	Add your own code
	Tango::DeviceAttribute dev_attr;
	try
	{
		dev_attr = axisR_proxy->read_attribute("Position");
		dev_attr >> *attr_AxisCurrentPositionR_read;
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::pbmp_define_zero_r()");
	}

	*attr_PbmpAxisOffsetL_read = *attr_PbmpAxisOffsetL_read - (*attr_AxisCurrentPositionL_read * axisL_m + axisL_q);

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::pbmp_define_zero_r
}
//--------------------------------------------------------
/**
 *	Command PbmpCenterVGoToPosition related method
 *	Description: 
 *
 *	@param argin 
 */
//--------------------------------------------------------
void Pbmpaxis::pbmp_center_vgo_to_position(Tango::DevDouble argin)
{
	DEBUG_STREAM << "Pbmpaxis::PbmpCenterVGoToPosition()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::pbmp_center_vgo_to_position) ENABLED START -----*/
	
	std::stringstream ss;
	ss << __func__ << "(" << argin << ")";
	hist->push_end(ss.str());
	
	//	Add your own code
	//TODO: contorllare trasformazione lineare

	DEBUG_STREAM << "Pbmpaxis::pbmp_center_vgo_to_position(): entering... !" << endl;

	try
	{
		Tango::DeviceAttribute dev_attr;

		dev_attr = axisU_proxy->read_attribute("Position");
		dev_attr >> *attr_AxisCurrentPositionU_read;

		dev_attr = axisD_proxy->read_attribute("Position");
		dev_attr >> *attr_AxisCurrentPositionD_read;

		DEBUG_STREAM << "Position U: " << *attr_AxisCurrentPositionU_read << endl;
		*attr_PbmpAxisCurrentPositionU_read = *attr_AxisCurrentPositionU_read * axisU_m + axisU_q + *attr_PbmpAxisOffsetU_read;

		DEBUG_STREAM << "Position D: " << *attr_AxisCurrentPositionD_read << endl;
		*attr_PbmpAxisCurrentPositionD_read = *attr_AxisCurrentPositionD_read * axisD_m + axisD_q + *attr_PbmpAxisOffsetD_read;

		*attr_PbmpCenterV_read = (*attr_PbmpAxisCurrentPositionD_read + *attr_PbmpAxisCurrentPositionU_read) / 2;
		Tango::DevDouble  attr_PbmpCenterV_write = argin;

		DEBUG_STREAM << "Moving Pbmp Center V from: " << *attr_PbmpCenterV_read << " to: " << attr_PbmpCenterV_write << endl;

		double PbmpCenterV_delta = attr_PbmpCenterV_write - *attr_PbmpCenterV_read;

		*attr_AxisCurrentPositionU_read = *attr_AxisCurrentPositionU_read + PbmpCenterV_delta / axisU_m;
		DEBUG_STREAM << "Position U: " << *attr_AxisCurrentPositionU_read << endl;

		*attr_AxisCurrentPositionD_read = *attr_AxisCurrentPositionD_read + PbmpCenterV_delta / axisD_m;
		DEBUG_STREAM << "Position D: " << *attr_AxisCurrentPositionD_read << endl;

		dev_attr << *attr_AxisCurrentPositionU_read;
		dev_attr.set_name("Position");
		axisU_proxy->write_attribute(dev_attr);

		dev_attr << *attr_AxisCurrentPositionD_read;
		dev_attr.set_name("Position");
		axisD_proxy->write_attribute(dev_attr);
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::pbmp_center_vgo_to_position()");
	}
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::pbmp_center_vgo_to_position
}
//--------------------------------------------------------
/**
 *	Command PbmpCenterHGoToPosition related method
 *	Description: 
 *
 *	@param argin 
 */
//--------------------------------------------------------
void Pbmpaxis::pbmp_center_hgo_to_position(Tango::DevDouble argin)
{
	DEBUG_STREAM << "Pbmpaxis::PbmpCenterHGoToPosition()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::pbmp_center_hgo_to_position) ENABLED START -----*/
	
	std::stringstream ss;
	ss << __func__ << "(" << argin << ")";
	hist->push_end(ss.str());
	
	//	Add your own code
        DEBUG_STREAM << "Pbmpaxis::pbmp_center_hgo_to_position(): entering... !" << endl;

        try
        {
                Tango::DeviceAttribute dev_attr;

                dev_attr = axisL_proxy->read_attribute("Position");
                dev_attr >> *attr_AxisCurrentPositionL_read;

                dev_attr = axisR_proxy->read_attribute("Position");
                dev_attr >> *attr_AxisCurrentPositionR_read;

                DEBUG_STREAM << "Position L: " << *attr_AxisCurrentPositionL_read << endl;
                *attr_PbmpAxisCurrentPositionL_read = *attr_AxisCurrentPositionL_read * axisL_m + axisL_q + *attr_PbmpAxisOffsetL_read;

                DEBUG_STREAM << "Position R: " << *attr_AxisCurrentPositionR_read << endl;
                *attr_PbmpAxisCurrentPositionR_read = *attr_AxisCurrentPositionR_read * axisR_m + axisR_q + *attr_PbmpAxisOffsetR_read;

                *attr_PbmpCenterH_read = (*attr_PbmpAxisCurrentPositionR_read + *attr_PbmpAxisCurrentPositionL_read) / 2;
                Tango::DevDouble attr_PbmpCenterH_write = argin;

                DEBUG_STREAM << "Moving Pbmp Center H from: " << *attr_PbmpCenterH_read << " to: " << attr_PbmpCenterH_write << endl;

                double PbmpCenterH_delta = attr_PbmpCenterH_write - *attr_PbmpCenterH_read;

                *attr_AxisCurrentPositionL_read = *attr_AxisCurrentPositionL_read + PbmpCenterH_delta / axisL_m;
                DEBUG_STREAM << "Position L: " << *attr_AxisCurrentPositionL_read << endl;

                *attr_AxisCurrentPositionR_read = *attr_AxisCurrentPositionR_read + PbmpCenterH_delta / axisR_m;
                DEBUG_STREAM << "Position R: " << *attr_AxisCurrentPositionR_read << endl;

                dev_attr << *attr_AxisCurrentPositionL_read;
                dev_attr.set_name("Position");
                axisL_proxy->write_attribute(dev_attr);

                dev_attr << *attr_AxisCurrentPositionR_read;
                dev_attr.set_name("Position");
                axisR_proxy->write_attribute(dev_attr);
        }
        catch(Tango::DevFailed &e)
        {
                exception_handler(e, Tango::FAULT,"Pbmpaxis::pbmp_center_hgo_to_position()");
        }

	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::pbmp_center_hgo_to_position
}
//--------------------------------------------------------
/**
 *	Command PbmpGapV related method
 *	Description: 
 *
 *	@param argin 
 */
//--------------------------------------------------------
void Pbmpaxis::pbmp_gap_v(Tango::DevDouble argin)
{
	DEBUG_STREAM << "Pbmpaxis::PbmpGapV()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::pbmp_gap_v) ENABLED START -----*/
	
	std::stringstream ss;
	ss << __func__ << "(" << argin << ")";
	hist->push_end(ss.str());
	
	//	Add your own code
	Tango::DevDouble attr_GapV_write = argin / 2;

	try
	{
		Tango::DeviceAttribute dev_attr;

		dev_attr = axisU_proxy->read_attribute("Position");
		dev_attr >> *attr_AxisCurrentPositionU_read;

		dev_attr = axisD_proxy->read_attribute("Position");
		dev_attr >> *attr_AxisCurrentPositionD_read;

		*attr_AxisCurrentPositionU_read = *attr_AxisCurrentPositionU_read + attr_GapV_write / axisU_m;
		DEBUG_STREAM << "Position U: " << *attr_AxisCurrentPositionU_read << endl;

		*attr_AxisCurrentPositionD_read = *attr_AxisCurrentPositionD_read + attr_GapV_write / axisD_m;
		DEBUG_STREAM << "Position D: " << *attr_AxisCurrentPositionD_read << endl;

		dev_attr << *attr_AxisCurrentPositionU_read;
		dev_attr.set_name("Position");
		axisU_proxy->write_attribute(dev_attr);

		dev_attr << *attr_AxisCurrentPositionD_read;
		dev_attr.set_name("Position");
		axisD_proxy->write_attribute(dev_attr);
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::pbmp_gap_v()");
	}

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::pbmp_gap_v
}
//--------------------------------------------------------
/**
 *	Command PbmpGapH related method
 *	Description: 
 *
 *	@param argin 
 */
//--------------------------------------------------------
void Pbmpaxis::pbmp_gap_h(Tango::DevDouble argin)
{
	DEBUG_STREAM << "Pbmpaxis::PbmpGapH()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::pbmp_gap_h) ENABLED START -----*/
	
	std::stringstream ss;
	ss << __func__ << "(" << argin << ")";
	hist->push_end(ss.str());
	
	//	Add your own code
	Tango::DevDouble attr_GapH_write = argin / 2;

	try
	{
		Tango::DeviceAttribute dev_attr;

		dev_attr = axisL_proxy->read_attribute("Position");
		dev_attr >> *attr_AxisCurrentPositionL_read;

		dev_attr = axisR_proxy->read_attribute("Position");
		dev_attr >> *attr_AxisCurrentPositionR_read;

		*attr_AxisCurrentPositionL_read = *attr_AxisCurrentPositionL_read + attr_GapH_write / axisL_m;
		DEBUG_STREAM << "Position L: " << *attr_AxisCurrentPositionL_read << endl;

		*attr_AxisCurrentPositionR_read = *attr_AxisCurrentPositionR_read + attr_GapH_write / axisR_m;
		DEBUG_STREAM << "Position R: " << *attr_AxisCurrentPositionR_read << endl;

		dev_attr << *attr_AxisCurrentPositionL_read;
		dev_attr.set_name("Position");
		axisL_proxy->write_attribute(dev_attr);

		dev_attr << *attr_AxisCurrentPositionR_read;
		dev_attr.set_name("Position");
		axisR_proxy->write_attribute(dev_attr);
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::pbmp_gap_h()");
	}

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::pbmp_gap_h
}
//--------------------------------------------------------
/**
 *	Command PbmpAxisStop related method
 *	Description: 
 *
 */
//--------------------------------------------------------
void Pbmpaxis::pbmp_axis_stop()
{
	DEBUG_STREAM << "Pbmpaxis::PbmpAxisStop()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Pbmpaxis::pbmp_axis_stop) ENABLED START -----*/
	
	std::stringstream ss;
	ss << __func__ << "()";
	hist->push_end(ss.str());
	
	//	Add your own code
	try
	{
		if(axisU_proxy->state() == Tango::MOVING)
		{
			axisU_proxy->command_inout("AxisStop");
		}
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::pbmp_axis_stop() axis U");
	}

	try
	{
		if(axisD_proxy->state() == Tango::MOVING)
		{
			axisD_proxy->command_inout("AxisStop");
		}
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::pbmp_axis_stop() axis D");
	}

	try
	{
		if(axisL_proxy->state() == Tango::MOVING)
		{
			axisL_proxy->command_inout("AxisStop");
		}
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::pbmp_axis_stop() axis L");
	}

	try
	{
		if(axisR_proxy->state() == Tango::MOVING)
		{
			axisR_proxy->command_inout("AxisStop");
		}
	}
	catch(Tango::DevFailed &e)
	{
		exception_handler(e, Tango::FAULT,"Pbmpaxis::pbmp_axis_stop() axis R");
	}

	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::pbmp_axis_stop
}
//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::add_dynamic_commands()
 *	Description : Create the dynamic commands if any
 *                for specified device.
 */
//--------------------------------------------------------
void Pbmpaxis::add_dynamic_commands()
{
	/*----- PROTECTED REGION ID(Pbmpaxis::add_dynamic_commands) ENABLED START -----*/
	
	//	Add your own code to create and add dynamic commands if any
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::add_dynamic_commands
}

/*----- PROTECTED REGION ID(Pbmpaxis::namespace_ending) ENABLED START -----*/

//	Additional Methods
//+------------------------------------------------------------------
/**
 *                        PRIVATE METHODS
 */
//+------------------------------------------------------------------

//+------------------------------------------------------------------
/**
 *      method: Pbmpaxis::print_error_msg
 *
 *      description:    method to send and error message
 *
 */
//+------------------------------------------------------------------
void Pbmpaxis::print_error_msg(const string reason_str, const string desc_str, const string origin_str)
{
    ERROR_STREAM << origin_str << "() => " << reason_str << " : " << desc_str << endl;

    Tango::Except::throw_exception(reason_str, desc_str, origin_str);
}
//+------------------------------------------------------------------
/**
 *      method: Pbmpaxis::print_error_msg
 *
 *      description:    method to send and error message
 *      				and set a new state
 *
 */
//+------------------------------------------------------------------
void Pbmpaxis::print_error_msg(const string reason_str, const string desc_str, const string origin_str, Tango::DevState state)
{
    ERROR_STREAM << origin_str << "() => " << reason_str << " : " << desc_str << endl;

    set_state(state);
    set_status(reason_str.c_str());

    Tango::Except::throw_exception(reason_str, desc_str, origin_str);
}
//+------------------------------------------------------------------
/**
 *      method: Pbmpaxis::exception_handler
 *
 *      description:    handle exception, print error message and
 *      				set state and status
 *
 */
//+------------------------------------------------------------------
void Pbmpaxis::exception_handler(Tango::DevFailed &ex, Tango::DevState new_state, const std::string base_msg)
{
    std::stringstream msg;

    msg << base_msg << " : ";
    for (unsigned int i=0; i<ex.errors.length(); i++)
    {
            msg << ex.errors[i].reason.in() << endl;
            msg << ex.errors[i].desc.in() << endl;
            msg << ex.errors[i].origin.in() << endl;
    }
    msg << ends;

    ERROR_STREAM << msg.str() << endl;

    set_state(new_state);
    set_status(msg.str());
}


/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::namespace_ending
} //	namespace
