/*----- PROTECTED REGION ID(Pbmpaxis.h) ENABLED START -----*/
//=============================================================================
//
// file :        Pbmpaxis.h
//
// description : Include file for the Pbmpaxis class
//
// project :     Photon beam monitor position
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef Pbmpaxis_H
#define Pbmpaxis_H

#include <tango.h>

#include "History.h"


/*----- PROTECTED REGION END -----*/	//	Pbmpaxis.h

/**
 *  Pbmpaxis class description:
 *    Photon beam monitor position axis mover. Works on galilaxis.
 */

namespace Pbmpaxis_ns
{
/*----- PROTECTED REGION ID(Pbmpaxis::Additional Class Declarations) ENABLED START -----*/

//	Additional Class Declarations

/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::Additional Class Declarations

class Pbmpaxis : public TANGO_BASE_CLASS
{

/*----- PROTECTED REGION ID(Pbmpaxis::Data Members) ENABLED START -----*/

//	Add your own data members
private:

	History_ns::history* hist;

public:


/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::Data Members

//	Device property data members
public:
	//	AxisU:	
	string	axisU;
	//	AxisD:	
	string	axisD;
	//	AxisL:	
	string	axisL;
	//	AxisR:	
	string	axisR;
	//	TrasfAxisU:	
	vector<Tango::DevDouble>	trasfAxisU;
	//	TrasfAxisD:	
	vector<Tango::DevDouble>	trasfAxisD;
	//	TrasfAxisL:	
	vector<Tango::DevDouble>	trasfAxisL;
	//	TrasfAxisR:	
	vector<Tango::DevDouble>	trasfAxisR;
	//	Timeout:	
	Tango::DevLong	timeout;

	bool	mandatoryNotDefined;

//	Attribute data members
public:
	Tango::DevDouble	*attr_AxisCurrentPositionU_read;
	Tango::DevDouble	*attr_AxisCurrentPositionD_read;
	Tango::DevDouble	*attr_AxisCurrentPositionL_read;
	Tango::DevDouble	*attr_AxisCurrentPositionR_read;
	Tango::DevShort	*attr_IsInitialisedU_read;
	Tango::DevShort	*attr_IsInitialisedD_read;
	Tango::DevShort	*attr_IsInitialisedL_read;
	Tango::DevShort	*attr_IsInitialisedR_read;
	Tango::DevDouble	*attr_PbmpAxisCurrentPositionU_read;
	Tango::DevDouble	*attr_PbmpAxisCurrentPositionD_read;
	Tango::DevDouble	*attr_PbmpAxisCurrentPositionL_read;
	Tango::DevDouble	*attr_PbmpAxisCurrentPositionR_read;
	Tango::DevDouble	*attr_PbmpCenterV_read;
	Tango::DevDouble	*attr_PbmpCenterH_read;
	Tango::DevDouble	*attr_GapV_read;
	Tango::DevDouble	*attr_GapH_read;
	Tango::DevDouble	*attr_PbmpAxisOffsetU_read;
	Tango::DevDouble	*attr_PbmpAxisOffsetD_read;
	Tango::DevDouble	*attr_PbmpAxisOffsetL_read;
	Tango::DevDouble	*attr_PbmpAxisOffsetR_read;
	Tango::DevShort	*attr_PbmpAxisIsInitialised_read;
	Tango::DevString	*attr_History_read;

//	Constructors and destructors
public:
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	Pbmpaxis(Tango::DeviceClass *cl,string &s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	Pbmpaxis(Tango::DeviceClass *cl,const char *s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device name
	 *	@param d	Device description.
	 */
	Pbmpaxis(Tango::DeviceClass *cl,const char *s,const char *d);
	/**
	 * The device object destructor.
	 */
	~Pbmpaxis() {delete_device();};


//	Miscellaneous methods
public:
	/*
	 *	will be called at device destruction or at init command.
	 */
	void delete_device();
	/*
	 *	Initialize the device
	 */
	virtual void init_device();
	/*
	 *	Read the device properties from database
	 */
	void get_device_property();
	/*
	 *	Always executed method before execution command method.
	 */
	virtual void always_executed_hook();

	/*
	 *	Check if mandatory property has been set
	 */
	 void check_mandatory_property(Tango::DbDatum &class_prop, Tango::DbDatum &dev_prop);

//	Attribute methods
public:
	//--------------------------------------------------------
	/*
	 *	Method      : Pbmpaxis::read_attr_hardware()
	 *	Description : Hardware acquisition for attributes.
	 */
	//--------------------------------------------------------
	virtual void read_attr_hardware(vector<long> &attr_list);
	//--------------------------------------------------------
	/*
	 *	Method      : Pbmpaxis::write_attr_hardware()
	 *	Description : Hardware writing for attributes.
	 */
	//--------------------------------------------------------
	virtual void write_attr_hardware(vector<long> &attr_list);

/**
 *	Attribute AxisCurrentPositionU related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_AxisCurrentPositionU(Tango::Attribute &attr);
	virtual void write_AxisCurrentPositionU(Tango::WAttribute &attr);
	virtual bool is_AxisCurrentPositionU_allowed(Tango::AttReqType type);
/**
 *	Attribute AxisCurrentPositionD related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_AxisCurrentPositionD(Tango::Attribute &attr);
	virtual void write_AxisCurrentPositionD(Tango::WAttribute &attr);
	virtual bool is_AxisCurrentPositionD_allowed(Tango::AttReqType type);
/**
 *	Attribute AxisCurrentPositionL related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_AxisCurrentPositionL(Tango::Attribute &attr);
	virtual void write_AxisCurrentPositionL(Tango::WAttribute &attr);
	virtual bool is_AxisCurrentPositionL_allowed(Tango::AttReqType type);
/**
 *	Attribute AxisCurrentPositionR related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_AxisCurrentPositionR(Tango::Attribute &attr);
	virtual void write_AxisCurrentPositionR(Tango::WAttribute &attr);
	virtual bool is_AxisCurrentPositionR_allowed(Tango::AttReqType type);
/**
 *	Attribute IsInitialisedU related methods
 *	Description: 
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar
 */
	virtual void read_IsInitialisedU(Tango::Attribute &attr);
	virtual bool is_IsInitialisedU_allowed(Tango::AttReqType type);
/**
 *	Attribute IsInitialisedD related methods
 *	Description: 
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar
 */
	virtual void read_IsInitialisedD(Tango::Attribute &attr);
	virtual bool is_IsInitialisedD_allowed(Tango::AttReqType type);
/**
 *	Attribute IsInitialisedL related methods
 *	Description: 
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar
 */
	virtual void read_IsInitialisedL(Tango::Attribute &attr);
	virtual bool is_IsInitialisedL_allowed(Tango::AttReqType type);
/**
 *	Attribute IsInitialisedR related methods
 *	Description: 
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar
 */
	virtual void read_IsInitialisedR(Tango::Attribute &attr);
	virtual bool is_IsInitialisedR_allowed(Tango::AttReqType type);
/**
 *	Attribute PbmpAxisCurrentPositionU related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_PbmpAxisCurrentPositionU(Tango::Attribute &attr);
	virtual void write_PbmpAxisCurrentPositionU(Tango::WAttribute &attr);
	virtual bool is_PbmpAxisCurrentPositionU_allowed(Tango::AttReqType type);
/**
 *	Attribute PbmpAxisCurrentPositionD related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_PbmpAxisCurrentPositionD(Tango::Attribute &attr);
	virtual void write_PbmpAxisCurrentPositionD(Tango::WAttribute &attr);
	virtual bool is_PbmpAxisCurrentPositionD_allowed(Tango::AttReqType type);
/**
 *	Attribute PbmpAxisCurrentPositionL related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_PbmpAxisCurrentPositionL(Tango::Attribute &attr);
	virtual void write_PbmpAxisCurrentPositionL(Tango::WAttribute &attr);
	virtual bool is_PbmpAxisCurrentPositionL_allowed(Tango::AttReqType type);
/**
 *	Attribute PbmpAxisCurrentPositionR related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_PbmpAxisCurrentPositionR(Tango::Attribute &attr);
	virtual void write_PbmpAxisCurrentPositionR(Tango::WAttribute &attr);
	virtual bool is_PbmpAxisCurrentPositionR_allowed(Tango::AttReqType type);
/**
 *	Attribute PbmpCenterV related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_PbmpCenterV(Tango::Attribute &attr);
	virtual void write_PbmpCenterV(Tango::WAttribute &attr);
	virtual bool is_PbmpCenterV_allowed(Tango::AttReqType type);
/**
 *	Attribute PbmpCenterH related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_PbmpCenterH(Tango::Attribute &attr);
	virtual void write_PbmpCenterH(Tango::WAttribute &attr);
	virtual bool is_PbmpCenterH_allowed(Tango::AttReqType type);
/**
 *	Attribute GapV related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_GapV(Tango::Attribute &attr);
	virtual void write_GapV(Tango::WAttribute &attr);
	virtual bool is_GapV_allowed(Tango::AttReqType type);
/**
 *	Attribute GapH related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_GapH(Tango::Attribute &attr);
	virtual void write_GapH(Tango::WAttribute &attr);
	virtual bool is_GapH_allowed(Tango::AttReqType type);
/**
 *	Attribute PbmpAxisOffsetU related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_PbmpAxisOffsetU(Tango::Attribute &attr);
	virtual bool is_PbmpAxisOffsetU_allowed(Tango::AttReqType type);
/**
 *	Attribute PbmpAxisOffsetD related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_PbmpAxisOffsetD(Tango::Attribute &attr);
	virtual bool is_PbmpAxisOffsetD_allowed(Tango::AttReqType type);
/**
 *	Attribute PbmpAxisOffsetL related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_PbmpAxisOffsetL(Tango::Attribute &attr);
	virtual bool is_PbmpAxisOffsetL_allowed(Tango::AttReqType type);
/**
 *	Attribute PbmpAxisOffsetR related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_PbmpAxisOffsetR(Tango::Attribute &attr);
	virtual bool is_PbmpAxisOffsetR_allowed(Tango::AttReqType type);
/**
 *	Attribute PbmpAxisIsInitialised related methods
 *	Description: 
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar
 */
	virtual void read_PbmpAxisIsInitialised(Tango::Attribute &attr);
	virtual bool is_PbmpAxisIsInitialised_allowed(Tango::AttReqType type);
/**
 *	Attribute History related methods
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Spectrum max = 2000
 */
	virtual void read_History(Tango::Attribute &attr);
	virtual bool is_History_allowed(Tango::AttReqType type);


	//--------------------------------------------------------
	/**
	 *	Method      : Pbmpaxis::add_dynamic_attributes()
	 *	Description : Add dynamic attributes if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_attributes();




//	Command related methods
public:
	/**
	 *	Command AxisGetMotionStatusU related method
	 *	Description: Status of the motion : Returned Value is:
	 *               -1 motion state unknown because communication is broken
	 *               0 motion ended with success
	 *               1 positionning motion running
	 *
	 *	@returns numerical code representing the status of the motion
	 */
	virtual Tango::DevLong axis_get_motion_status_u();
	virtual bool is_AxisGetMotionStatusU_allowed(const CORBA::Any &any);
	/**
	 *	Command AxisGetMotionStatusD related method
	 *	Description: Status of the motion : Returned Value is:
	 *               -1 motion state unknown because communication is broken
	 *               0 motion ended with success
	 *               1 positionning motion running
	 *
	 *	@returns numerical code representing the status of the motion
	 */
	virtual Tango::DevLong axis_get_motion_status_d();
	virtual bool is_AxisGetMotionStatusD_allowed(const CORBA::Any &any);
	/**
	 *	Command AxisGetMotionStatusL related method
	 *	Description: Status of the motion : Returned Value is:
	 *               -1 motion state unknown because communication is broken
	 *               0 motion ended with success
	 *               1 positionning motion running
	 *
	 *	@returns numerical code representing the status of the motion
	 */
	virtual Tango::DevLong axis_get_motion_status_l();
	virtual bool is_AxisGetMotionStatusL_allowed(const CORBA::Any &any);
	/**
	 *	Command AxisGetMotionStatusR related method
	 *	Description: Status of the motion : Returned Value is:
	 *               -1 motion state unknown because communication is broken
	 *               0 motion ended with success
	 *               1 positionning motion running
	 *
	 *	@returns numerical code representing the status of the motion
	 */
	virtual Tango::DevLong axis_get_motion_status_r();
	virtual bool is_AxisGetMotionStatusR_allowed(const CORBA::Any &any);
	/**
	 *	Command AxisInitU related method
	 *	Description: 
	 *
	 */
	virtual void axis_init_u();
	virtual bool is_AxisInitU_allowed(const CORBA::Any &any);
	/**
	 *	Command AxisInitD related method
	 *	Description: 
	 *
	 */
	virtual void axis_init_d();
	virtual bool is_AxisInitD_allowed(const CORBA::Any &any);
	/**
	 *	Command AxisInitL related method
	 *	Description: 
	 *
	 */
	virtual void axis_init_l();
	virtual bool is_AxisInitL_allowed(const CORBA::Any &any);
	/**
	 *	Command AxisInitR related method
	 *	Description: 
	 *
	 */
	virtual void axis_init_r();
	virtual bool is_AxisInitR_allowed(const CORBA::Any &any);
	/**
	 *	Command AxisStopU related method
	 *	Description: 
	 *
	 */
	virtual void axis_stop_u();
	virtual bool is_AxisStopU_allowed(const CORBA::Any &any);
	/**
	 *	Command AxisStopD related method
	 *	Description: 
	 *
	 */
	virtual void axis_stop_d();
	virtual bool is_AxisStopD_allowed(const CORBA::Any &any);
	/**
	 *	Command AxisStopL related method
	 *	Description: 
	 *
	 */
	virtual void axis_stop_l();
	virtual bool is_AxisStopL_allowed(const CORBA::Any &any);
	/**
	 *	Command AxisStopR related method
	 *	Description: 
	 *
	 */
	virtual void axis_stop_r();
	virtual bool is_AxisStopR_allowed(const CORBA::Any &any);
	/**
	 *	Command MotorONU related method
	 *	Description: enables the power amplifier of the motor
	 *
	 */
	virtual void motor_onu();
	virtual bool is_MotorONU_allowed(const CORBA::Any &any);
	/**
	 *	Command MotorOND related method
	 *	Description: enables the power amplifier of the motor
	 *
	 */
	virtual void motor_ond();
	virtual bool is_MotorOND_allowed(const CORBA::Any &any);
	/**
	 *	Command MotorONL related method
	 *	Description: enables the power amplifier of the motor
	 *
	 */
	virtual void motor_onl();
	virtual bool is_MotorONL_allowed(const CORBA::Any &any);
	/**
	 *	Command MotorONR related method
	 *	Description: enables the power amplifier of the motor
	 *
	 */
	virtual void motor_onr();
	virtual bool is_MotorONR_allowed(const CORBA::Any &any);
	/**
	 *	Command MotorOFFU related method
	 *	Description: disable the power amplifier of the motor
	 *
	 */
	virtual void motor_offu();
	virtual bool is_MotorOFFU_allowed(const CORBA::Any &any);
	/**
	 *	Command MotorOFFD related method
	 *	Description: disable the power amplifier of the motor
	 *
	 */
	virtual void motor_offd();
	virtual bool is_MotorOFFD_allowed(const CORBA::Any &any);
	/**
	 *	Command MotorOFFL related method
	 *	Description: disable the power amplifier of the motor
	 *
	 */
	virtual void motor_offl();
	virtual bool is_MotorOFFL_allowed(const CORBA::Any &any);
	/**
	 *	Command MotorOFFR related method
	 *	Description: disable the power amplifier of the motor
	 *
	 */
	virtual void motor_offr();
	virtual bool is_MotorOFFR_allowed(const CORBA::Any &any);
	/**
	 *	Command PbmpAxisDefineOffsetU related method
	 *	Description: 
	 *
	 *	@param argin 
	 */
	virtual void pbmp_axis_define_offset_u(Tango::DevDouble argin);
	virtual bool is_PbmpAxisDefineOffsetU_allowed(const CORBA::Any &any);
	/**
	 *	Command PbmpAxisDefineOffsetD related method
	 *	Description: 
	 *
	 *	@param argin 
	 */
	virtual void pbmp_axis_define_offset_d(Tango::DevDouble argin);
	virtual bool is_PbmpAxisDefineOffsetD_allowed(const CORBA::Any &any);
	/**
	 *	Command PbmpAxisDefineOffsetL related method
	 *	Description: 
	 *
	 *	@param argin 
	 */
	virtual void pbmp_axis_define_offset_l(Tango::DevDouble argin);
	virtual bool is_PbmpAxisDefineOffsetL_allowed(const CORBA::Any &any);
	/**
	 *	Command PbmpAxisDefineOffsetR related method
	 *	Description: 
	 *
	 *	@param argin 
	 */
	virtual void pbmp_axis_define_offset_r(Tango::DevDouble argin);
	virtual bool is_PbmpAxisDefineOffsetR_allowed(const CORBA::Any &any);
	/**
	 *	Command PbmpDefineZeroU related method
	 *	Description: 
	 *
	 */
	virtual void pbmp_define_zero_u();
	virtual bool is_PbmpDefineZeroU_allowed(const CORBA::Any &any);
	/**
	 *	Command PbmpDefineZeroD related method
	 *	Description: 
	 *
	 */
	virtual void pbmp_define_zero_d();
	virtual bool is_PbmpDefineZeroD_allowed(const CORBA::Any &any);
	/**
	 *	Command PbmpDefineZeroL related method
	 *	Description: 
	 *
	 */
	virtual void pbmp_define_zero_l();
	virtual bool is_PbmpDefineZeroL_allowed(const CORBA::Any &any);
	/**
	 *	Command PbmpDefineZeroR related method
	 *	Description: 
	 *
	 */
	virtual void pbmp_define_zero_r();
	virtual bool is_PbmpDefineZeroR_allowed(const CORBA::Any &any);
	/**
	 *	Command PbmpCenterVGoToPosition related method
	 *	Description: 
	 *
	 *	@param argin 
	 */
	virtual void pbmp_center_vgo_to_position(Tango::DevDouble argin);
	virtual bool is_PbmpCenterVGoToPosition_allowed(const CORBA::Any &any);
	/**
	 *	Command PbmpCenterHGoToPosition related method
	 *	Description: 
	 *
	 *	@param argin 
	 */
	virtual void pbmp_center_hgo_to_position(Tango::DevDouble argin);
	virtual bool is_PbmpCenterHGoToPosition_allowed(const CORBA::Any &any);
	/**
	 *	Command PbmpGapV related method
	 *	Description: 
	 *
	 *	@param argin 
	 */
	virtual void pbmp_gap_v(Tango::DevDouble argin);
	virtual bool is_PbmpGapV_allowed(const CORBA::Any &any);
	/**
	 *	Command PbmpGapH related method
	 *	Description: 
	 *
	 *	@param argin 
	 */
	virtual void pbmp_gap_h(Tango::DevDouble argin);
	virtual bool is_PbmpGapH_allowed(const CORBA::Any &any);
	/**
	 *	Command PbmpAxisStop related method
	 *	Description: 
	 *
	 */
	virtual void pbmp_axis_stop();
	virtual bool is_PbmpAxisStop_allowed(const CORBA::Any &any);


	//--------------------------------------------------------
	/**
	 *	Method      : Pbmpaxis::add_dynamic_commands()
	 *	Description : Add dynamic commands if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_commands();

/*----- PROTECTED REGION ID(Pbmpaxis::Additional Method prototypes) ENABLED START -----*/

//	Additional Method prototypes
protected :	
	void print_error_msg(const std::string, const std::string, const std::string);
	void print_error_msg(const std::string, const std::string, const std::string, Tango::DevState);
	void exception_handler(Tango::DevFailed &e, Tango::DevState, const std::string base_msg);

private:
	Tango::DeviceProxy* axisU_proxy;
	Tango::DeviceProxy* axisD_proxy;
	Tango::DeviceProxy* axisL_proxy;
	Tango::DeviceProxy* axisR_proxy;

	Tango::DevState axisU_state;
	Tango::DevState axisD_state;
	Tango::DevState axisL_state;
	Tango::DevState axisR_state;

	string axisU_status;
	string axisD_status;
	string axisL_status;
	string axisR_status;

	double axisU_m;
	double axisD_m;
	double axisL_m;
	double axisR_m;

	double axisU_q;
	double axisD_q;
	double axisL_q;
	double axisR_q;

	double GAP_V_MIN_VAL;
	double GAP_H_MIN_VAL;

/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::Additional Method prototypes
};

/*----- PROTECTED REGION ID(Pbmpaxis::Additional Classes Definitions) ENABLED START -----*/

//	Additional Classes Definitions

/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::Additional Classes Definitions

}	//	End of namespace

#endif   //	Pbmpaxis_H
