/*----- PROTECTED REGION ID(PbmpaxisClass.cpp) ENABLED START -----*/
//=============================================================================
//
// file :        PbmpaxisClass.cpp
//
// description : C++ source for the PbmpaxisClass.
//               A singleton class derived from DeviceClass.
//               It implements the command and attribute list
//               and all properties and methods required
//               by the Pbmpaxis once per process.
//
// project :     Photon beam monitor position
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <tango.h>
#include <Pbmpaxis.h>
#include <PbmpaxisClass.h>

/*----- PROTECTED REGION END -----*/	//	PbmpaxisClass.cpp

//-------------------------------------------------------------------
/**
 *	Create PbmpaxisClass singleton and
 *	return it in a C function for Python usage
 */
//-------------------------------------------------------------------
extern "C" {
#ifdef _TG_WINDOWS_

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_Pbmpaxis_class(const char *name) {
		return Pbmpaxis_ns::PbmpaxisClass::init(name);
	}
}

namespace Pbmpaxis_ns
{
//===================================================================
//	Initialize pointer for singleton pattern
//===================================================================
PbmpaxisClass *PbmpaxisClass::_instance = NULL;

//--------------------------------------------------------
/**
 * method : 		PbmpaxisClass::PbmpaxisClass(string &s)
 * description : 	constructor for the PbmpaxisClass
 *
 * @param s	The class name
 */
//--------------------------------------------------------
PbmpaxisClass::PbmpaxisClass(string &s):Tango::DeviceClass(s)
{
	cout2 << "Entering PbmpaxisClass constructor" << endl;
	set_default_property();
	write_class_property();

	/*----- PROTECTED REGION ID(PbmpaxisClass::constructor) ENABLED START -----*/

        // version tag

        string Release(RELEASE);
        set_cvs_tag(Release);

        string Repository(REPO);
        set_cvs_location(Repository);

        doc_url = REPO;

	
	/*----- PROTECTED REGION END -----*/	//	PbmpaxisClass::constructor

	cout2 << "Leaving PbmpaxisClass constructor" << endl;
}

//--------------------------------------------------------
/**
 * method : 		PbmpaxisClass::~PbmpaxisClass()
 * description : 	destructor for the PbmpaxisClass
 */
//--------------------------------------------------------
PbmpaxisClass::~PbmpaxisClass()
{
	/*----- PROTECTED REGION ID(PbmpaxisClass::destructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	PbmpaxisClass::destructor

	_instance = NULL;
}


//--------------------------------------------------------
/**
 * method : 		PbmpaxisClass::init
 * description : 	Create the object if not already done.
 *                  Otherwise, just return a pointer to the object
 *
 * @param	name	The class name
 */
//--------------------------------------------------------
PbmpaxisClass *PbmpaxisClass::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new PbmpaxisClass(s);
		}
		catch (bad_alloc &)
		{
			throw;
		}
	}
	return _instance;
}

//--------------------------------------------------------
/**
 * method : 		PbmpaxisClass::instance
 * description : 	Check if object already created,
 *                  and return a pointer to the object
 */
//--------------------------------------------------------
PbmpaxisClass *PbmpaxisClass::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}



//===================================================================
//	Command execution method calls
//===================================================================
//--------------------------------------------------------
/**
 * method : 		AxisGetMotionStatusUClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *AxisGetMotionStatusUClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "AxisGetMotionStatusUClass::execute(): arrived" << endl;
	return insert((static_cast<Pbmpaxis *>(device))->axis_get_motion_status_u());
}

//--------------------------------------------------------
/**
 * method : 		AxisGetMotionStatusDClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *AxisGetMotionStatusDClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "AxisGetMotionStatusDClass::execute(): arrived" << endl;
	return insert((static_cast<Pbmpaxis *>(device))->axis_get_motion_status_d());
}

//--------------------------------------------------------
/**
 * method : 		AxisGetMotionStatusLClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *AxisGetMotionStatusLClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "AxisGetMotionStatusLClass::execute(): arrived" << endl;
	return insert((static_cast<Pbmpaxis *>(device))->axis_get_motion_status_l());
}

//--------------------------------------------------------
/**
 * method : 		AxisGetMotionStatusRClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *AxisGetMotionStatusRClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "AxisGetMotionStatusRClass::execute(): arrived" << endl;
	return insert((static_cast<Pbmpaxis *>(device))->axis_get_motion_status_r());
}

//--------------------------------------------------------
/**
 * method : 		AxisInitUClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *AxisInitUClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "AxisInitUClass::execute(): arrived" << endl;
	((static_cast<Pbmpaxis *>(device))->axis_init_u());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		AxisInitDClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *AxisInitDClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "AxisInitDClass::execute(): arrived" << endl;
	((static_cast<Pbmpaxis *>(device))->axis_init_d());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		AxisInitLClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *AxisInitLClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "AxisInitLClass::execute(): arrived" << endl;
	((static_cast<Pbmpaxis *>(device))->axis_init_l());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		AxisInitRClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *AxisInitRClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "AxisInitRClass::execute(): arrived" << endl;
	((static_cast<Pbmpaxis *>(device))->axis_init_r());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		AxisStopUClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *AxisStopUClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "AxisStopUClass::execute(): arrived" << endl;
	((static_cast<Pbmpaxis *>(device))->axis_stop_u());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		AxisStopDClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *AxisStopDClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "AxisStopDClass::execute(): arrived" << endl;
	((static_cast<Pbmpaxis *>(device))->axis_stop_d());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		AxisStopLClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *AxisStopLClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "AxisStopLClass::execute(): arrived" << endl;
	((static_cast<Pbmpaxis *>(device))->axis_stop_l());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		AxisStopRClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *AxisStopRClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "AxisStopRClass::execute(): arrived" << endl;
	((static_cast<Pbmpaxis *>(device))->axis_stop_r());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		MotorONUClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *MotorONUClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "MotorONUClass::execute(): arrived" << endl;
	((static_cast<Pbmpaxis *>(device))->motor_onu());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		MotorONDClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *MotorONDClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "MotorONDClass::execute(): arrived" << endl;
	((static_cast<Pbmpaxis *>(device))->motor_ond());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		MotorONLClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *MotorONLClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "MotorONLClass::execute(): arrived" << endl;
	((static_cast<Pbmpaxis *>(device))->motor_onl());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		MotorONRClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *MotorONRClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "MotorONRClass::execute(): arrived" << endl;
	((static_cast<Pbmpaxis *>(device))->motor_onr());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		MotorOFFUClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *MotorOFFUClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "MotorOFFUClass::execute(): arrived" << endl;
	((static_cast<Pbmpaxis *>(device))->motor_offu());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		MotorOFFDClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *MotorOFFDClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "MotorOFFDClass::execute(): arrived" << endl;
	((static_cast<Pbmpaxis *>(device))->motor_offd());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		MotorOFFLClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *MotorOFFLClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "MotorOFFLClass::execute(): arrived" << endl;
	((static_cast<Pbmpaxis *>(device))->motor_offl());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		MotorOFFRClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *MotorOFFRClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "MotorOFFRClass::execute(): arrived" << endl;
	((static_cast<Pbmpaxis *>(device))->motor_offr());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		PbmpAxisDefineOffsetUClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *PbmpAxisDefineOffsetUClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "PbmpAxisDefineOffsetUClass::execute(): arrived" << endl;
	Tango::DevDouble argin;
	extract(in_any, argin);
	((static_cast<Pbmpaxis *>(device))->pbmp_axis_define_offset_u(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		PbmpAxisDefineOffsetDClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *PbmpAxisDefineOffsetDClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "PbmpAxisDefineOffsetDClass::execute(): arrived" << endl;
	Tango::DevDouble argin;
	extract(in_any, argin);
	((static_cast<Pbmpaxis *>(device))->pbmp_axis_define_offset_d(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		PbmpAxisDefineOffsetLClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *PbmpAxisDefineOffsetLClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "PbmpAxisDefineOffsetLClass::execute(): arrived" << endl;
	Tango::DevDouble argin;
	extract(in_any, argin);
	((static_cast<Pbmpaxis *>(device))->pbmp_axis_define_offset_l(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		PbmpAxisDefineOffsetRClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *PbmpAxisDefineOffsetRClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "PbmpAxisDefineOffsetRClass::execute(): arrived" << endl;
	Tango::DevDouble argin;
	extract(in_any, argin);
	((static_cast<Pbmpaxis *>(device))->pbmp_axis_define_offset_r(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		PbmpDefineZeroUClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *PbmpDefineZeroUClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "PbmpDefineZeroUClass::execute(): arrived" << endl;
	((static_cast<Pbmpaxis *>(device))->pbmp_define_zero_u());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		PbmpDefineZeroDClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *PbmpDefineZeroDClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "PbmpDefineZeroDClass::execute(): arrived" << endl;
	((static_cast<Pbmpaxis *>(device))->pbmp_define_zero_d());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		PbmpDefineZeroLClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *PbmpDefineZeroLClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "PbmpDefineZeroLClass::execute(): arrived" << endl;
	((static_cast<Pbmpaxis *>(device))->pbmp_define_zero_l());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		PbmpDefineZeroRClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *PbmpDefineZeroRClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "PbmpDefineZeroRClass::execute(): arrived" << endl;
	((static_cast<Pbmpaxis *>(device))->pbmp_define_zero_r());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		PbmpCenterVGoToPositionClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *PbmpCenterVGoToPositionClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "PbmpCenterVGoToPositionClass::execute(): arrived" << endl;
	Tango::DevDouble argin;
	extract(in_any, argin);
	((static_cast<Pbmpaxis *>(device))->pbmp_center_vgo_to_position(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		PbmpCenterHGoToPositionClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *PbmpCenterHGoToPositionClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "PbmpCenterHGoToPositionClass::execute(): arrived" << endl;
	Tango::DevDouble argin;
	extract(in_any, argin);
	((static_cast<Pbmpaxis *>(device))->pbmp_center_hgo_to_position(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		PbmpGapVClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *PbmpGapVClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "PbmpGapVClass::execute(): arrived" << endl;
	Tango::DevDouble argin;
	extract(in_any, argin);
	((static_cast<Pbmpaxis *>(device))->pbmp_gap_v(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		PbmpGapHClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *PbmpGapHClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "PbmpGapHClass::execute(): arrived" << endl;
	Tango::DevDouble argin;
	extract(in_any, argin);
	((static_cast<Pbmpaxis *>(device))->pbmp_gap_h(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		PbmpAxisStopClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *PbmpAxisStopClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "PbmpAxisStopClass::execute(): arrived" << endl;
	((static_cast<Pbmpaxis *>(device))->pbmp_axis_stop());
	return new CORBA::Any();
}


//===================================================================
//	Properties management
//===================================================================
//--------------------------------------------------------
/**
 *	Method      : PbmpaxisClass::get_class_property()
 *	Description : Get the class property for specified name.
 */
//--------------------------------------------------------
Tango::DbDatum PbmpaxisClass::get_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, returns  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : PbmpaxisClass::get_default_device_property()
 *	Description : Return the default value for device property.
 */
//--------------------------------------------------------
Tango::DbDatum PbmpaxisClass::get_default_device_property(string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : PbmpaxisClass::get_default_class_property()
 *	Description : Return the default value for class property.
 */
//--------------------------------------------------------
Tango::DbDatum PbmpaxisClass::get_default_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}


//--------------------------------------------------------
/**
 *	Method      : PbmpaxisClass::set_default_property()
 *	Description : Set default property (class and device) for wizard.
 *                For each property, add to wizard property name and description.
 *                If default value has been set, add it to wizard property and
 *                store it in a DbDatum.
 */
//--------------------------------------------------------
void PbmpaxisClass::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;
	vector<string>	vect_data;

	//	Set Default Class Properties

	//	Set Default device Properties
	prop_name = "AxisU";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "AxisD";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "AxisL";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "AxisR";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "TrasfAxisU";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "TrasfAxisD";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "TrasfAxisL";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "TrasfAxisR";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "Timeout";
	prop_desc = "";
	prop_def  = "3000";
	vect_data.clear();
	vect_data.push_back("3000");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
}

//--------------------------------------------------------
/**
 *	Method      : PbmpaxisClass::write_class_property()
 *	Description : Set class description fields as property in database
 */
//--------------------------------------------------------
void PbmpaxisClass::write_class_property()
{
	//	First time, check if database used
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("Photon beam monitor position");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("Photon beam monitor position axis mover. Works on galilaxis.");
	description << str_desc;
	data.push_back(description);

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("TANGO_BASE_CLASS");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	get_db_class()->put_property(data);
}

//===================================================================
//	Factory methods
//===================================================================

//--------------------------------------------------------
/**
 *	Method      : PbmpaxisClass::device_factory()
 *	Description : Create the device object(s)
 *                and store them in the device list
 */
//--------------------------------------------------------
void PbmpaxisClass::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{
	/*----- PROTECTED REGION ID(PbmpaxisClass::device_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	PbmpaxisClass::device_factory_before

	//	Create devices and add it into the device list
	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
		device_list.push_back(new Pbmpaxis(this, (*devlist_ptr)[i]));
	}

	//	Manage dynamic attributes if any
	erase_dynamic_attributes(devlist_ptr, get_class_attr()->get_attr_list());

	//	Export devices to the outside world
	for (unsigned long i=1 ; i<=devlist_ptr->length() ; i++)
	{
		//	Add dynamic attributes if any
		Pbmpaxis *dev = static_cast<Pbmpaxis *>(device_list[device_list.size()-i]);
		dev->add_dynamic_attributes();

		//	Check before if database used.
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(dev);
		else
			export_device(dev, dev->get_name().c_str());
	}

	/*----- PROTECTED REGION ID(PbmpaxisClass::device_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	PbmpaxisClass::device_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : PbmpaxisClass::attribute_factory()
 *	Description : Create the attribute object(s)
 *                and store them in the attribute list
 */
//--------------------------------------------------------
void PbmpaxisClass::attribute_factory(vector<Tango::Attr *> &att_list)
{
	/*----- PROTECTED REGION ID(PbmpaxisClass::attribute_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	PbmpaxisClass::attribute_factory_before
	//	Attribute : AxisCurrentPositionU
	AxisCurrentPositionUAttrib	*axiscurrentpositionu = new AxisCurrentPositionUAttrib();
	Tango::UserDefaultAttrProp	axiscurrentpositionu_prop;
	//	description	not set for AxisCurrentPositionU
	//	label	not set for AxisCurrentPositionU
	//	unit	not set for AxisCurrentPositionU
	//	standard_unit	not set for AxisCurrentPositionU
	//	display_unit	not set for AxisCurrentPositionU
	//	format	not set for AxisCurrentPositionU
	//	max_value	not set for AxisCurrentPositionU
	//	min_value	not set for AxisCurrentPositionU
	//	max_alarm	not set for AxisCurrentPositionU
	//	min_alarm	not set for AxisCurrentPositionU
	//	max_warning	not set for AxisCurrentPositionU
	//	min_warning	not set for AxisCurrentPositionU
	//	delta_t	not set for AxisCurrentPositionU
	//	delta_val	not set for AxisCurrentPositionU
	
	axiscurrentpositionu->set_default_properties(axiscurrentpositionu_prop);
	//	Not Polled
	axiscurrentpositionu->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(axiscurrentpositionu);

	//	Attribute : AxisCurrentPositionD
	AxisCurrentPositionDAttrib	*axiscurrentpositiond = new AxisCurrentPositionDAttrib();
	Tango::UserDefaultAttrProp	axiscurrentpositiond_prop;
	//	description	not set for AxisCurrentPositionD
	//	label	not set for AxisCurrentPositionD
	//	unit	not set for AxisCurrentPositionD
	//	standard_unit	not set for AxisCurrentPositionD
	//	display_unit	not set for AxisCurrentPositionD
	//	format	not set for AxisCurrentPositionD
	//	max_value	not set for AxisCurrentPositionD
	//	min_value	not set for AxisCurrentPositionD
	//	max_alarm	not set for AxisCurrentPositionD
	//	min_alarm	not set for AxisCurrentPositionD
	//	max_warning	not set for AxisCurrentPositionD
	//	min_warning	not set for AxisCurrentPositionD
	//	delta_t	not set for AxisCurrentPositionD
	//	delta_val	not set for AxisCurrentPositionD
	
	axiscurrentpositiond->set_default_properties(axiscurrentpositiond_prop);
	//	Not Polled
	axiscurrentpositiond->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(axiscurrentpositiond);

	//	Attribute : AxisCurrentPositionL
	AxisCurrentPositionLAttrib	*axiscurrentpositionl = new AxisCurrentPositionLAttrib();
	Tango::UserDefaultAttrProp	axiscurrentpositionl_prop;
	//	description	not set for AxisCurrentPositionL
	//	label	not set for AxisCurrentPositionL
	//	unit	not set for AxisCurrentPositionL
	//	standard_unit	not set for AxisCurrentPositionL
	//	display_unit	not set for AxisCurrentPositionL
	//	format	not set for AxisCurrentPositionL
	//	max_value	not set for AxisCurrentPositionL
	//	min_value	not set for AxisCurrentPositionL
	//	max_alarm	not set for AxisCurrentPositionL
	//	min_alarm	not set for AxisCurrentPositionL
	//	max_warning	not set for AxisCurrentPositionL
	//	min_warning	not set for AxisCurrentPositionL
	//	delta_t	not set for AxisCurrentPositionL
	//	delta_val	not set for AxisCurrentPositionL
	
	axiscurrentpositionl->set_default_properties(axiscurrentpositionl_prop);
	//	Not Polled
	axiscurrentpositionl->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(axiscurrentpositionl);

	//	Attribute : AxisCurrentPositionR
	AxisCurrentPositionRAttrib	*axiscurrentpositionr = new AxisCurrentPositionRAttrib();
	Tango::UserDefaultAttrProp	axiscurrentpositionr_prop;
	//	description	not set for AxisCurrentPositionR
	//	label	not set for AxisCurrentPositionR
	//	unit	not set for AxisCurrentPositionR
	//	standard_unit	not set for AxisCurrentPositionR
	//	display_unit	not set for AxisCurrentPositionR
	//	format	not set for AxisCurrentPositionR
	//	max_value	not set for AxisCurrentPositionR
	//	min_value	not set for AxisCurrentPositionR
	//	max_alarm	not set for AxisCurrentPositionR
	//	min_alarm	not set for AxisCurrentPositionR
	//	max_warning	not set for AxisCurrentPositionR
	//	min_warning	not set for AxisCurrentPositionR
	//	delta_t	not set for AxisCurrentPositionR
	//	delta_val	not set for AxisCurrentPositionR
	
	axiscurrentpositionr->set_default_properties(axiscurrentpositionr_prop);
	//	Not Polled
	axiscurrentpositionr->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(axiscurrentpositionr);

	//	Attribute : IsInitialisedU
	IsInitialisedUAttrib	*isinitialisedu = new IsInitialisedUAttrib();
	Tango::UserDefaultAttrProp	isinitialisedu_prop;
	//	description	not set for IsInitialisedU
	//	label	not set for IsInitialisedU
	//	unit	not set for IsInitialisedU
	//	standard_unit	not set for IsInitialisedU
	//	display_unit	not set for IsInitialisedU
	//	format	not set for IsInitialisedU
	//	max_value	not set for IsInitialisedU
	//	min_value	not set for IsInitialisedU
	//	max_alarm	not set for IsInitialisedU
	//	min_alarm	not set for IsInitialisedU
	//	max_warning	not set for IsInitialisedU
	//	min_warning	not set for IsInitialisedU
	//	delta_t	not set for IsInitialisedU
	//	delta_val	not set for IsInitialisedU
	
	isinitialisedu->set_default_properties(isinitialisedu_prop);
	//	Not Polled
	isinitialisedu->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(isinitialisedu);

	//	Attribute : IsInitialisedD
	IsInitialisedDAttrib	*isinitialisedd = new IsInitialisedDAttrib();
	Tango::UserDefaultAttrProp	isinitialisedd_prop;
	//	description	not set for IsInitialisedD
	//	label	not set for IsInitialisedD
	//	unit	not set for IsInitialisedD
	//	standard_unit	not set for IsInitialisedD
	//	display_unit	not set for IsInitialisedD
	//	format	not set for IsInitialisedD
	//	max_value	not set for IsInitialisedD
	//	min_value	not set for IsInitialisedD
	//	max_alarm	not set for IsInitialisedD
	//	min_alarm	not set for IsInitialisedD
	//	max_warning	not set for IsInitialisedD
	//	min_warning	not set for IsInitialisedD
	//	delta_t	not set for IsInitialisedD
	//	delta_val	not set for IsInitialisedD
	
	isinitialisedd->set_default_properties(isinitialisedd_prop);
	//	Not Polled
	isinitialisedd->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(isinitialisedd);

	//	Attribute : IsInitialisedL
	IsInitialisedLAttrib	*isinitialisedl = new IsInitialisedLAttrib();
	Tango::UserDefaultAttrProp	isinitialisedl_prop;
	//	description	not set for IsInitialisedL
	//	label	not set for IsInitialisedL
	//	unit	not set for IsInitialisedL
	//	standard_unit	not set for IsInitialisedL
	//	display_unit	not set for IsInitialisedL
	//	format	not set for IsInitialisedL
	//	max_value	not set for IsInitialisedL
	//	min_value	not set for IsInitialisedL
	//	max_alarm	not set for IsInitialisedL
	//	min_alarm	not set for IsInitialisedL
	//	max_warning	not set for IsInitialisedL
	//	min_warning	not set for IsInitialisedL
	//	delta_t	not set for IsInitialisedL
	//	delta_val	not set for IsInitialisedL
	
	isinitialisedl->set_default_properties(isinitialisedl_prop);
	//	Not Polled
	isinitialisedl->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(isinitialisedl);

	//	Attribute : IsInitialisedR
	IsInitialisedRAttrib	*isinitialisedr = new IsInitialisedRAttrib();
	Tango::UserDefaultAttrProp	isinitialisedr_prop;
	//	description	not set for IsInitialisedR
	//	label	not set for IsInitialisedR
	//	unit	not set for IsInitialisedR
	//	standard_unit	not set for IsInitialisedR
	//	display_unit	not set for IsInitialisedR
	//	format	not set for IsInitialisedR
	//	max_value	not set for IsInitialisedR
	//	min_value	not set for IsInitialisedR
	//	max_alarm	not set for IsInitialisedR
	//	min_alarm	not set for IsInitialisedR
	//	max_warning	not set for IsInitialisedR
	//	min_warning	not set for IsInitialisedR
	//	delta_t	not set for IsInitialisedR
	//	delta_val	not set for IsInitialisedR
	
	isinitialisedr->set_default_properties(isinitialisedr_prop);
	//	Not Polled
	isinitialisedr->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(isinitialisedr);

	//	Attribute : PbmpAxisCurrentPositionU
	PbmpAxisCurrentPositionUAttrib	*pbmpaxiscurrentpositionu = new PbmpAxisCurrentPositionUAttrib();
	Tango::UserDefaultAttrProp	pbmpaxiscurrentpositionu_prop;
	//	description	not set for PbmpAxisCurrentPositionU
	//	label	not set for PbmpAxisCurrentPositionU
	//	unit	not set for PbmpAxisCurrentPositionU
	//	standard_unit	not set for PbmpAxisCurrentPositionU
	//	display_unit	not set for PbmpAxisCurrentPositionU
	//	format	not set for PbmpAxisCurrentPositionU
	//	max_value	not set for PbmpAxisCurrentPositionU
	//	min_value	not set for PbmpAxisCurrentPositionU
	//	max_alarm	not set for PbmpAxisCurrentPositionU
	//	min_alarm	not set for PbmpAxisCurrentPositionU
	//	max_warning	not set for PbmpAxisCurrentPositionU
	//	min_warning	not set for PbmpAxisCurrentPositionU
	//	delta_t	not set for PbmpAxisCurrentPositionU
	//	delta_val	not set for PbmpAxisCurrentPositionU
	
	pbmpaxiscurrentpositionu->set_default_properties(pbmpaxiscurrentpositionu_prop);
	//	Not Polled
	pbmpaxiscurrentpositionu->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(pbmpaxiscurrentpositionu);

	//	Attribute : PbmpAxisCurrentPositionD
	PbmpAxisCurrentPositionDAttrib	*pbmpaxiscurrentpositiond = new PbmpAxisCurrentPositionDAttrib();
	Tango::UserDefaultAttrProp	pbmpaxiscurrentpositiond_prop;
	//	description	not set for PbmpAxisCurrentPositionD
	//	label	not set for PbmpAxisCurrentPositionD
	//	unit	not set for PbmpAxisCurrentPositionD
	//	standard_unit	not set for PbmpAxisCurrentPositionD
	//	display_unit	not set for PbmpAxisCurrentPositionD
	//	format	not set for PbmpAxisCurrentPositionD
	//	max_value	not set for PbmpAxisCurrentPositionD
	//	min_value	not set for PbmpAxisCurrentPositionD
	//	max_alarm	not set for PbmpAxisCurrentPositionD
	//	min_alarm	not set for PbmpAxisCurrentPositionD
	//	max_warning	not set for PbmpAxisCurrentPositionD
	//	min_warning	not set for PbmpAxisCurrentPositionD
	//	delta_t	not set for PbmpAxisCurrentPositionD
	//	delta_val	not set for PbmpAxisCurrentPositionD
	
	pbmpaxiscurrentpositiond->set_default_properties(pbmpaxiscurrentpositiond_prop);
	//	Not Polled
	pbmpaxiscurrentpositiond->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(pbmpaxiscurrentpositiond);

	//	Attribute : PbmpAxisCurrentPositionL
	PbmpAxisCurrentPositionLAttrib	*pbmpaxiscurrentpositionl = new PbmpAxisCurrentPositionLAttrib();
	Tango::UserDefaultAttrProp	pbmpaxiscurrentpositionl_prop;
	//	description	not set for PbmpAxisCurrentPositionL
	//	label	not set for PbmpAxisCurrentPositionL
	//	unit	not set for PbmpAxisCurrentPositionL
	//	standard_unit	not set for PbmpAxisCurrentPositionL
	//	display_unit	not set for PbmpAxisCurrentPositionL
	//	format	not set for PbmpAxisCurrentPositionL
	//	max_value	not set for PbmpAxisCurrentPositionL
	//	min_value	not set for PbmpAxisCurrentPositionL
	//	max_alarm	not set for PbmpAxisCurrentPositionL
	//	min_alarm	not set for PbmpAxisCurrentPositionL
	//	max_warning	not set for PbmpAxisCurrentPositionL
	//	min_warning	not set for PbmpAxisCurrentPositionL
	//	delta_t	not set for PbmpAxisCurrentPositionL
	//	delta_val	not set for PbmpAxisCurrentPositionL
	
	pbmpaxiscurrentpositionl->set_default_properties(pbmpaxiscurrentpositionl_prop);
	//	Not Polled
	pbmpaxiscurrentpositionl->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(pbmpaxiscurrentpositionl);

	//	Attribute : PbmpAxisCurrentPositionR
	PbmpAxisCurrentPositionRAttrib	*pbmpaxiscurrentpositionr = new PbmpAxisCurrentPositionRAttrib();
	Tango::UserDefaultAttrProp	pbmpaxiscurrentpositionr_prop;
	//	description	not set for PbmpAxisCurrentPositionR
	//	label	not set for PbmpAxisCurrentPositionR
	//	unit	not set for PbmpAxisCurrentPositionR
	//	standard_unit	not set for PbmpAxisCurrentPositionR
	//	display_unit	not set for PbmpAxisCurrentPositionR
	//	format	not set for PbmpAxisCurrentPositionR
	//	max_value	not set for PbmpAxisCurrentPositionR
	//	min_value	not set for PbmpAxisCurrentPositionR
	//	max_alarm	not set for PbmpAxisCurrentPositionR
	//	min_alarm	not set for PbmpAxisCurrentPositionR
	//	max_warning	not set for PbmpAxisCurrentPositionR
	//	min_warning	not set for PbmpAxisCurrentPositionR
	//	delta_t	not set for PbmpAxisCurrentPositionR
	//	delta_val	not set for PbmpAxisCurrentPositionR
	
	pbmpaxiscurrentpositionr->set_default_properties(pbmpaxiscurrentpositionr_prop);
	//	Not Polled
	pbmpaxiscurrentpositionr->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(pbmpaxiscurrentpositionr);

	//	Attribute : PbmpCenterV
	PbmpCenterVAttrib	*pbmpcenterv = new PbmpCenterVAttrib();
	Tango::UserDefaultAttrProp	pbmpcenterv_prop;
	//	description	not set for PbmpCenterV
	//	label	not set for PbmpCenterV
	//	unit	not set for PbmpCenterV
	//	standard_unit	not set for PbmpCenterV
	//	display_unit	not set for PbmpCenterV
	//	format	not set for PbmpCenterV
	//	max_value	not set for PbmpCenterV
	//	min_value	not set for PbmpCenterV
	//	max_alarm	not set for PbmpCenterV
	//	min_alarm	not set for PbmpCenterV
	//	max_warning	not set for PbmpCenterV
	//	min_warning	not set for PbmpCenterV
	//	delta_t	not set for PbmpCenterV
	//	delta_val	not set for PbmpCenterV
	
	pbmpcenterv->set_default_properties(pbmpcenterv_prop);
	//	Not Polled
	pbmpcenterv->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(pbmpcenterv);

	//	Attribute : PbmpCenterH
	PbmpCenterHAttrib	*pbmpcenterh = new PbmpCenterHAttrib();
	Tango::UserDefaultAttrProp	pbmpcenterh_prop;
	//	description	not set for PbmpCenterH
	//	label	not set for PbmpCenterH
	//	unit	not set for PbmpCenterH
	//	standard_unit	not set for PbmpCenterH
	//	display_unit	not set for PbmpCenterH
	//	format	not set for PbmpCenterH
	//	max_value	not set for PbmpCenterH
	//	min_value	not set for PbmpCenterH
	//	max_alarm	not set for PbmpCenterH
	//	min_alarm	not set for PbmpCenterH
	//	max_warning	not set for PbmpCenterH
	//	min_warning	not set for PbmpCenterH
	//	delta_t	not set for PbmpCenterH
	//	delta_val	not set for PbmpCenterH
	
	pbmpcenterh->set_default_properties(pbmpcenterh_prop);
	//	Not Polled
	pbmpcenterh->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(pbmpcenterh);

	//	Attribute : GapV
	GapVAttrib	*gapv = new GapVAttrib();
	Tango::UserDefaultAttrProp	gapv_prop;
	//	description	not set for GapV
	//	label	not set for GapV
	//	unit	not set for GapV
	//	standard_unit	not set for GapV
	//	display_unit	not set for GapV
	//	format	not set for GapV
	//	max_value	not set for GapV
	//	min_value	not set for GapV
	//	max_alarm	not set for GapV
	//	min_alarm	not set for GapV
	//	max_warning	not set for GapV
	//	min_warning	not set for GapV
	//	delta_t	not set for GapV
	//	delta_val	not set for GapV
	
	gapv->set_default_properties(gapv_prop);
	//	Not Polled
	gapv->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(gapv);

	//	Attribute : GapH
	GapHAttrib	*gaph = new GapHAttrib();
	Tango::UserDefaultAttrProp	gaph_prop;
	//	description	not set for GapH
	//	label	not set for GapH
	//	unit	not set for GapH
	//	standard_unit	not set for GapH
	//	display_unit	not set for GapH
	//	format	not set for GapH
	//	max_value	not set for GapH
	//	min_value	not set for GapH
	//	max_alarm	not set for GapH
	//	min_alarm	not set for GapH
	//	max_warning	not set for GapH
	//	min_warning	not set for GapH
	//	delta_t	not set for GapH
	//	delta_val	not set for GapH
	
	gaph->set_default_properties(gaph_prop);
	//	Not Polled
	gaph->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(gaph);

	//	Attribute : PbmpAxisOffsetU
	PbmpAxisOffsetUAttrib	*pbmpaxisoffsetu = new PbmpAxisOffsetUAttrib();
	Tango::UserDefaultAttrProp	pbmpaxisoffsetu_prop;
	//	description	not set for PbmpAxisOffsetU
	//	label	not set for PbmpAxisOffsetU
	//	unit	not set for PbmpAxisOffsetU
	//	standard_unit	not set for PbmpAxisOffsetU
	//	display_unit	not set for PbmpAxisOffsetU
	//	format	not set for PbmpAxisOffsetU
	//	max_value	not set for PbmpAxisOffsetU
	//	min_value	not set for PbmpAxisOffsetU
	//	max_alarm	not set for PbmpAxisOffsetU
	//	min_alarm	not set for PbmpAxisOffsetU
	//	max_warning	not set for PbmpAxisOffsetU
	//	min_warning	not set for PbmpAxisOffsetU
	//	delta_t	not set for PbmpAxisOffsetU
	//	delta_val	not set for PbmpAxisOffsetU
	
	pbmpaxisoffsetu->set_default_properties(pbmpaxisoffsetu_prop);
	//	Not Polled
	pbmpaxisoffsetu->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(pbmpaxisoffsetu);

	//	Attribute : PbmpAxisOffsetD
	PbmpAxisOffsetDAttrib	*pbmpaxisoffsetd = new PbmpAxisOffsetDAttrib();
	Tango::UserDefaultAttrProp	pbmpaxisoffsetd_prop;
	//	description	not set for PbmpAxisOffsetD
	//	label	not set for PbmpAxisOffsetD
	//	unit	not set for PbmpAxisOffsetD
	//	standard_unit	not set for PbmpAxisOffsetD
	//	display_unit	not set for PbmpAxisOffsetD
	//	format	not set for PbmpAxisOffsetD
	//	max_value	not set for PbmpAxisOffsetD
	//	min_value	not set for PbmpAxisOffsetD
	//	max_alarm	not set for PbmpAxisOffsetD
	//	min_alarm	not set for PbmpAxisOffsetD
	//	max_warning	not set for PbmpAxisOffsetD
	//	min_warning	not set for PbmpAxisOffsetD
	//	delta_t	not set for PbmpAxisOffsetD
	//	delta_val	not set for PbmpAxisOffsetD
	
	pbmpaxisoffsetd->set_default_properties(pbmpaxisoffsetd_prop);
	//	Not Polled
	pbmpaxisoffsetd->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(pbmpaxisoffsetd);

	//	Attribute : PbmpAxisOffsetL
	PbmpAxisOffsetLAttrib	*pbmpaxisoffsetl = new PbmpAxisOffsetLAttrib();
	Tango::UserDefaultAttrProp	pbmpaxisoffsetl_prop;
	//	description	not set for PbmpAxisOffsetL
	//	label	not set for PbmpAxisOffsetL
	//	unit	not set for PbmpAxisOffsetL
	//	standard_unit	not set for PbmpAxisOffsetL
	//	display_unit	not set for PbmpAxisOffsetL
	//	format	not set for PbmpAxisOffsetL
	//	max_value	not set for PbmpAxisOffsetL
	//	min_value	not set for PbmpAxisOffsetL
	//	max_alarm	not set for PbmpAxisOffsetL
	//	min_alarm	not set for PbmpAxisOffsetL
	//	max_warning	not set for PbmpAxisOffsetL
	//	min_warning	not set for PbmpAxisOffsetL
	//	delta_t	not set for PbmpAxisOffsetL
	//	delta_val	not set for PbmpAxisOffsetL
	
	pbmpaxisoffsetl->set_default_properties(pbmpaxisoffsetl_prop);
	//	Not Polled
	pbmpaxisoffsetl->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(pbmpaxisoffsetl);

	//	Attribute : PbmpAxisOffsetR
	PbmpAxisOffsetRAttrib	*pbmpaxisoffsetr = new PbmpAxisOffsetRAttrib();
	Tango::UserDefaultAttrProp	pbmpaxisoffsetr_prop;
	//	description	not set for PbmpAxisOffsetR
	//	label	not set for PbmpAxisOffsetR
	//	unit	not set for PbmpAxisOffsetR
	//	standard_unit	not set for PbmpAxisOffsetR
	//	display_unit	not set for PbmpAxisOffsetR
	//	format	not set for PbmpAxisOffsetR
	//	max_value	not set for PbmpAxisOffsetR
	//	min_value	not set for PbmpAxisOffsetR
	//	max_alarm	not set for PbmpAxisOffsetR
	//	min_alarm	not set for PbmpAxisOffsetR
	//	max_warning	not set for PbmpAxisOffsetR
	//	min_warning	not set for PbmpAxisOffsetR
	//	delta_t	not set for PbmpAxisOffsetR
	//	delta_val	not set for PbmpAxisOffsetR
	
	pbmpaxisoffsetr->set_default_properties(pbmpaxisoffsetr_prop);
	//	Not Polled
	pbmpaxisoffsetr->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(pbmpaxisoffsetr);

	//	Attribute : PbmpAxisIsInitialised
	PbmpAxisIsInitialisedAttrib	*pbmpaxisisinitialised = new PbmpAxisIsInitialisedAttrib();
	Tango::UserDefaultAttrProp	pbmpaxisisinitialised_prop;
	//	description	not set for PbmpAxisIsInitialised
	//	label	not set for PbmpAxisIsInitialised
	//	unit	not set for PbmpAxisIsInitialised
	//	standard_unit	not set for PbmpAxisIsInitialised
	//	display_unit	not set for PbmpAxisIsInitialised
	//	format	not set for PbmpAxisIsInitialised
	//	max_value	not set for PbmpAxisIsInitialised
	//	min_value	not set for PbmpAxisIsInitialised
	//	max_alarm	not set for PbmpAxisIsInitialised
	//	min_alarm	not set for PbmpAxisIsInitialised
	//	max_warning	not set for PbmpAxisIsInitialised
	//	min_warning	not set for PbmpAxisIsInitialised
	//	delta_t	not set for PbmpAxisIsInitialised
	//	delta_val	not set for PbmpAxisIsInitialised
	
	pbmpaxisisinitialised->set_default_properties(pbmpaxisisinitialised_prop);
	//	Not Polled
	pbmpaxisisinitialised->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(pbmpaxisisinitialised);

	//	Attribute : History
	HistoryAttrib	*history = new HistoryAttrib();
	Tango::UserDefaultAttrProp	history_prop;
	//	description	not set for History
	//	label	not set for History
	//	unit	not set for History
	//	standard_unit	not set for History
	//	display_unit	not set for History
	//	format	not set for History
	//	max_value	not set for History
	//	min_value	not set for History
	//	max_alarm	not set for History
	//	min_alarm	not set for History
	//	max_warning	not set for History
	//	min_warning	not set for History
	//	delta_t	not set for History
	//	delta_val	not set for History
	
	history->set_default_properties(history_prop);
	//	Not Polled
	history->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(history);


	//	Create a list of static attributes
	create_static_attribute_list(get_class_attr()->get_attr_list());
	/*----- PROTECTED REGION ID(PbmpaxisClass::attribute_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	PbmpaxisClass::attribute_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : PbmpaxisClass::pipe_factory()
 *	Description : Create the pipe object(s)
 *                and store them in the pipe list
 */
//--------------------------------------------------------
void PbmpaxisClass::pipe_factory()
{
	/*----- PROTECTED REGION ID(PbmpaxisClass::pipe_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	PbmpaxisClass::pipe_factory_before
	/*----- PROTECTED REGION ID(PbmpaxisClass::pipe_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	PbmpaxisClass::pipe_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : PbmpaxisClass::command_factory()
 *	Description : Create the command object(s)
 *                and store them in the command list
 */
//--------------------------------------------------------
void PbmpaxisClass::command_factory()
{
	/*----- PROTECTED REGION ID(PbmpaxisClass::command_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	PbmpaxisClass::command_factory_before


	//	Command AxisGetMotionStatusU
	AxisGetMotionStatusUClass	*pAxisGetMotionStatusUCmd =
		new AxisGetMotionStatusUClass("AxisGetMotionStatusU",
			Tango::DEV_VOID, Tango::DEV_LONG,
			"",
			"numerical code representing the status of the motion",
			Tango::EXPERT);
	command_list.push_back(pAxisGetMotionStatusUCmd);

	//	Command AxisGetMotionStatusD
	AxisGetMotionStatusDClass	*pAxisGetMotionStatusDCmd =
		new AxisGetMotionStatusDClass("AxisGetMotionStatusD",
			Tango::DEV_VOID, Tango::DEV_LONG,
			"",
			"numerical code representing the status of the motion",
			Tango::EXPERT);
	command_list.push_back(pAxisGetMotionStatusDCmd);

	//	Command AxisGetMotionStatusL
	AxisGetMotionStatusLClass	*pAxisGetMotionStatusLCmd =
		new AxisGetMotionStatusLClass("AxisGetMotionStatusL",
			Tango::DEV_VOID, Tango::DEV_LONG,
			"",
			"numerical code representing the status of the motion",
			Tango::EXPERT);
	command_list.push_back(pAxisGetMotionStatusLCmd);

	//	Command AxisGetMotionStatusR
	AxisGetMotionStatusRClass	*pAxisGetMotionStatusRCmd =
		new AxisGetMotionStatusRClass("AxisGetMotionStatusR",
			Tango::DEV_VOID, Tango::DEV_LONG,
			"",
			"numerical code representing the status of the motion",
			Tango::EXPERT);
	command_list.push_back(pAxisGetMotionStatusRCmd);

	//	Command AxisInitU
	AxisInitUClass	*pAxisInitUCmd =
		new AxisInitUClass("AxisInitU",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pAxisInitUCmd);

	//	Command AxisInitD
	AxisInitDClass	*pAxisInitDCmd =
		new AxisInitDClass("AxisInitD",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pAxisInitDCmd);

	//	Command AxisInitL
	AxisInitLClass	*pAxisInitLCmd =
		new AxisInitLClass("AxisInitL",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pAxisInitLCmd);

	//	Command AxisInitR
	AxisInitRClass	*pAxisInitRCmd =
		new AxisInitRClass("AxisInitR",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pAxisInitRCmd);

	//	Command AxisStopU
	AxisStopUClass	*pAxisStopUCmd =
		new AxisStopUClass("AxisStopU",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pAxisStopUCmd);

	//	Command AxisStopD
	AxisStopDClass	*pAxisStopDCmd =
		new AxisStopDClass("AxisStopD",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pAxisStopDCmd);

	//	Command AxisStopL
	AxisStopLClass	*pAxisStopLCmd =
		new AxisStopLClass("AxisStopL",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pAxisStopLCmd);

	//	Command AxisStopR
	AxisStopRClass	*pAxisStopRCmd =
		new AxisStopRClass("AxisStopR",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pAxisStopRCmd);

	//	Command MotorONU
	MotorONUClass	*pMotorONUCmd =
		new MotorONUClass("MotorONU",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pMotorONUCmd);

	//	Command MotorOND
	MotorONDClass	*pMotorONDCmd =
		new MotorONDClass("MotorOND",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pMotorONDCmd);

	//	Command MotorONL
	MotorONLClass	*pMotorONLCmd =
		new MotorONLClass("MotorONL",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pMotorONLCmd);

	//	Command MotorONR
	MotorONRClass	*pMotorONRCmd =
		new MotorONRClass("MotorONR",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pMotorONRCmd);

	//	Command MotorOFFU
	MotorOFFUClass	*pMotorOFFUCmd =
		new MotorOFFUClass("MotorOFFU",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pMotorOFFUCmd);

	//	Command MotorOFFD
	MotorOFFDClass	*pMotorOFFDCmd =
		new MotorOFFDClass("MotorOFFD",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pMotorOFFDCmd);

	//	Command MotorOFFL
	MotorOFFLClass	*pMotorOFFLCmd =
		new MotorOFFLClass("MotorOFFL",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pMotorOFFLCmd);

	//	Command MotorOFFR
	MotorOFFRClass	*pMotorOFFRCmd =
		new MotorOFFRClass("MotorOFFR",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pMotorOFFRCmd);

	//	Command PbmpAxisDefineOffsetU
	PbmpAxisDefineOffsetUClass	*pPbmpAxisDefineOffsetUCmd =
		new PbmpAxisDefineOffsetUClass("PbmpAxisDefineOffsetU",
			Tango::DEV_DOUBLE, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pPbmpAxisDefineOffsetUCmd);

	//	Command PbmpAxisDefineOffsetD
	PbmpAxisDefineOffsetDClass	*pPbmpAxisDefineOffsetDCmd =
		new PbmpAxisDefineOffsetDClass("PbmpAxisDefineOffsetD",
			Tango::DEV_DOUBLE, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pPbmpAxisDefineOffsetDCmd);

	//	Command PbmpAxisDefineOffsetL
	PbmpAxisDefineOffsetLClass	*pPbmpAxisDefineOffsetLCmd =
		new PbmpAxisDefineOffsetLClass("PbmpAxisDefineOffsetL",
			Tango::DEV_DOUBLE, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pPbmpAxisDefineOffsetLCmd);

	//	Command PbmpAxisDefineOffsetR
	PbmpAxisDefineOffsetRClass	*pPbmpAxisDefineOffsetRCmd =
		new PbmpAxisDefineOffsetRClass("PbmpAxisDefineOffsetR",
			Tango::DEV_DOUBLE, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pPbmpAxisDefineOffsetRCmd);

	//	Command PbmpDefineZeroU
	PbmpDefineZeroUClass	*pPbmpDefineZeroUCmd =
		new PbmpDefineZeroUClass("PbmpDefineZeroU",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pPbmpDefineZeroUCmd);

	//	Command PbmpDefineZeroD
	PbmpDefineZeroDClass	*pPbmpDefineZeroDCmd =
		new PbmpDefineZeroDClass("PbmpDefineZeroD",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pPbmpDefineZeroDCmd);

	//	Command PbmpDefineZeroL
	PbmpDefineZeroLClass	*pPbmpDefineZeroLCmd =
		new PbmpDefineZeroLClass("PbmpDefineZeroL",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pPbmpDefineZeroLCmd);

	//	Command PbmpDefineZeroR
	PbmpDefineZeroRClass	*pPbmpDefineZeroRCmd =
		new PbmpDefineZeroRClass("PbmpDefineZeroR",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pPbmpDefineZeroRCmd);

	//	Command PbmpCenterVGoToPosition
	PbmpCenterVGoToPositionClass	*pPbmpCenterVGoToPositionCmd =
		new PbmpCenterVGoToPositionClass("PbmpCenterVGoToPosition",
			Tango::DEV_DOUBLE, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pPbmpCenterVGoToPositionCmd);

	//	Command PbmpCenterHGoToPosition
	PbmpCenterHGoToPositionClass	*pPbmpCenterHGoToPositionCmd =
		new PbmpCenterHGoToPositionClass("PbmpCenterHGoToPosition",
			Tango::DEV_DOUBLE, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pPbmpCenterHGoToPositionCmd);

	//	Command PbmpGapV
	PbmpGapVClass	*pPbmpGapVCmd =
		new PbmpGapVClass("PbmpGapV",
			Tango::DEV_DOUBLE, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pPbmpGapVCmd);

	//	Command PbmpGapH
	PbmpGapHClass	*pPbmpGapHCmd =
		new PbmpGapHClass("PbmpGapH",
			Tango::DEV_DOUBLE, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pPbmpGapHCmd);

	//	Command PbmpAxisStop
	PbmpAxisStopClass	*pPbmpAxisStopCmd =
		new PbmpAxisStopClass("PbmpAxisStop",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pPbmpAxisStopCmd);

	/*----- PROTECTED REGION ID(PbmpaxisClass::command_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	PbmpaxisClass::command_factory_after
}

//===================================================================
//	Dynamic attributes related methods
//===================================================================

//--------------------------------------------------------
/**
 * method : 		PbmpaxisClass::create_static_attribute_list
 * description : 	Create the a list of static attributes
 *
 * @param	att_list	the ceated attribute list
 */
//--------------------------------------------------------
void PbmpaxisClass::create_static_attribute_list(vector<Tango::Attr *> &att_list)
{
	for (unsigned long i=0 ; i<att_list.size() ; i++)
	{
		string att_name(att_list[i]->get_name());
		transform(att_name.begin(), att_name.end(), att_name.begin(), ::tolower);
		defaultAttList.push_back(att_name);
	}

	cout2 << defaultAttList.size() << " attributes in default list" << endl;

	/*----- PROTECTED REGION ID(PbmpaxisClass::create_static_att_list) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	PbmpaxisClass::create_static_att_list
}


//--------------------------------------------------------
/**
 * method : 		PbmpaxisClass::erase_dynamic_attributes
 * description : 	delete the dynamic attributes if any.
 *
 * @param	devlist_ptr	the device list pointer
 * @param	list of all attributes
 */
//--------------------------------------------------------
void PbmpaxisClass::erase_dynamic_attributes(const Tango::DevVarStringArray *devlist_ptr, vector<Tango::Attr *> &att_list)
{
	Tango::Util *tg = Tango::Util::instance();

	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		Tango::DeviceImpl *dev_impl = tg->get_device_by_name(((string)(*devlist_ptr)[i]).c_str());
		Pbmpaxis *dev = static_cast<Pbmpaxis *> (dev_impl);

		vector<Tango::Attribute *> &dev_att_list = dev->get_device_attr()->get_attribute_list();
		vector<Tango::Attribute *>::iterator ite_att;
		for (ite_att=dev_att_list.begin() ; ite_att != dev_att_list.end() ; ++ite_att)
		{
			string att_name((*ite_att)->get_name_lower());
			if ((att_name == "state") || (att_name == "status"))
				continue;
			vector<string>::iterator ite_str = find(defaultAttList.begin(), defaultAttList.end(), att_name);
			if (ite_str == defaultAttList.end())
			{
				cout2 << att_name << " is a UNWANTED dynamic attribute for device " << (*devlist_ptr)[i] << endl;
				Tango::Attribute &att = dev->get_device_attr()->get_attr_by_name(att_name.c_str());
				dev->remove_attribute(att_list[att.get_attr_idx()], true, false);
				--ite_att;
			}
		}
	}
	/*----- PROTECTED REGION ID(PbmpaxisClass::erase_dynamic_attributes) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	PbmpaxisClass::erase_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Method      : PbmpaxisClass::get_attr_object_by_name()
 *	Description : returns Tango::Attr * object found by name
 */
//--------------------------------------------------------
Tango::Attr *PbmpaxisClass::get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname)
{
	vector<Tango::Attr *>::iterator it;
	for (it=att_list.begin() ; it<att_list.end() ; ++it)
		if ((*it)->get_name()==attname)
			return (*it);
	//	Attr does not exist
	return NULL;
}


/*----- PROTECTED REGION ID(PbmpaxisClass::Additional Methods) ENABLED START -----*/

/*----- PROTECTED REGION END -----*/	//	PbmpaxisClass::Additional Methods
} //	namespace
