/*----- PROTECTED REGION ID(PbmpaxisClass.h) ENABLED START -----*/
//=============================================================================
//
// file :        PbmpaxisClass.h
//
// description : Include for the Pbmpaxis root class.
//               This class is the singleton class for
//                the Pbmpaxis device class.
//               It contains all properties and methods which the 
//               Pbmpaxis requires only once e.g. the commands.
//
// project :     Photon beam monitor position
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef PbmpaxisClass_H
#define PbmpaxisClass_H

#include <tango.h>
#include <Pbmpaxis.h>

/*----- PROTECTED REGION END -----*/	//	PbmpaxisClass.h


namespace Pbmpaxis_ns
{
/*----- PROTECTED REGION ID(PbmpaxisClass::classes for dynamic creation) ENABLED START -----*/


/*----- PROTECTED REGION END -----*/	//	PbmpaxisClass::classes for dynamic creation

//=========================================
//	Define classes for attributes
//=========================================
//	Attribute AxisCurrentPositionU class definition
class AxisCurrentPositionUAttrib: public Tango::Attr
{
public:
	AxisCurrentPositionUAttrib():Attr("AxisCurrentPositionU",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~AxisCurrentPositionUAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Pbmpaxis *>(dev))->read_AxisCurrentPositionU(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Pbmpaxis *>(dev))->write_AxisCurrentPositionU(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Pbmpaxis *>(dev))->is_AxisCurrentPositionU_allowed(ty);}
};

//	Attribute AxisCurrentPositionD class definition
class AxisCurrentPositionDAttrib: public Tango::Attr
{
public:
	AxisCurrentPositionDAttrib():Attr("AxisCurrentPositionD",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~AxisCurrentPositionDAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Pbmpaxis *>(dev))->read_AxisCurrentPositionD(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Pbmpaxis *>(dev))->write_AxisCurrentPositionD(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Pbmpaxis *>(dev))->is_AxisCurrentPositionD_allowed(ty);}
};

//	Attribute AxisCurrentPositionL class definition
class AxisCurrentPositionLAttrib: public Tango::Attr
{
public:
	AxisCurrentPositionLAttrib():Attr("AxisCurrentPositionL",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~AxisCurrentPositionLAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Pbmpaxis *>(dev))->read_AxisCurrentPositionL(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Pbmpaxis *>(dev))->write_AxisCurrentPositionL(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Pbmpaxis *>(dev))->is_AxisCurrentPositionL_allowed(ty);}
};

//	Attribute AxisCurrentPositionR class definition
class AxisCurrentPositionRAttrib: public Tango::Attr
{
public:
	AxisCurrentPositionRAttrib():Attr("AxisCurrentPositionR",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~AxisCurrentPositionRAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Pbmpaxis *>(dev))->read_AxisCurrentPositionR(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Pbmpaxis *>(dev))->write_AxisCurrentPositionR(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Pbmpaxis *>(dev))->is_AxisCurrentPositionR_allowed(ty);}
};

//	Attribute IsInitialisedU class definition
class IsInitialisedUAttrib: public Tango::Attr
{
public:
	IsInitialisedUAttrib():Attr("IsInitialisedU",
			Tango::DEV_SHORT, Tango::READ) {};
	~IsInitialisedUAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Pbmpaxis *>(dev))->read_IsInitialisedU(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Pbmpaxis *>(dev))->is_IsInitialisedU_allowed(ty);}
};

//	Attribute IsInitialisedD class definition
class IsInitialisedDAttrib: public Tango::Attr
{
public:
	IsInitialisedDAttrib():Attr("IsInitialisedD",
			Tango::DEV_SHORT, Tango::READ) {};
	~IsInitialisedDAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Pbmpaxis *>(dev))->read_IsInitialisedD(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Pbmpaxis *>(dev))->is_IsInitialisedD_allowed(ty);}
};

//	Attribute IsInitialisedL class definition
class IsInitialisedLAttrib: public Tango::Attr
{
public:
	IsInitialisedLAttrib():Attr("IsInitialisedL",
			Tango::DEV_SHORT, Tango::READ) {};
	~IsInitialisedLAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Pbmpaxis *>(dev))->read_IsInitialisedL(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Pbmpaxis *>(dev))->is_IsInitialisedL_allowed(ty);}
};

//	Attribute IsInitialisedR class definition
class IsInitialisedRAttrib: public Tango::Attr
{
public:
	IsInitialisedRAttrib():Attr("IsInitialisedR",
			Tango::DEV_SHORT, Tango::READ) {};
	~IsInitialisedRAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Pbmpaxis *>(dev))->read_IsInitialisedR(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Pbmpaxis *>(dev))->is_IsInitialisedR_allowed(ty);}
};

//	Attribute PbmpAxisCurrentPositionU class definition
class PbmpAxisCurrentPositionUAttrib: public Tango::Attr
{
public:
	PbmpAxisCurrentPositionUAttrib():Attr("PbmpAxisCurrentPositionU",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~PbmpAxisCurrentPositionUAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Pbmpaxis *>(dev))->read_PbmpAxisCurrentPositionU(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Pbmpaxis *>(dev))->write_PbmpAxisCurrentPositionU(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Pbmpaxis *>(dev))->is_PbmpAxisCurrentPositionU_allowed(ty);}
};

//	Attribute PbmpAxisCurrentPositionD class definition
class PbmpAxisCurrentPositionDAttrib: public Tango::Attr
{
public:
	PbmpAxisCurrentPositionDAttrib():Attr("PbmpAxisCurrentPositionD",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~PbmpAxisCurrentPositionDAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Pbmpaxis *>(dev))->read_PbmpAxisCurrentPositionD(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Pbmpaxis *>(dev))->write_PbmpAxisCurrentPositionD(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Pbmpaxis *>(dev))->is_PbmpAxisCurrentPositionD_allowed(ty);}
};

//	Attribute PbmpAxisCurrentPositionL class definition
class PbmpAxisCurrentPositionLAttrib: public Tango::Attr
{
public:
	PbmpAxisCurrentPositionLAttrib():Attr("PbmpAxisCurrentPositionL",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~PbmpAxisCurrentPositionLAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Pbmpaxis *>(dev))->read_PbmpAxisCurrentPositionL(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Pbmpaxis *>(dev))->write_PbmpAxisCurrentPositionL(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Pbmpaxis *>(dev))->is_PbmpAxisCurrentPositionL_allowed(ty);}
};

//	Attribute PbmpAxisCurrentPositionR class definition
class PbmpAxisCurrentPositionRAttrib: public Tango::Attr
{
public:
	PbmpAxisCurrentPositionRAttrib():Attr("PbmpAxisCurrentPositionR",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~PbmpAxisCurrentPositionRAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Pbmpaxis *>(dev))->read_PbmpAxisCurrentPositionR(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Pbmpaxis *>(dev))->write_PbmpAxisCurrentPositionR(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Pbmpaxis *>(dev))->is_PbmpAxisCurrentPositionR_allowed(ty);}
};

//	Attribute PbmpCenterV class definition
class PbmpCenterVAttrib: public Tango::Attr
{
public:
	PbmpCenterVAttrib():Attr("PbmpCenterV",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~PbmpCenterVAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Pbmpaxis *>(dev))->read_PbmpCenterV(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Pbmpaxis *>(dev))->write_PbmpCenterV(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Pbmpaxis *>(dev))->is_PbmpCenterV_allowed(ty);}
};

//	Attribute PbmpCenterH class definition
class PbmpCenterHAttrib: public Tango::Attr
{
public:
	PbmpCenterHAttrib():Attr("PbmpCenterH",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~PbmpCenterHAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Pbmpaxis *>(dev))->read_PbmpCenterH(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Pbmpaxis *>(dev))->write_PbmpCenterH(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Pbmpaxis *>(dev))->is_PbmpCenterH_allowed(ty);}
};

//	Attribute GapV class definition
class GapVAttrib: public Tango::Attr
{
public:
	GapVAttrib():Attr("GapV",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~GapVAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Pbmpaxis *>(dev))->read_GapV(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Pbmpaxis *>(dev))->write_GapV(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Pbmpaxis *>(dev))->is_GapV_allowed(ty);}
};

//	Attribute GapH class definition
class GapHAttrib: public Tango::Attr
{
public:
	GapHAttrib():Attr("GapH",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~GapHAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Pbmpaxis *>(dev))->read_GapH(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Pbmpaxis *>(dev))->write_GapH(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Pbmpaxis *>(dev))->is_GapH_allowed(ty);}
};

//	Attribute PbmpAxisOffsetU class definition
class PbmpAxisOffsetUAttrib: public Tango::Attr
{
public:
	PbmpAxisOffsetUAttrib():Attr("PbmpAxisOffsetU",
			Tango::DEV_DOUBLE, Tango::READ) {};
	~PbmpAxisOffsetUAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Pbmpaxis *>(dev))->read_PbmpAxisOffsetU(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Pbmpaxis *>(dev))->is_PbmpAxisOffsetU_allowed(ty);}
};

//	Attribute PbmpAxisOffsetD class definition
class PbmpAxisOffsetDAttrib: public Tango::Attr
{
public:
	PbmpAxisOffsetDAttrib():Attr("PbmpAxisOffsetD",
			Tango::DEV_DOUBLE, Tango::READ) {};
	~PbmpAxisOffsetDAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Pbmpaxis *>(dev))->read_PbmpAxisOffsetD(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Pbmpaxis *>(dev))->is_PbmpAxisOffsetD_allowed(ty);}
};

//	Attribute PbmpAxisOffsetL class definition
class PbmpAxisOffsetLAttrib: public Tango::Attr
{
public:
	PbmpAxisOffsetLAttrib():Attr("PbmpAxisOffsetL",
			Tango::DEV_DOUBLE, Tango::READ) {};
	~PbmpAxisOffsetLAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Pbmpaxis *>(dev))->read_PbmpAxisOffsetL(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Pbmpaxis *>(dev))->is_PbmpAxisOffsetL_allowed(ty);}
};

//	Attribute PbmpAxisOffsetR class definition
class PbmpAxisOffsetRAttrib: public Tango::Attr
{
public:
	PbmpAxisOffsetRAttrib():Attr("PbmpAxisOffsetR",
			Tango::DEV_DOUBLE, Tango::READ) {};
	~PbmpAxisOffsetRAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Pbmpaxis *>(dev))->read_PbmpAxisOffsetR(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Pbmpaxis *>(dev))->is_PbmpAxisOffsetR_allowed(ty);}
};

//	Attribute PbmpAxisIsInitialised class definition
class PbmpAxisIsInitialisedAttrib: public Tango::Attr
{
public:
	PbmpAxisIsInitialisedAttrib():Attr("PbmpAxisIsInitialised",
			Tango::DEV_SHORT, Tango::READ) {};
	~PbmpAxisIsInitialisedAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Pbmpaxis *>(dev))->read_PbmpAxisIsInitialised(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Pbmpaxis *>(dev))->is_PbmpAxisIsInitialised_allowed(ty);}
};

//	Attribute History class definition
class HistoryAttrib: public Tango::SpectrumAttr
{
public:
	HistoryAttrib():SpectrumAttr("History",
			Tango::DEV_STRING, Tango::READ, 2000) {};
	~HistoryAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Pbmpaxis *>(dev))->read_History(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Pbmpaxis *>(dev))->is_History_allowed(ty);}
};


//=========================================
//	Define classes for commands
//=========================================
//	Command AxisGetMotionStatusU class definition
class AxisGetMotionStatusUClass : public Tango::Command
{
public:
	AxisGetMotionStatusUClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	AxisGetMotionStatusUClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~AxisGetMotionStatusUClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Pbmpaxis *>(dev))->is_AxisGetMotionStatusU_allowed(any);}
};

//	Command AxisGetMotionStatusD class definition
class AxisGetMotionStatusDClass : public Tango::Command
{
public:
	AxisGetMotionStatusDClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	AxisGetMotionStatusDClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~AxisGetMotionStatusDClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Pbmpaxis *>(dev))->is_AxisGetMotionStatusD_allowed(any);}
};

//	Command AxisGetMotionStatusL class definition
class AxisGetMotionStatusLClass : public Tango::Command
{
public:
	AxisGetMotionStatusLClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	AxisGetMotionStatusLClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~AxisGetMotionStatusLClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Pbmpaxis *>(dev))->is_AxisGetMotionStatusL_allowed(any);}
};

//	Command AxisGetMotionStatusR class definition
class AxisGetMotionStatusRClass : public Tango::Command
{
public:
	AxisGetMotionStatusRClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	AxisGetMotionStatusRClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~AxisGetMotionStatusRClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Pbmpaxis *>(dev))->is_AxisGetMotionStatusR_allowed(any);}
};

//	Command AxisInitU class definition
class AxisInitUClass : public Tango::Command
{
public:
	AxisInitUClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	AxisInitUClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~AxisInitUClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Pbmpaxis *>(dev))->is_AxisInitU_allowed(any);}
};

//	Command AxisInitD class definition
class AxisInitDClass : public Tango::Command
{
public:
	AxisInitDClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	AxisInitDClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~AxisInitDClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Pbmpaxis *>(dev))->is_AxisInitD_allowed(any);}
};

//	Command AxisInitL class definition
class AxisInitLClass : public Tango::Command
{
public:
	AxisInitLClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	AxisInitLClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~AxisInitLClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Pbmpaxis *>(dev))->is_AxisInitL_allowed(any);}
};

//	Command AxisInitR class definition
class AxisInitRClass : public Tango::Command
{
public:
	AxisInitRClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	AxisInitRClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~AxisInitRClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Pbmpaxis *>(dev))->is_AxisInitR_allowed(any);}
};

//	Command AxisStopU class definition
class AxisStopUClass : public Tango::Command
{
public:
	AxisStopUClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	AxisStopUClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~AxisStopUClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Pbmpaxis *>(dev))->is_AxisStopU_allowed(any);}
};

//	Command AxisStopD class definition
class AxisStopDClass : public Tango::Command
{
public:
	AxisStopDClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	AxisStopDClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~AxisStopDClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Pbmpaxis *>(dev))->is_AxisStopD_allowed(any);}
};

//	Command AxisStopL class definition
class AxisStopLClass : public Tango::Command
{
public:
	AxisStopLClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	AxisStopLClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~AxisStopLClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Pbmpaxis *>(dev))->is_AxisStopL_allowed(any);}
};

//	Command AxisStopR class definition
class AxisStopRClass : public Tango::Command
{
public:
	AxisStopRClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	AxisStopRClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~AxisStopRClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Pbmpaxis *>(dev))->is_AxisStopR_allowed(any);}
};

//	Command MotorONU class definition
class MotorONUClass : public Tango::Command
{
public:
	MotorONUClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	MotorONUClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~MotorONUClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Pbmpaxis *>(dev))->is_MotorONU_allowed(any);}
};

//	Command MotorOND class definition
class MotorONDClass : public Tango::Command
{
public:
	MotorONDClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	MotorONDClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~MotorONDClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Pbmpaxis *>(dev))->is_MotorOND_allowed(any);}
};

//	Command MotorONL class definition
class MotorONLClass : public Tango::Command
{
public:
	MotorONLClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	MotorONLClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~MotorONLClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Pbmpaxis *>(dev))->is_MotorONL_allowed(any);}
};

//	Command MotorONR class definition
class MotorONRClass : public Tango::Command
{
public:
	MotorONRClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	MotorONRClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~MotorONRClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Pbmpaxis *>(dev))->is_MotorONR_allowed(any);}
};

//	Command MotorOFFU class definition
class MotorOFFUClass : public Tango::Command
{
public:
	MotorOFFUClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	MotorOFFUClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~MotorOFFUClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Pbmpaxis *>(dev))->is_MotorOFFU_allowed(any);}
};

//	Command MotorOFFD class definition
class MotorOFFDClass : public Tango::Command
{
public:
	MotorOFFDClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	MotorOFFDClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~MotorOFFDClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Pbmpaxis *>(dev))->is_MotorOFFD_allowed(any);}
};

//	Command MotorOFFL class definition
class MotorOFFLClass : public Tango::Command
{
public:
	MotorOFFLClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	MotorOFFLClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~MotorOFFLClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Pbmpaxis *>(dev))->is_MotorOFFL_allowed(any);}
};

//	Command MotorOFFR class definition
class MotorOFFRClass : public Tango::Command
{
public:
	MotorOFFRClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	MotorOFFRClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~MotorOFFRClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Pbmpaxis *>(dev))->is_MotorOFFR_allowed(any);}
};

//	Command PbmpAxisDefineOffsetU class definition
class PbmpAxisDefineOffsetUClass : public Tango::Command
{
public:
	PbmpAxisDefineOffsetUClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	PbmpAxisDefineOffsetUClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~PbmpAxisDefineOffsetUClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Pbmpaxis *>(dev))->is_PbmpAxisDefineOffsetU_allowed(any);}
};

//	Command PbmpAxisDefineOffsetD class definition
class PbmpAxisDefineOffsetDClass : public Tango::Command
{
public:
	PbmpAxisDefineOffsetDClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	PbmpAxisDefineOffsetDClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~PbmpAxisDefineOffsetDClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Pbmpaxis *>(dev))->is_PbmpAxisDefineOffsetD_allowed(any);}
};

//	Command PbmpAxisDefineOffsetL class definition
class PbmpAxisDefineOffsetLClass : public Tango::Command
{
public:
	PbmpAxisDefineOffsetLClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	PbmpAxisDefineOffsetLClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~PbmpAxisDefineOffsetLClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Pbmpaxis *>(dev))->is_PbmpAxisDefineOffsetL_allowed(any);}
};

//	Command PbmpAxisDefineOffsetR class definition
class PbmpAxisDefineOffsetRClass : public Tango::Command
{
public:
	PbmpAxisDefineOffsetRClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	PbmpAxisDefineOffsetRClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~PbmpAxisDefineOffsetRClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Pbmpaxis *>(dev))->is_PbmpAxisDefineOffsetR_allowed(any);}
};

//	Command PbmpDefineZeroU class definition
class PbmpDefineZeroUClass : public Tango::Command
{
public:
	PbmpDefineZeroUClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	PbmpDefineZeroUClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~PbmpDefineZeroUClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Pbmpaxis *>(dev))->is_PbmpDefineZeroU_allowed(any);}
};

//	Command PbmpDefineZeroD class definition
class PbmpDefineZeroDClass : public Tango::Command
{
public:
	PbmpDefineZeroDClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	PbmpDefineZeroDClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~PbmpDefineZeroDClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Pbmpaxis *>(dev))->is_PbmpDefineZeroD_allowed(any);}
};

//	Command PbmpDefineZeroL class definition
class PbmpDefineZeroLClass : public Tango::Command
{
public:
	PbmpDefineZeroLClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	PbmpDefineZeroLClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~PbmpDefineZeroLClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Pbmpaxis *>(dev))->is_PbmpDefineZeroL_allowed(any);}
};

//	Command PbmpDefineZeroR class definition
class PbmpDefineZeroRClass : public Tango::Command
{
public:
	PbmpDefineZeroRClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	PbmpDefineZeroRClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~PbmpDefineZeroRClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Pbmpaxis *>(dev))->is_PbmpDefineZeroR_allowed(any);}
};

//	Command PbmpCenterVGoToPosition class definition
class PbmpCenterVGoToPositionClass : public Tango::Command
{
public:
	PbmpCenterVGoToPositionClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	PbmpCenterVGoToPositionClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~PbmpCenterVGoToPositionClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Pbmpaxis *>(dev))->is_PbmpCenterVGoToPosition_allowed(any);}
};

//	Command PbmpCenterHGoToPosition class definition
class PbmpCenterHGoToPositionClass : public Tango::Command
{
public:
	PbmpCenterHGoToPositionClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	PbmpCenterHGoToPositionClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~PbmpCenterHGoToPositionClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Pbmpaxis *>(dev))->is_PbmpCenterHGoToPosition_allowed(any);}
};

//	Command PbmpGapV class definition
class PbmpGapVClass : public Tango::Command
{
public:
	PbmpGapVClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	PbmpGapVClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~PbmpGapVClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Pbmpaxis *>(dev))->is_PbmpGapV_allowed(any);}
};

//	Command PbmpGapH class definition
class PbmpGapHClass : public Tango::Command
{
public:
	PbmpGapHClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	PbmpGapHClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~PbmpGapHClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Pbmpaxis *>(dev))->is_PbmpGapH_allowed(any);}
};

//	Command PbmpAxisStop class definition
class PbmpAxisStopClass : public Tango::Command
{
public:
	PbmpAxisStopClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	PbmpAxisStopClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~PbmpAxisStopClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Pbmpaxis *>(dev))->is_PbmpAxisStop_allowed(any);}
};


/**
 *	The PbmpaxisClass singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  PbmpaxisClass : public Tango::DeviceClass
#else
class PbmpaxisClass : public Tango::DeviceClass
#endif
{
	/*----- PROTECTED REGION ID(PbmpaxisClass::Additionnal DServer data members) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	PbmpaxisClass::Additionnal DServer data members

	public:
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
	
		//	Method prototypes
		static PbmpaxisClass *init(const char *);
		static PbmpaxisClass *instance();
		~PbmpaxisClass();
		Tango::DbDatum	get_class_property(string &);
		Tango::DbDatum	get_default_device_property(string &);
		Tango::DbDatum	get_default_class_property(string &);
	
	protected:
		PbmpaxisClass(string &);
		static PbmpaxisClass *_instance;
		void command_factory();
		void attribute_factory(vector<Tango::Attr *> &);
		void pipe_factory();
		void write_class_property();
		void set_default_property();
		void get_class_property();
		string get_cvstag();
		string get_cvsroot();
	
	private:
		void device_factory(const Tango::DevVarStringArray *);
		void create_static_attribute_list(vector<Tango::Attr *> &);
		void erase_dynamic_attributes(const Tango::DevVarStringArray *,vector<Tango::Attr *> &);
		vector<string>	defaultAttList;
		Tango::Attr *get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname);
};

}	//	End of namespace

#endif   //	Pbmpaxis_H
