/*----- PROTECTED REGION ID(PbmpaxisStateMachine.cpp) ENABLED START -----*/
//=============================================================================
//
// file :        PbmpaxisStateMachine.cpp
//
// description : State machine file for the Pbmpaxis class
//
// project :     Photon beam monitor position
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

#include <Pbmpaxis.h>

/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::PbmpaxisStateMachine.cpp

//================================================================
//  States   |  Description
//================================================================
//  OFF      |  
//  STANDBY  |  
//  MOVING   |  
//  FAULT    |  
//  ALARM    |  
//  DISABLE  |  


namespace Pbmpaxis_ns
{
//=================================================
//		Attributes Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_AxisCurrentPositionU_allowed()
 *	Description : Execution allowed for AxisCurrentPositionU attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_AxisCurrentPositionU_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for AxisCurrentPositionU attribute in Write access.
	/*----- PROTECTED REGION ID(Pbmpaxis::AxisCurrentPositionUStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::AxisCurrentPositionUStateAllowed_WRITE

	//	Not any excluded states for AxisCurrentPositionU attribute in read access.
	/*----- PROTECTED REGION ID(Pbmpaxis::AxisCurrentPositionUStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::AxisCurrentPositionUStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_AxisCurrentPositionD_allowed()
 *	Description : Execution allowed for AxisCurrentPositionD attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_AxisCurrentPositionD_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for AxisCurrentPositionD attribute in Write access.
	/*----- PROTECTED REGION ID(Pbmpaxis::AxisCurrentPositionDStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::AxisCurrentPositionDStateAllowed_WRITE

	//	Not any excluded states for AxisCurrentPositionD attribute in read access.
	/*----- PROTECTED REGION ID(Pbmpaxis::AxisCurrentPositionDStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::AxisCurrentPositionDStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_AxisCurrentPositionL_allowed()
 *	Description : Execution allowed for AxisCurrentPositionL attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_AxisCurrentPositionL_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for AxisCurrentPositionL attribute in Write access.
	/*----- PROTECTED REGION ID(Pbmpaxis::AxisCurrentPositionLStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::AxisCurrentPositionLStateAllowed_WRITE

	//	Not any excluded states for AxisCurrentPositionL attribute in read access.
	/*----- PROTECTED REGION ID(Pbmpaxis::AxisCurrentPositionLStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::AxisCurrentPositionLStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_AxisCurrentPositionR_allowed()
 *	Description : Execution allowed for AxisCurrentPositionR attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_AxisCurrentPositionR_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for AxisCurrentPositionR attribute in Write access.
	/*----- PROTECTED REGION ID(Pbmpaxis::AxisCurrentPositionRStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::AxisCurrentPositionRStateAllowed_WRITE

	//	Not any excluded states for AxisCurrentPositionR attribute in read access.
	/*----- PROTECTED REGION ID(Pbmpaxis::AxisCurrentPositionRStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::AxisCurrentPositionRStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_IsInitialisedU_allowed()
 *	Description : Execution allowed for IsInitialisedU attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_IsInitialisedU_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for IsInitialisedU attribute in read access.
	/*----- PROTECTED REGION ID(Pbmpaxis::IsInitialisedUStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::IsInitialisedUStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_IsInitialisedD_allowed()
 *	Description : Execution allowed for IsInitialisedD attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_IsInitialisedD_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for IsInitialisedD attribute in read access.
	/*----- PROTECTED REGION ID(Pbmpaxis::IsInitialisedDStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::IsInitialisedDStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_IsInitialisedL_allowed()
 *	Description : Execution allowed for IsInitialisedL attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_IsInitialisedL_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for IsInitialisedL attribute in read access.
	/*----- PROTECTED REGION ID(Pbmpaxis::IsInitialisedLStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::IsInitialisedLStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_IsInitialisedR_allowed()
 *	Description : Execution allowed for IsInitialisedR attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_IsInitialisedR_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for IsInitialisedR attribute in read access.
	/*----- PROTECTED REGION ID(Pbmpaxis::IsInitialisedRStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::IsInitialisedRStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_PbmpAxisCurrentPositionU_allowed()
 *	Description : Execution allowed for PbmpAxisCurrentPositionU attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_PbmpAxisCurrentPositionU_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for PbmpAxisCurrentPositionU attribute in Write access.
	/*----- PROTECTED REGION ID(Pbmpaxis::PbmpAxisCurrentPositionUStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::PbmpAxisCurrentPositionUStateAllowed_WRITE

	//	Not any excluded states for PbmpAxisCurrentPositionU attribute in read access.
	/*----- PROTECTED REGION ID(Pbmpaxis::PbmpAxisCurrentPositionUStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::PbmpAxisCurrentPositionUStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_PbmpAxisCurrentPositionD_allowed()
 *	Description : Execution allowed for PbmpAxisCurrentPositionD attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_PbmpAxisCurrentPositionD_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for PbmpAxisCurrentPositionD attribute in Write access.
	/*----- PROTECTED REGION ID(Pbmpaxis::PbmpAxisCurrentPositionDStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::PbmpAxisCurrentPositionDStateAllowed_WRITE

	//	Not any excluded states for PbmpAxisCurrentPositionD attribute in read access.
	/*----- PROTECTED REGION ID(Pbmpaxis::PbmpAxisCurrentPositionDStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::PbmpAxisCurrentPositionDStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_PbmpAxisCurrentPositionL_allowed()
 *	Description : Execution allowed for PbmpAxisCurrentPositionL attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_PbmpAxisCurrentPositionL_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for PbmpAxisCurrentPositionL attribute in Write access.
	/*----- PROTECTED REGION ID(Pbmpaxis::PbmpAxisCurrentPositionLStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::PbmpAxisCurrentPositionLStateAllowed_WRITE

	//	Not any excluded states for PbmpAxisCurrentPositionL attribute in read access.
	/*----- PROTECTED REGION ID(Pbmpaxis::PbmpAxisCurrentPositionLStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::PbmpAxisCurrentPositionLStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_PbmpAxisCurrentPositionR_allowed()
 *	Description : Execution allowed for PbmpAxisCurrentPositionR attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_PbmpAxisCurrentPositionR_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for PbmpAxisCurrentPositionR attribute in Write access.
	/*----- PROTECTED REGION ID(Pbmpaxis::PbmpAxisCurrentPositionRStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::PbmpAxisCurrentPositionRStateAllowed_WRITE

	//	Not any excluded states for PbmpAxisCurrentPositionR attribute in read access.
	/*----- PROTECTED REGION ID(Pbmpaxis::PbmpAxisCurrentPositionRStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::PbmpAxisCurrentPositionRStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_PbmpCenterV_allowed()
 *	Description : Execution allowed for PbmpCenterV attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_PbmpCenterV_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for PbmpCenterV attribute in Write access.
	/*----- PROTECTED REGION ID(Pbmpaxis::PbmpCenterVStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::PbmpCenterVStateAllowed_WRITE

	//	Not any excluded states for PbmpCenterV attribute in read access.
	/*----- PROTECTED REGION ID(Pbmpaxis::PbmpCenterVStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::PbmpCenterVStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_PbmpCenterH_allowed()
 *	Description : Execution allowed for PbmpCenterH attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_PbmpCenterH_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for PbmpCenterH attribute in Write access.
	/*----- PROTECTED REGION ID(Pbmpaxis::PbmpCenterHStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::PbmpCenterHStateAllowed_WRITE

	//	Not any excluded states for PbmpCenterH attribute in read access.
	/*----- PROTECTED REGION ID(Pbmpaxis::PbmpCenterHStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::PbmpCenterHStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_GapV_allowed()
 *	Description : Execution allowed for GapV attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_GapV_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for GapV attribute in Write access.
	/*----- PROTECTED REGION ID(Pbmpaxis::GapVStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::GapVStateAllowed_WRITE

	//	Not any excluded states for GapV attribute in read access.
	/*----- PROTECTED REGION ID(Pbmpaxis::GapVStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::GapVStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_GapH_allowed()
 *	Description : Execution allowed for GapH attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_GapH_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for GapH attribute in Write access.
	/*----- PROTECTED REGION ID(Pbmpaxis::GapHStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::GapHStateAllowed_WRITE

	//	Not any excluded states for GapH attribute in read access.
	/*----- PROTECTED REGION ID(Pbmpaxis::GapHStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::GapHStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_PbmpAxisOffsetU_allowed()
 *	Description : Execution allowed for PbmpAxisOffsetU attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_PbmpAxisOffsetU_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for PbmpAxisOffsetU attribute in read access.
	/*----- PROTECTED REGION ID(Pbmpaxis::PbmpAxisOffsetUStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::PbmpAxisOffsetUStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_PbmpAxisOffsetD_allowed()
 *	Description : Execution allowed for PbmpAxisOffsetD attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_PbmpAxisOffsetD_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for PbmpAxisOffsetD attribute in read access.
	/*----- PROTECTED REGION ID(Pbmpaxis::PbmpAxisOffsetDStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::PbmpAxisOffsetDStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_PbmpAxisOffsetL_allowed()
 *	Description : Execution allowed for PbmpAxisOffsetL attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_PbmpAxisOffsetL_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for PbmpAxisOffsetL attribute in read access.
	/*----- PROTECTED REGION ID(Pbmpaxis::PbmpAxisOffsetLStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::PbmpAxisOffsetLStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_PbmpAxisOffsetR_allowed()
 *	Description : Execution allowed for PbmpAxisOffsetR attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_PbmpAxisOffsetR_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for PbmpAxisOffsetR attribute in read access.
	/*----- PROTECTED REGION ID(Pbmpaxis::PbmpAxisOffsetRStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::PbmpAxisOffsetRStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_PbmpAxisIsInitialised_allowed()
 *	Description : Execution allowed for PbmpAxisIsInitialised attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_PbmpAxisIsInitialised_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for PbmpAxisIsInitialised attribute in read access.
	/*----- PROTECTED REGION ID(Pbmpaxis::PbmpAxisIsInitialisedStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::PbmpAxisIsInitialisedStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_History_allowed()
 *	Description : Execution allowed for History attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_History_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for History attribute in read access.
	/*----- PROTECTED REGION ID(Pbmpaxis::HistoryStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::HistoryStateAllowed_READ
	return true;
}


//=================================================
//		Commands Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_AxisGetMotionStatusU_allowed()
 *	Description : Execution allowed for AxisGetMotionStatusU attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_AxisGetMotionStatusU_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for AxisGetMotionStatusU command.
	/*----- PROTECTED REGION ID(Pbmpaxis::AxisGetMotionStatusUStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::AxisGetMotionStatusUStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_AxisGetMotionStatusD_allowed()
 *	Description : Execution allowed for AxisGetMotionStatusD attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_AxisGetMotionStatusD_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for AxisGetMotionStatusD command.
	/*----- PROTECTED REGION ID(Pbmpaxis::AxisGetMotionStatusDStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::AxisGetMotionStatusDStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_AxisGetMotionStatusL_allowed()
 *	Description : Execution allowed for AxisGetMotionStatusL attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_AxisGetMotionStatusL_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for AxisGetMotionStatusL command.
	/*----- PROTECTED REGION ID(Pbmpaxis::AxisGetMotionStatusLStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::AxisGetMotionStatusLStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_AxisGetMotionStatusR_allowed()
 *	Description : Execution allowed for AxisGetMotionStatusR attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_AxisGetMotionStatusR_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for AxisGetMotionStatusR command.
	/*----- PROTECTED REGION ID(Pbmpaxis::AxisGetMotionStatusRStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::AxisGetMotionStatusRStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_AxisInitU_allowed()
 *	Description : Execution allowed for AxisInitU attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_AxisInitU_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for AxisInitU command.
	/*----- PROTECTED REGION ID(Pbmpaxis::AxisInitUStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::AxisInitUStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_AxisInitD_allowed()
 *	Description : Execution allowed for AxisInitD attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_AxisInitD_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for AxisInitD command.
	/*----- PROTECTED REGION ID(Pbmpaxis::AxisInitDStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::AxisInitDStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_AxisInitL_allowed()
 *	Description : Execution allowed for AxisInitL attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_AxisInitL_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for AxisInitL command.
	/*----- PROTECTED REGION ID(Pbmpaxis::AxisInitLStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::AxisInitLStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_AxisInitR_allowed()
 *	Description : Execution allowed for AxisInitR attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_AxisInitR_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for AxisInitR command.
	/*----- PROTECTED REGION ID(Pbmpaxis::AxisInitRStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::AxisInitRStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_AxisStopU_allowed()
 *	Description : Execution allowed for AxisStopU attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_AxisStopU_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for AxisStopU command.
	/*----- PROTECTED REGION ID(Pbmpaxis::AxisStopUStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::AxisStopUStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_AxisStopD_allowed()
 *	Description : Execution allowed for AxisStopD attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_AxisStopD_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for AxisStopD command.
	/*----- PROTECTED REGION ID(Pbmpaxis::AxisStopDStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::AxisStopDStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_AxisStopL_allowed()
 *	Description : Execution allowed for AxisStopL attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_AxisStopL_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for AxisStopL command.
	/*----- PROTECTED REGION ID(Pbmpaxis::AxisStopLStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::AxisStopLStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_AxisStopR_allowed()
 *	Description : Execution allowed for AxisStopR attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_AxisStopR_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for AxisStopR command.
	/*----- PROTECTED REGION ID(Pbmpaxis::AxisStopRStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::AxisStopRStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_MotorONU_allowed()
 *	Description : Execution allowed for MotorONU attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_MotorONU_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for MotorONU command.
	/*----- PROTECTED REGION ID(Pbmpaxis::MotorONUStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::MotorONUStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_MotorOND_allowed()
 *	Description : Execution allowed for MotorOND attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_MotorOND_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for MotorOND command.
	/*----- PROTECTED REGION ID(Pbmpaxis::MotorONDStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::MotorONDStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_MotorONL_allowed()
 *	Description : Execution allowed for MotorONL attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_MotorONL_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for MotorONL command.
	/*----- PROTECTED REGION ID(Pbmpaxis::MotorONLStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::MotorONLStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_MotorONR_allowed()
 *	Description : Execution allowed for MotorONR attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_MotorONR_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for MotorONR command.
	/*----- PROTECTED REGION ID(Pbmpaxis::MotorONRStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::MotorONRStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_MotorOFFU_allowed()
 *	Description : Execution allowed for MotorOFFU attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_MotorOFFU_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for MotorOFFU command.
	/*----- PROTECTED REGION ID(Pbmpaxis::MotorOFFUStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::MotorOFFUStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_MotorOFFD_allowed()
 *	Description : Execution allowed for MotorOFFD attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_MotorOFFD_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for MotorOFFD command.
	/*----- PROTECTED REGION ID(Pbmpaxis::MotorOFFDStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::MotorOFFDStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_MotorOFFL_allowed()
 *	Description : Execution allowed for MotorOFFL attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_MotorOFFL_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for MotorOFFL command.
	/*----- PROTECTED REGION ID(Pbmpaxis::MotorOFFLStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::MotorOFFLStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_MotorOFFR_allowed()
 *	Description : Execution allowed for MotorOFFR attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_MotorOFFR_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for MotorOFFR command.
	/*----- PROTECTED REGION ID(Pbmpaxis::MotorOFFRStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::MotorOFFRStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_PbmpAxisDefineOffsetU_allowed()
 *	Description : Execution allowed for PbmpAxisDefineOffsetU attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_PbmpAxisDefineOffsetU_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for PbmpAxisDefineOffsetU command.
	/*----- PROTECTED REGION ID(Pbmpaxis::PbmpAxisDefineOffsetUStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::PbmpAxisDefineOffsetUStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_PbmpAxisDefineOffsetD_allowed()
 *	Description : Execution allowed for PbmpAxisDefineOffsetD attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_PbmpAxisDefineOffsetD_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for PbmpAxisDefineOffsetD command.
	/*----- PROTECTED REGION ID(Pbmpaxis::PbmpAxisDefineOffsetDStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::PbmpAxisDefineOffsetDStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_PbmpAxisDefineOffsetL_allowed()
 *	Description : Execution allowed for PbmpAxisDefineOffsetL attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_PbmpAxisDefineOffsetL_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for PbmpAxisDefineOffsetL command.
	/*----- PROTECTED REGION ID(Pbmpaxis::PbmpAxisDefineOffsetLStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::PbmpAxisDefineOffsetLStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_PbmpAxisDefineOffsetR_allowed()
 *	Description : Execution allowed for PbmpAxisDefineOffsetR attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_PbmpAxisDefineOffsetR_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for PbmpAxisDefineOffsetR command.
	/*----- PROTECTED REGION ID(Pbmpaxis::PbmpAxisDefineOffsetRStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::PbmpAxisDefineOffsetRStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_PbmpDefineZeroU_allowed()
 *	Description : Execution allowed for PbmpDefineZeroU attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_PbmpDefineZeroU_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for PbmpDefineZeroU command.
	/*----- PROTECTED REGION ID(Pbmpaxis::PbmpDefineZeroUStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::PbmpDefineZeroUStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_PbmpDefineZeroD_allowed()
 *	Description : Execution allowed for PbmpDefineZeroD attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_PbmpDefineZeroD_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for PbmpDefineZeroD command.
	/*----- PROTECTED REGION ID(Pbmpaxis::PbmpDefineZeroDStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::PbmpDefineZeroDStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_PbmpDefineZeroL_allowed()
 *	Description : Execution allowed for PbmpDefineZeroL attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_PbmpDefineZeroL_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for PbmpDefineZeroL command.
	/*----- PROTECTED REGION ID(Pbmpaxis::PbmpDefineZeroLStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::PbmpDefineZeroLStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_PbmpDefineZeroR_allowed()
 *	Description : Execution allowed for PbmpDefineZeroR attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_PbmpDefineZeroR_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for PbmpDefineZeroR command.
	/*----- PROTECTED REGION ID(Pbmpaxis::PbmpDefineZeroRStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::PbmpDefineZeroRStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_PbmpCenterVGoToPosition_allowed()
 *	Description : Execution allowed for PbmpCenterVGoToPosition attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_PbmpCenterVGoToPosition_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for PbmpCenterVGoToPosition command.
	/*----- PROTECTED REGION ID(Pbmpaxis::PbmpCenterVGoToPositionStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::PbmpCenterVGoToPositionStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_PbmpCenterHGoToPosition_allowed()
 *	Description : Execution allowed for PbmpCenterHGoToPosition attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_PbmpCenterHGoToPosition_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for PbmpCenterHGoToPosition command.
	/*----- PROTECTED REGION ID(Pbmpaxis::PbmpCenterHGoToPositionStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::PbmpCenterHGoToPositionStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_PbmpGapV_allowed()
 *	Description : Execution allowed for PbmpGapV attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_PbmpGapV_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for PbmpGapV command.
	/*----- PROTECTED REGION ID(Pbmpaxis::PbmpGapVStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::PbmpGapVStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_PbmpGapH_allowed()
 *	Description : Execution allowed for PbmpGapH attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_PbmpGapH_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for PbmpGapH command.
	/*----- PROTECTED REGION ID(Pbmpaxis::PbmpGapHStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::PbmpGapHStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pbmpaxis::is_PbmpAxisStop_allowed()
 *	Description : Execution allowed for PbmpAxisStop attribute
 */
//--------------------------------------------------------
bool Pbmpaxis::is_PbmpAxisStop_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for PbmpAxisStop command.
	/*----- PROTECTED REGION ID(Pbmpaxis::PbmpAxisStopStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::PbmpAxisStopStateAllowed
	return true;
}


/*----- PROTECTED REGION ID(Pbmpaxis::PbmpaxisStateAllowed.AdditionalMethods) ENABLED START -----*/

//	Additional Methods

/*----- PROTECTED REGION END -----*/	//	Pbmpaxis::PbmpaxisStateAllowed.AdditionalMethods

}	//	End of namespace
